<?php

/**
 * Option param
 */
class OPTION_PARAM
{
	public $id;
	public $parent_id;
	public $level;

	public function __construct($id, $parent_id, $level)
	{
		$this->id = $id;
		$this->parent_id = $parent_id;
		$this->level = $level;
	}
}

/**
 * Option node
 */
class OPTION_NODE extends DB_TREE_NODE
{
	public $taxCode = '';
	public $taxDescription = '';

	public function drawNode($param)
	{
		if ($this->id != $param->id)
		{
			if ($this->id != TREE_ROOT)
			{
				echo str_repeat("\t", $param->level)."<li class=\"closed\">\n";
				echo str_repeat("\t", $param->level+1)."<a class=\"avalara_category ".(count($this->nodes) > 0 ? 'parent': '').'" href="javascript:selectAvalaraCode(\''.htmlspecialchars($this->taxCode).'\', \''.htmlspecialchars($this->taxDescription).'\')">'.htmlspecialchars($this->caption)."</a>\n";

				if (count($this->nodes) > 0)
				{
					echo str_repeat("\t", $param->level+1)."<ul style=\"display:none;\">\n";

					foreach ($this->nodes as $id => $node)
					{
						$node->drawNode(new OPTION_PARAM($param->id, $param->parent_id, $param->level+1));
					}
					echo str_repeat("\t", $param->level+1)."</ul>\n";
				}

				echo str_repeat("\t", $param->level)."</li>\n";
			}
			else
			{
				if (count($this->nodes) > 0)
				{
					foreach ($this->nodes as $id => $node)
					{
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}
}

$tree = new DB_TREE();
$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));

$db->query('SELECT * FROM '.DB_PREFIX.'avalara_tax_codes_categories ORDER BY level, description');
while ($db->moveNext())
{
	$node = new OPTION_NODE(
		$db->col['id'],
		intval($db->col['parent']),
		$db->col['level'],
		1,
		$db->col['description'] == '' ? $db->col['tax_code'] : $db->col['description']
	);

	$node->taxCode = $db->col['tax_code'];
	$node->taxDescription = empty($db->col['description']) ? $db->col['tax_code'] : $db->col['description'];

	$tree->addNode($node);
}
?>
<div>
	<div>
		<ul class="tree">
<?php
			$cid = -1;
			$parent = TREE_ROOT;
			$tree->collection[TREE_ROOT]->drawNode(new OPTION_PARAM($cid, $parent, 0));
?>
		</ul>
	</div>
	<div style="clear:both;"></div>
</div>
