<?php
/**
 * Bulk categories uploader
 */

	if (!defined("ENV")) exit();
	
	///////////////////////////////////////////
	// inherit basic node & override drawNode
	class OPTION_PARAM
	{
		var $id;
		var $parent_id;
		var $level;
		var $key;
		function OPTION_PARAM($id, $parent_id, $level, $key)
		{
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			$this->key = $key;
			return $this;
		}
	}
	
	$is_selected_cat = false;
	
	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param)
		{
			global $is_selected_cat;
			if ($this->id!=$param->id)
			{
				if ($this->id != TREE_ROOT)
				{
					echo '<option value="'.$this->id.'" '.($is_selected_cat==false?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					$is_selected_cat = true;
				}
				for ($i=0; $i<($param->level-1)*4; $i++) echo "&nbsp;";			
				echo htmlspecialchars($this->caption).'</option>';
				if (count($this->nodes)>0)
				{
					foreach ($this->nodes as $id => $node)
					{
						$node->drawNode(new OPTION_PARAM($param->id, $param->parent_id, $param->level+1, $param->key));
					}
				}
			}
		}
	}

	//load categories
	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Please Select a Category"));
	
	$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE key_name <> 'gift_cert' ORDER BY level, priority, name");
	while (($category = $db->moveNext()) != false)
	{
		$tree->addNode(new OPTION_NODE($category["cid"], $category["parent"], $category["level"], $category["is_visible"], $category["name"]));
	}
	
	// set fields for uploading
	//0 - caption
	//1 - default value
	//2 - required
	//3 - boolean
	$fields_names = array();
	$fields_names["skip"] = array("Skip", "", false, false);
	$fields_names["key_name"] = array("Category key", "", true, false, array("code", "key", "id", "categorykey"));
	$fields_names["name"] = array("Name", "", true, false, array("categorytitle", "title", "categoryname", "name"));
	$fields_names["parent"] = array("Parent category key", "", false, false, array("parent", "parentid", "parentkey", "parentcode"));
	$fields_names["is_visible"] = array("Is visible", "Yes", false, true, array("visible", "isvisible", "active", "isactive4"));
	$fields_names["list_subcats"] = array("List subcategories", "No", false, true, array("list", "subcats", "subcategories", "listsubcategories", "listsubcats"));
	$fields_names["priority"] = array("Sorting priority", "0", false, false, array("categorypriority", "priority", "sortorder"));
	$fields_names["meta_keywords"] = array("Meta keywords", "", false, false, array("metakeyword", "metakeywords", "keyword", "keywords"));
	$fields_names["meta_title"] = array("Meta title", "", false, false, array("metatitle"));
	$fields_names["meta_description"] = array("Meta description", "", false, false, array("metadescription"));
	$fields_names["url_custom"] = array("Custom URL", "", false, false, array("url", "customurl", "urlcustom"));
	$fields_names["category_header"] = array("Category header", "", false, false, array("header", "categoryheader"));
	$fields_names["description"] = array("Category description top", "", false, false, array("description", "descriptiontop", "topdescription"));
	$fields_names["description_bottom"] = array("Category description bottom", "", false, false, array("descriptionbottom", "bottomdescription"));
	$taxService = Tax_ProviderFactory::getTaxService();
	if ($taxService instanceof Tax_Avalara_AvalaraService)
	{
		$fields_names['avalara_tax_code'] = array('Avalara Tax Code', '', false, false, array('avalarataxcode'));
	}
	else if ($taxService instanceof Tax_Exactor_ExactorService)
	{
		$fields_names['exactor_euc_code'] = array('Exactor EUC Code', '', false, false, array('exactoreuccode'));
	}
	$bool_true = array("true", "yes", "1", "ok", "on");
	$bool_false = array("false", "no", "0", "not", "off");
	