<?php
/**
 * Bulk products uploader
 */

	set_time_limit(100000);

	if (!defined("ENV")) exit();
	
	///////////////////////////////////////////
	// inherit basic node & override drawNode
	class OPTION_PARAM{
		var $id;
		var $parent_id;
		var $level;
		function OPTION_PARAM($id, $parent_id, $level){
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}
	
	$is_selected_cat = false;
	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param){
			global $is_selected_cat;
			if($this->id!=$param->id){
				if($this->id != TREE_ROOT){
					//echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					echo '<option value="'.$this->id.'" '.($is_selected_cat==false?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					$is_selected_cat = true;
				}
				for($i=0; $i<($param->level-1)*4; $i++){
					echo "&nbsp;";
				}
				echo gs($this->caption).'</option>';
				if(count($this->nodes)>0){
					foreach ($this->nodes as $id => $node)
					{
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}

	//load categories
	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Please Select a Category"));
	
	$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE key_name <> 'gift_cert' ORDER BY level, priority, name");
	while (($category = $db->moveNext()) != false)
	{
		$tree->addNode(
			new OPTION_NODE(
				$category["cid"], 
				$category["parent"], 
				$category["level"], 
				$category["is_visible"],
				$category["name"]
			)
		);
	}
	
	// set fields for uploading
	//0 - caption
	//1 - default value
	//2 - required
	//3 - boolean
	//4 - array - lowercase with spaces removed strings to match headers
	//5 - comma separated string - is this used?
	$fields_names = array();
		
	
	$fields_names["skip"] = array("Skip", "", false, false, array(), "");
	
	$fields_names["product_id"] = array("Product ID", "", true, false, array("productid", "id"), "Product ID, ID");
	$fields_names["is_visible"] = array("Available", "Yes", false, true, array("available", "visible", "isavailable", "isvisible", "isactive"), "Available, Visible, Active, Is available, Is visible, Is active");
	$fields_names["product_sku"] = array("Product SKU", "", false, false, array("productsku", "sku"), "Product SKU, SKU");
	$fields_names["product_upc"] = array("UPC code", "", false, false, array("upc", "productupc", "upccode"), "UPC, Product UPC, UPC code");
	$fields_names["product_gtin"] = array("GTIN", "", false, false, array("gtin", "globaltradeitemnumber"), "GTIN, Global Trade Item Number");
	$fields_names["product_mpn"] = array("MPN", "", false, false, array("mpn", "manufacturerpartnumber"), "MPN, Manufacturer Part Number");
	$fields_names["title"] = array("Name", "", true, false, array("producttitle", "title", "productname", "name"), "Product title, Title, Product name, Name");
	$fields_names["price"] = array("Price", "", true, false, array("productprice", "price", "itemprice"), "Product price, Price, Item price");
	
	$fields_names["cost"] = array("Cost", "0.00", false, false, array("productcost", "cost", "itemcost"), "Product Cost, Cost, Item cost");
	
	$fields_names["category"] = array("Categories", "", false, false, array("category", "categorykey", "categorykeys", "categories"), "Category, Category key, Category keys, Categories");
	$fields_names["manufacturer"] = array("Manufacturer ID", "0", false, false, array("manufacturer", "manufacturerid", "manufacturerkey", "manufacturercode"), "Manufacturer, Manufacturer ID, Manufacturer key, Manufacturer code");
	$fields_names["location"] = array("Location code", "0", false, false, array("location", "productlocation", "itemlocation", "locationcode"), "Location, Product location, Item location, Location code, Location ID, Location key");
		
	$fields_names["is_locked"] = array("Is locked", "", false, false, array("locked", "lock", "is_locked", "productlocked", 'lockproduct'), "Locked, Lock, Is locked, Product locked");
	$fields_names["lock_fields"] = array("Lock fields", "", false, false, array("locks", "lockfields", "readonly"), "Locks, Lock fields, Read only");
	
	$fields_names["meta_keywords"] = array("Meta keywords", "", false, false, array("metakeyword", "metakeywords", "keyword", "keywords"), "Meta keyword, Meta keywords, Keyword, Keywords");
	$fields_names["meta_title"] = array("Meta title", "", false, false, array("metatitle"), "Meta title");
	$fields_names["meta_description"] = array("Meta description", "", false, false, array("metadescription"), "Meta description");

	$fields_names["url_custom"] = array("Custom Product URL", "", false, false, array("producturl", "customurl", "url", "seourl", "urlcustom", 'customproducturl'), "Custom URL");

	$fields_names["priority"] = array("Sorting priority", "0", false, false, array("productpriority", "priority", "sortorder"), "Product priority, Priority, Sort order");
		
	$fields_names["call_for_price"] = array("Call for price", "No", false, true, array("call", "callforprice"), "Call, Call for price");
	
	$fields_names["is_taxable"] = array("Is taxable", "Yes", false, true, array("istaxable", "taxable"), "Is taxable, Taxable");
	
	$fields_names["tax_class_id"] = array("Tax class key", "0", false, false, array("taxclass", "taxclassid", "taxclasskey"), "Tax class, Tax class id, Tax class key");
	$fields_names["tax_rate"] = array("Tax rate - Product Level", "-1.00000", false, false, array("taxrate", 'taxrateonproductlevel'), "Tax rate, Tax rate on product level");

	$fields_names['avalara_tax_code'] = array('Avalara tax code', '', false, false, array('avalarataxcode'), 'Avalara tax code');
	$fields_names['exactor_euc_code'] = array('Exactor EUC Code', '', false, false, array('exactoreuccode'), 'Exactor EUC Code');

	$fields_names["price2"] = array("Sale price", "", false, false, array("saleprice", "sale"), "Sale Price, Sale");
		
	$fields_names["price_level_1"] = array("Price level 1", "0.00", false, false, array("pricelevel1"), "Price Level 1");
	$fields_names["price_level_2"] = array("Price level 2", "0.00", false, false, array("pricelevel2"), "Price Level 2");
	$fields_names["price_level_3"] = array("Price level 3", "0.00", false, false, array("pricelevel3"), "Price Level 3");
		
	//$fields_names["shipping_price"] = array("Shipping Price", "0.00", false, false);
	$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE carrier_id='custom' AND method_id='product_level'");
	while (($shipping_selected = $db->moveNext()) != false)
	{
		$n = "Shipping Price - ".$shipping_selected["carrier_name"];
		$s = strtolower(preg_replace("/[^A-Za-z0-9]/", "", $n ));
		$fields_names["shipping_price_".$shipping_selected["ssid"]] = array($n, "0.00", false, false, array($s), $n);
	}
		
	$fields_names["free_shipping"] = array("Free shipping", "No", false, true, array("freeshipping", "shippingisfree"), "Free shipping, Shipping is free");
	$fields_names["weight"] = array("Unit weight", "0", false, false, array("weight", "productweight", "itemweight"), "Weight, Product weight, Item weight");
		
	$fields_names["inter_pack"] = array("Inter pack", "0", false, false, array("interpack", "inter"), "Inter pack, Inter");
	$fields_names["case_pack"] = array("Case pack", "0", false, false, array("casepack", "case"), "Case pack, Case");
		
	$fields_names["min_order"] = array("Min order", "1", false, false, array("minorder", "min"), "Min order, Min");
	$fields_names["max_order"] = array("Max order", "0", false, false, array("maxorder", "max"), "Max order, Max");
		
	$fields_names["is_home"] = array("On home page", "No", false, true, array("ishome", "onhomepage", "showonhomepage"), "Is home, On home page, Show on home page");
	$fields_names["is_hotdeal"] = array("Is hotdeal", "No", false, true, array("ishotdeal", "hotdeal"), "Is hotdeal, Hotdeal");
	$fields_names["is_dollar_days"] = array("DollarDays Product", "No", false, true, array("dollardays", "isdollardays", "dollardaysproduct", "isdollardaysproduct"), "Dollar Days, Is Dollar Days, Dollar Days product, Is Dollar Days product");
	$fields_names["is_doba"] = array("Doba product", "No", false, true, array("doba", "isdoba", "dobaproduct", "isdobaproduct"), "Doba, Is Doba, Doba product, Is Doba product");
		
	$fields_names["digital_product"] = array("Is digital product", "No", false, true, array("digital", "isdigital", "digitalproduct", "downloadable"), "Digital, Is digital, Digital Product, Downloadable");
	$fields_names["digital_product_file"] = array("Digital product file", "", false, false, array("digitalproductfile", "digitalfile", "digitalfilename", "downloadfile", "downloadfilename"), "Digital product file, Digital file, Digital file name, Ddownload file, Download file name");
		
	if (AccessManager::checkAccess('INVENTORY'))
	{
		$fields_names["inventory_control"] = array("Track inventory", "No", false, true, array("inventorycontrol", "trackinventory"), "Track inventory, Inventory control");
		$fields_names["stock"] = array("Stock", "0", false, false, array("stock", "itemsinstock"), "Stock, Items in stock");
		$fields_names["stock_warning"] = array("Stock warning", "0", false, false, array("minstock", "stockwarning"), "Min. stock, Stock warning");
		$fields_names["inventory_rule"] = array("Inventory rule", "Hide", false, false, array("inventoryrule"), "Inventory rule"); //'Hide', 'OutOfStock'
	}
	
	$fields_names["overview"] = array("Overview", "", false, false, array("productoverview", "overview", "shortdescription"), "Product overview, Overview, Short description");
	$fields_names["description"] = array("Description", "", false, false, array("productdescription", "description"), "Product description, Description");
		
	$fields_names["image_url"] = array("Image URL", "", false, false, array("imageurl"), "Image URL");
	$fields_names["zoom_option"] = array("Image zooming option", "global", false, false, array("imagezoomingoption", "zoomoption", "imagezooming", "zoomingtype"), "Image zooming option, Zoom option, Image zooming, Zooming type");
	$fields_names["image_alt_text"] = array("Image alt text", "", false, false, array("imagealttext", "imagetext"), "Image alt text, image text");
	
	$fields_names["product_sub_id"] = array("Product Sub ID", "", false, false, array("product sub id", "productsubid", 'subid'), "");
	if (AccessManager::checkAccess('INVENTORY'))
	{
		$fields_names["product_sub_id_stock"] = array("Items in stock on attr. level", "", false, false, array("itemsinstockonattrlevel", 'stockonattributelevel'), "");
	}
	$fields_names['product_sub_options'] = array('Sub Product Attributes', '', false, false, array('subproductattributes'), '');
	
	$fields_names['google_item_condition'] = array('Google Base Item Condition', 'new', false, false, array('googlebaseitemcondition'), 'Google Base Item Condition');
	$fields_names['google_product_type'] = array('Google Base Product Category', '', false, false, array('googlebaseproductcategory'), 'Google Base Product Category');
	$fields_names['google_availability'] = array('Google Base Availability', 'inventory_control', false, false, array('googlebaseavailability'), 'Google Base Availability');
	$fields_names['google_online_only'] = array('Google Base Online Only', 'n', false, false, array('googlebaseonlineonly'), 'Google Base Online Only');
	$fields_names['google_gender'] = array('Google Base Gender', '', false, false, array('googlebasegender'), 'Google Base Gender');
	$fields_names['google_age_group'] = array('Google Base Age Group', '', false, false, array('googlebaseagegroup'), 'Google Base Age Group');
	$fields_names['google_color'] = array('Google Base Color', '', false, false, array('googlebasecolor'), 'Google Base Color');
	$fields_names['google_size'] = array('Google Base Size', '', false, false, array('googlebasesize'), 'Google Base Size');
	$fields_names['google_material'] = array('Google Base Material', '', false, false, array('googlebasematerial'), 'Google Base Material');
	$fields_names['google_pattern'] = array('Google Base Pattern', '', false, false, array('googlebasepattern'), 'Google Base Pattern');
	
	$attributes_count = 10;
	$attribute_fields = array();
	
	for ($i = 1; $i <= 10; $i++)
	{	
		$fields_names["attribute_type_".$i] = array("Attribute type ".$i, "", false, false, array("attributetype".$i), "Attribute Type ".$i);
		$fields_names["attribute_name_".$i] = array("Attribute name ".$i, "", false, false, array("attributename".$i), "Attribute Name ".$i);
		$fields_names["attribute_caption_".$i] = array("Attribute caption ".$i, "", false, false, array("attributecaption".$i), "Attribute Caption ".$i);
		$fields_names["attribute_options_".$i] = array("Attribute options ".$i, "", false, false, array("attributeoptions".$i), "Attribute Options ".$i);
		$fields_names["attribute_priority_".$i] = array("Attribute priority ".$i, "", false, false, array("attributepriority".$i), "Attribute Priority ".$i);
		$fields_names['attribute_track_'.$i] = array('Attribute track inventory '.$i, '', false, false, array('attributetrackinventory'.$i), 'Attribute Track Inventory '.$i);

		$attribute_fields[] = "attribute_type_".$i;
		$attribute_fields[] = "attribute_name_".$i;
		$attribute_fields[] = "attribute_caption_".$i;
		$attribute_fields[] = "attribute_options_".$i;
		$attribute_fields[] = "attribute_priority_".$i;
		$attribute_fields[] = 'attribute_track_'.$i;
	}
	
	////////////////////////////////////////////
	$bool_true = array("true", "yes", "1", "ok", "on");
	$bool_false = array("false", "no", "0", "not", "off");
	
?>