<?php
/**
 * Charts
 */

	if (!defined("ENV")) exit();

	/**
	 * Do not cache output
	 */
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Cache-Control: no-store, no-cache, max-age=0, must-revalidate, post-check=0, pre-check=0");
	header("Pragma: no-cache");

	$repo = DataAccess_Repository::get('ChartRepository');
	$year  = isset($year)  ? intval($year)  : date('Y');
	$month = isset($month) ? intval($month) : date('m');

	switch($mode)
	{
		/**
		 * Usage statistics by month (hits)
		 */
		default:
		case "usage_by_month_hits" :
		{
			$chart = $repo->getUsageHitsByMonth($month, $year);
			break;
		}

		/**
		 * Usage statistics by month (unique hosts)
		 */
		case "usage_by_month_hosts" : 
		{
			$chart = $repo->getUsageHostsByMonth($month, $year);
			break;
		}

		/**
		 * Sales statistics by month
		 */
		case "sales_by_month" :
		{
			$chart = $repo->getSalesByMonth($month, $year);
			break;
		}
	}

	print $chart->asFlot();