<?php
	if (!defined("ENV")) exit();
	
	$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."users WHERE newsletters='Yes' AND removed='No'");
	$db->moveNext(); $c = $db->col["c"];
	
	$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."emails WHERE newsletters='Yes'");
	$db->moveNext(); $c = $c + $db->col["c"];
	
	if ($c >= 1001)
	{
		pageHeader("Newsletter Email Wizard", "", "icb-wizard");
		pageNote(array(
			array("class"=>"ic-info", "text"=>
			"You currently have over 1001 email addresses assigned to receive your newsletter. This exceeds the number of emails that can be sent out using this system.<br/><br/>". 
			"We suggest you export your email address to our partner, Mail Chimp or use another third-party email system to manage your newsletters.<br/><br/>".
			"Our integration with MailChimp will automatically sync your users email addresses to your MailChimp account making newsletter management a breeze.<br/><br/>". 
			"<img src=\"images/admin/mailchimp_sm.png\"/><br/><br/>".
			"To learn more about MailChimp, <a target=\"_blank\" href=\"http://eepurl.com/L3JD\">click here</a>.<br/><br/>".
			"If you'd like to export your email addresses to import to another program, <a href=\"admin.php?p=emails_import\">click here</a>.", 
			"url"=>"", "visible"=>true),
		));
	}
	else
	{
		$mode = isset($mode)?trim($mode):"insert";
		$eid = isset($eid)?$eid*1:0;
		
		$from_y = isset($from_y)?$from_y:date("Y");
		$from_m = isset($from_m)?$from_m:date("n");
		$from_d = isset($from_d)?$from_d:1;
		$to_y = isset($to_y)?$to_y:date("Y");
		$to_m = isset($to_m)?$to_m:date("n");
		$to_d = isset($to_d)?$to_d:date("t", mktime(1,1,1,$to_m, 1, $to_y));
			
		$email_view = empty($email_view)?"text":$email_view;
			
		$step = isset($step)?$step*1:1;
		$step = in_array($step, array(1,2,3,4))?$step:1;
		
		$hint_texts = 
			array(
				"1"=> 
					"Select a date range for your products and click the \"Generate Email\" button.<br>".
					"You can adjust the email on the next step.<br>".
					"Please note: To avoid server overloading issues, the system will only allow 150 products to be generated.",
				"2"=> 
					"On this page you may edit generated HTML and TEXT for product update email.<br>".
					"To preview email and then send it to subscribers click over \"Preview email\" button.<br>".
					"If you would like to change date range, click over \"Change dates\" button.",
				"3"=> 
					"Please review email as it will be visible for subscribers in HTML and TEXT modes.<br>".
					"To back to this email editing click over \"Edit email\" button.<br>".
					"If you would like to send it right now, click over \"Send email\" button."
			);
		
		pageHeader("Product Update Email Wizard", "step ".gs($step)." of 4", "icb-wizard");
		
		if (DEMO_LOCK)
		{
			pageNote(array(
				array("class"=>"ic-info", "text"=>"This feature is not available in Demo Mode", "url"=>"", "visible"=>true),
			));
		}
		else
		{
			if ($step < 4)
			{
				pageNote(array(
					array("class"=>"ic-info", "text"=>$hint_texts[$step], "url"=>"", "visible"=>true)
				));
			}
			loadJS("cf_email.js");
			
			if ($step < 4)
			{
?>
	<div class="admin-tabs admin-tabs-framed" id="tabs-updates">
<?php 
				pageTabs(array(
					array("title"=>"Updates Email", "id"=>"main"),
				), "tabs-updates", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
<?php
			}
			
			switch ($step)
			{
				/**
				 * Prepare email
				 */
				case 1 : 
				{
?>
				<form name="frmEmail" action="admin.php?p=email_updates&step=2" method="post" onSubmit="return checkUpdatesForm(this);">
					<div class="admin-form-header first"><span class="icon ic-icon ic-calendar-month"></span>Select Product Updates Date Range</div>
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
						<tr valign="top">
							<td class="formItemCaption">From</td>
							<td class="formItemControl">
								<select name="from_m" class="date-month">
<?php
					for ($i=1; $i<=12; $i++)
					{
?>
									<option value="<?=$i?>" <?=$i == $from_m?"selected":""?>><?=$months[$i]?></option>
<?php
	 				}
?>
								</select>
								<select name="from_d" class="date-day">
<?php
					for ($i=1; $i<=31; $i++)
					{
?>
									<option value="<?=$i?>" <?=$i == $from_d?"selected":""?>><?=$i?></option>
<?php
					}
?>
								</select>
								<select name="from_y" class="date-year">
<?php
					for ($i=2003; $i<=date("Y")+10; $i++)
					{
?>
									<option value="<?=$i?>" <?=$i == $from_y?"selected":""?>><?=$i?></option>
<?php
					}
?>
								</select>
							</td>
						</tr>
						<tr>
							<td class="formItemCaption">To</td>
							<td class="formItemControl">
								<select name="to_m" class="date-month">
<?php
					for ($i=1; $i<=12; $i++)
					{
?>
									<option value="<?=$i?>" <?=$i == $to_m?"selected":""?>><?=$months[$i]?></option>
<?php
	 				}
?>
								</select>
								<select name="to_d" class="date-day">
<?php
					for ($i=1; $i<=31; $i++)
					{
?>
									<option value="<?=$i?>" <?=$i == $to_d?"selected":""?>><?=$i?></option>
<?php
					}
?>
								</select>
								<select name="to_y" class="date-year">
<?php
					for ($i=2003; $i<=date("Y")+10; $i++)
					{
?>
									<option value="<?=$i?>" <?=$i == $to_y?"selected":""?>><?=$i?></option>
<?php
					}
?>
								</select>
							</td>
						</tr>
					</table>
					
					<div class="admin-form-header"><span class="icon ic-icon ic-align-vertical-left"></span>Product Layout in the Email</div>
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
						<tr valign="top">
							<td class="formItemCaption">Choose the layout for the HTML email</td>
							<td class="formItemControl">
								<select name="email_view" class="short">
									<option value="text">Text</option>
									<option value="thumb" <?=$email_view=="thumb"?"selected":""?>>Thumbnail</option>
								</select>
							</td>
						</tr>
					</table>
					<div class="admin-form-buttons">
						<input type="submit" value="Generate email"/>
					</div>
				</form>
<?php
					break;
				}
				/**
				 * Edit email
				 */
				case 2 :
				{
	 				if ($mode == "insert")
	 				{
						$from_name = "";
						$from_email = "";
						$subject = "";
					
						//init smarty & other libs
						if ($settings["USE_MOD_REWRITE"]=="YES")
						{
							require_once("content/engine/engine_url_rewrite.php");
						}
						else
						{
							require_once("content/engine/engine_url_default.php");
						}
						require_once("content/admin/admin_init_smarty.php");
						require_once("content/engine/engine_order.php");
						require_once("content/classes/class.products.php");
						
						$products = new ShoppingCartProducts($db, $settings);
						
						require_once("content/classes/class.currencies.php");
						$currencies = new Currencies($db);
						$default_currency = $currencies->getDefaultCurrency();
						$currencies->setCurrentCurrency($default_currency["currency_id"]);
						
						//get products between dates
						$mysql_from =  $from_y."-".$from_m."-".$from_d;
						$mysql_to =  $to_y."-".$to_m."-".$to_d;
						$dates = $months[$from_m]." ".$from_d.", ".$from_y." - ".$months[$to_m]." ".$to_d.", ".$to_y;
						
						//assign smarty vars
						view()->assign("products", $products->getItemsProductUpdates($mysql_from, $mysql_to, 0, 150));
						view()->assign("products_file", strtolower("templates/emails/elements/product-updates-view-".$email_view.".html"));
						view()->assign("dates", $dates);
						
						$lang_file = escapeFileName($settings["ActiveLanguage"]);
						
						include_once("./content/languages/".$lang_file.".php");
						view()->assign("msg", $msg);
						view()->assign("EmailTitle", "Product Updates");
						
						//get email HTML & TEXT
						view()->force_compile = true;
						
						$email_html = view()->fetch("templates/emails/product_updates_html.html");
						$email_text = view()->fetch("templates/emails/product_updates_text.html");
					}
					else
					{
						$db->query("SELECT * FROM ".DB_PREFIX."emails_archive WHERE eid='".$eid."'");
						if ($db->moveNext())
						{
							$from_name = $db->col["from_name"];
							$from_email = $db->col["from_email"];
							$subject = $db->col["subject"];
							$email_html = $db->col["content_html"];
							$email_text = $db->col["content_text"];
						}
					}
	?>
					<form name="frmEmail" action="admin.php?p=email_updates&step=3&hidemenus=true" method="post" onSubmit="return checkEmailForm(this)">
						<input type="hidden" name="mode" value="<?=gs($mode)?>"/>
						<input type="hidden" name="eid" value="<?=$eid?>"/>
						
						<div class="admin-form-header first"><span class="icon ic-icon ic-checkmark"></span>Email Properties</div>
						<table width="100%" cellpadding="0" cellspacing="0" border="0">
							<tr valign="top">
								<td class="formItemCaption required">Subject</td>
								<td class="formItemControl"><input type="text" name="subject" value="<?=htmlspecialchars($subject)?>"></td>
							</tr>
							<tr valign="top">
								<td class="formItemCaption required">From Name</td>
								<td class="formItemControl"><input type="text" name="from_name" value="<?=htmlspecialchars($from_name)?>"></td>
							</tr>
							<tr valign="top">
								<td class="formItemCaption required">From Email</td>
								<td class="formItemControl"><input type="text" name="from_email" value="<?=htmlspecialchars($from_email)?>"></td>
							</tr>
						</table>
						
						<div class="admin-form-header editor-manager"><span class="icon ic-icon ic-pencil"></span>HTML Email</div>
						<div class="formItemControl big">
							<textarea wrap="off" class="no-mce editor-area" id="email_html" name="email_html"><?=htmlspecialchars($email_html)?></textarea>
						</div>
						
						<div class="admin-form-header"><span class="icon ic-icon ic-pencil"></span>Text Email</div>
						<div class="formItemControl big">
							<textarea class="no-mce" wrap="off"  name="email_text"><?=htmlspecialchars($email_text)?></textarea>
						</div>
						
						<div class="admin-form-buttons">
							<input type="button" value="Change dates" onClick="document.location='admin.php?p=email_updates&step=1'"/>
							<input type="submit" value="Preview email"/>
						</div>
					</form>
<?php
					break;
				}
				
				/**
				 * Preview email
				 */
	
				case 3 : 
				{
					$action = isset($action)?trim($action):"";
					$eid = isset($eid)?$eid:0;
					if ($action == "test_email")
					{
						$db->query("SELECT * FROM ".DB_PREFIX."emails_archive WHERE eid='".$eid."'");
						if ($db->moveNext())
						{
							$test_email = isset($test_email)?trim($test_email):"";
							require_once("content/engine/engine_notifications.php");
							$content_text = stripslashes($db->col["content_text"]);
							$content_html = stripslashes($db->col["content_html"]);
							$from_email = stripslashes($db->col["from_email"]);
							$from_name = stripslashes($db->col["from_name"]);
							$subject = stripslashes($db->col["subject"]);
							send_mail($test_email, $subject, $content_text, array('name' => $from_name, 'email' => $from_email), "text");
							send_mail($test_email, $subject, $content_html, array('name' => $from_name, 'email' => $from_email), "html");
						}
					}
					else
					{
						//now store changes into database
						$db->reset();
						$db->assignStr("sent", "No");
						$db->assignStr("type", "updates");
						$db->assignStr("subject", $subject);
						$db->assignStr("content_html", $email_html);
						$db->assignStr("content_text", $email_text);
						$db->assignStr("from_name", $from_name);
						$db->assignStr("from_email", $from_email);
						if ($mode == "update")
						{
							$db->update(DB_PREFIX."emails_archive", "WHERE eid='".$eid."'");
						}
						else
						{
							$eid = $db->insert(DB_PREFIX."emails_archive");
						}
					}
?>
					<div class="admin-form-header first"><span class="icon ic-icon ic-document"></span>HTML Email</div>
					<div class="formItemControl big">
						<iframe width="100%" height="230" src="admin.php?p=email_preview&eid=<?=$eid?>&mode=html&chart"></iframe>
					</div>
					
					<div class="admin-form-header"><span class="icon ic-icon ic-document"></span>TEXT Email</div>
					<div class="formItemControl big">
						<iframe width="100%" height="230" src="admin.php?p=email_preview&eid=<?=$eid?>&mode=text&chart"></iframe>
					</div>
					
					<div class="admin-form-header"><span class="icon ic-icon ic-envelope"></span>Send Test Email</div>
					
					<form name="frmEmail" action="admin.php?p=email_updates&step=3&hidemenus=true" method="post">
						<input type="hidden" name="action" value="test_email"/>
						<input type="hidden" name="eid" value="<?=$eid?>"/>
						<table cellpading="0" cellspacing="5" border="0" width="100%">
							<tr>
								<td class="formItemCaption" style="padding-top:10px;">Test Email Address</td>
								<td class="formItemControl">
									<div style="float:left;width:255px;padding-top:3px;">
										<input type="text" name="test_email" value="<?=htmlspecialchars(isset($test_email)?$test_email:$auth_admin_email)?>">
									</div>
									<div style="float:left;width:120px;"><input type="submit" value="Send test email"/></div>
								</td>
							</tr>
						</table>
					</form>
					
					<form name="frmEmail" action="admin.php?p=email_updates&step=4" method="post" onSubmit="return confirmSendEmailProductUpdates()">
					<div class="admin-form-buttons">
						<input type="hidden" name="eid" value="<?=$eid?>"/>
						<input type="button" onclick="document.location='admin.php?p=email_updates&step=2&mode=update&eid=<?=$eid?>';" value="Edit email"/>
						<input type="submit" value="Send email"/>
					</div>
<?php
					break;
				}
				
				/**
				 * Send emails
				 */
	
				case 4 : 
				{
					$db->query("SELECT * FROM ".DB_PREFIX."emails_archive WHERE eid='".$eid."' AND sent='No'");
					if ($db->moveNext())
					{
						require_once("content/engine/engine_notifications.php");
						$content_text = stripslashes($db->col["content_text"]);
						$content_html = stripslashes($db->col["content_html"]);
						$from_email = stripslashes($db->col["from_email"]);
						$from_name = stripslashes($db->col["from_name"]);
						$subject = stripslashes($db->col["subject"]);
	                                
						if (!safe_mode()) set_time_limit(3000);
						
						$uc = 0;
						// unsubscribe block
						//$unsubscr_sample = "-Unsubscribe link will be generated here-";
						//$unsubscr_users_link = $settings["GlobalHttpUrl"]."/index.php?p=unsubscribe";
						//$unsubscr_users_message = "To cancel your subscription, click here";
						//$unsubscr_users_text = $unsubscr_users_message.": ".$unsubscr_users_link;
						//$unsubscr_users_html = "<a href=\"".$unsubscr_users_link."\">".$unsubscr_users_message."</a>";
						// end of unsubscribe block
	
						//send 2 users
						if (!DEMO_LOCK)
						{
							$db->query("SELECT * FROM ".DB_PREFIX."users WHERE updates='Yes' GROUP BY email ORDER BY email");
							while ($db->moveNext())
							{
								if ($db->col["email_mode"] == "text")
								{
									send_mail($db->col["email"], $subject, $content_text, array('name' => $from_name, 'email' => $from_email), "text");
								}
								else
								{
									send_mail($db->col["email"], $subject, $content_html, array('name' => $from_name, 'email' => $from_email), "html");
								}
								$uc++;
							}
						}
	                                
						//send 2 subscribers
						$db->query("SELECT * FROM ".DB_PREFIX."emails WHERE updates='Yes' AND dead='No' GROUP BY email ORDER BY email");
	
						if (!safe_mode()) set_time_limit(300);
						
						$sc = 0;
						// unsubscribe block
						$unsubscr_sample = "-Unsubscribe link will be generated here-";
						// end of unsubscribe block
						if (!DEMO_LOCK)
						{
							while ($db->moveNext())
							{
								send_mail($db->col["email"], $subject, $content_text, array('name' => $from_name, 'email' => $from_email), "text");
								send_mail($db->col["email"], $subject, $content_html, array('name' => $from_name, 'email' => $from_email), "html");
								$sc++;
							}
						}
						$db->query("UPDATE ".DB_PREFIX."emails_archive SET sent='Yes', sent_at=NOW() WHERE eid='".$eid."'");
						pageNote(array(
							array("class"=>"ic-info", "text"=>"<b>Product Update Email has been successfully sent</b>", "url"=>"", "visible"=>true),
							array("class"=>"ic-info", "text"=>"You have sent your newsletter to ".$uc." registered user(s) and ".$sc." email(s) to unregistered subscribers", "url"=>"", "visible"=>true)
						));
						pageWhat(array(
							array("text"=>"Browse Emails Archive", "url"=>"admin.php?p=email_archive"),
							array("text"=>"Send Product Update email again", "url"=>"admin.php?p=email_updates")
						));
					}
					else
					{
						pageNote(array(
							array("class"=>"ic-cross", "text"=>"<b>This email already sent</b>", "url"=>"", "visible"=>true)
						));
						pageWhat(array(
							array("text"=>"Browse Emails Archive", "url"=>"admin.php?p=email_archive"),
							array("text"=>"Send Product Update Email again", "url"=>"admin.php?p=email_updates")
						));
					}
				}
			}
	        if ($step < 4)
	        {
?>
				</div>
			</div>
		</div>
<?php
	        }
		}
	}
?>
