<?php
	include_once("content/engine/engine_images.php");

	if (!defined("ENV")) exit();
	if (!safe_mode()) set_time_limit(10000);
	
	if ($settings["USE_MOD_REWRITE"]=="YES")
	{
		require_once("content/engine/engine_url_rewrite.php");	
	}
	else
	{
		require_once("content/engine/engine_url_default.php");
	}
	
	$coid = intval($settings["TaxDefaultCountry"]);
	$stid = intval($settings["TaxDefaultState"]);

	$query = "SELECT iso_a2 FROM ".DB_PREFIX."countries WHERE coid='".$coid."'";
	$result = $db->query($query);
	if ($row = $db->moveNext())
	{
		$defaultTaxCountry = $row['iso_a2'];
	}
	else
	{
		$defaultTaxCountry = 'US';
	}

	$export_format = "rss";//isset($export_format)?$export_format:"rss";
	$export_taxes = isset($export_taxes)?$export_taxes:0;
	
	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new DB_TREE_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));
	
	$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE key_name <> 'gift_cert' ORDER BY level, priority, name");
	
	while($db->moveNext())
	{
		$tree->addNode(
			new DB_TREE_NODE(
				$db->col["cid"], 
				$db->col["parent"], 
				$db->col["level"], 
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}
	
	function fr_normalize($s)
	{
		$ss = str_replace("\r", " ", $s);
		$ss = str_replace("\n", " ", $ss);
		$ss = str_replace("\t", " ", $ss);
		$ss = str_replace("\0", " ", $ss);
		$ss = htmlentities(trim(stripslashes($ss)));
		$sss = "";
		$whitespace = false;
		for($i=0; $i<strlen($ss); $i++){
			$sss = $sss.((($ss[$i] == " " && !$whitespace) || ($ss[$i] != " ")) ? $ss[$i] : "");
			$whitespace = $ss[$i] == " ";
		}
		return $sss;
	}
	
	function st_normalize($string)
	{
		$string_final = strip_tags($string);
		$string_final = htmlspecialchars($string_final);
		return utf8_encode($string_final);
	} 
	
	function getCategoryPath($id)
	{
		global $tree;
		$path = "";
		$_id = $id;
		for ($i=0; $i<count($tree->collection); $i++)
		{
			$path = (fr_normalize(str_replace(">", " ", $tree->collection[$_id]->caption))).($path==""?"":" > ").$path;
			$_id = $tree->collection[$_id]->parent_id;
			if (!($_id > 0))
			{
				break;
			}
		}
		return $path;
	}

	$expdate = '';
	if (isset($_POST['expdays']) && intval($_POST['expdays']) > 0 && intval($_POST['expdays']) < 31)
	{
		$expdate = gmdate("Y-m-d", time() + (intval($_POST['expdays']) * 24 * 60 * 60));
	}

	$service_type = (!isset($service_type) || trim($service_type) == "") ? "Not Define":$service_type;
	$de = isset($de)?trim($de):"overview";

	//Store location from the Company Information
	$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes'  AND group_id='1' ORDER BY priority");
	$store_location = "";
	while ($db->moveNext())
	{
		$address[$db->col["name"]] = $db->col["value"]; 
	}
	$store_location = trim($address["CompanyAddressLine1"])==""?"":$address["CompanyAddressLine1"];
	$store_location = $store_location.(trim($address["CompanyAddressLine2"])==""?"":", ".$address["CompanyAddressLine2"]);
	$store_location = $store_location.(trim($address["CompanyCity"])==""?"":", ".$address["CompanyCity"]);
	$store_location = $store_location.(trim($address["CompanyState"])==""?"":", ".$address["CompanyState"]);
	$store_location = $store_location.(trim($address["CompanyZip"])==""?"":", ".$address["CompanyZip"]);
	$store_location = $store_location.(trim($address["CompanyCountry"])==""?"":", ".$address["CompanyCountry"]);
	
	/**
	 * Preset taxes
	 */
	//create tax tables array
	$alternate_tax_tables = array();
	
	//non-taxable products
	$alternate_tax_tables[] = '<alternate-tax-table standalone="true" name="tax_exempt"><alternate-tax-rules/></alternate-tax-table>';
	
	//select all tax classes used in current order
	$db->query("SELECT	".DB_PREFIX."tax_classes.class_id AS tax_class_id, ".DB_PREFIX."tax_classes.class_name AS tax_class_name FROM ".DB_PREFIX."tax_classes");

	$_tax_classes = $db->getRecords();
	
	$tax_classes = array();
	foreach ($_tax_classes as $i=>$_tax_class)
	{
		//add alternate state table for each tax class
		$tax_xml = '';
				
		//add rates and zones
		$r = $db->query("
			SELECT 
				".DB_PREFIX."tax_rates.tax_rate,
				".DB_PREFIX."tax_zones_regions.coid as country_id,
				".DB_PREFIX."tax_zones_regions.stid as state_id,
				".DB_PREFIX."countries.iso_a2 AS country_code,
				".DB_PREFIX."states.short_name AS state_code
			FROM ".DB_PREFIX."tax_zones_regions 
			INNER JOIN ".DB_PREFIX."tax_rates ON (".DB_PREFIX."tax_zones_regions.zone_id = ".DB_PREFIX."tax_rates.zone_id)
			LEFT JOIN ".DB_PREFIX."countries ON (".DB_PREFIX."countries.coid =".DB_PREFIX."tax_zones_regions.coid)
		   	LEFT JOIN ".DB_PREFIX."states ON (".DB_PREFIX."states.stid = ".DB_PREFIX."tax_zones_regions.stid)
			WHERE ".DB_PREFIX."tax_rates.class_id='".$_tax_class["tax_class_id"]."' AND ".DB_PREFIX."tax_rates.user_level LIKE '%0%'
		");
		
		if ($db->numRows($r) > 0)
		{
			//add new tax rule for each itteration (tax rate)
			while ($db->moveNext($r, MYSQL_ASSOC))
			{
				$_tax_rate = $db->col;
				$tax_xml .= '<g:tax><g:rate>'.myNum($_tax_rate["tax_rate"]).'</g:rate><g:tax_ship>'.($settings["ShippingTaxable"]?"y":"n").'</g:tax_ship>';
				
				//world-wide tax
				if ($_tax_rate["country_id"] == "0")
				{
					$tax_xml.= '<g:country>'.$defaultTaxCountry.'</g:country><g:region>*</g:region>';
				}
				//country-specific tax
				else
				{
					$tax_xml.= '<g:country>'.$_tax_rate["country_code"].'</g:country>';
					if ($_tax_rate["state_id"] == "0")
					{
						$tax_xml.= '<g:region>*</g:region>';
					}
					else
					{
						$tax_xml.= '<g:region>'.$_tax_rate["state_code"].'</g:region>';
					}
				}
				$tax_xml.= '</g:tax>';
				
			}
		}
		$tax_classes[$_tax_class["tax_class_id"]] = $tax_xml;	
	}
	
	if ($export_format == "rss")
	{
		$mime_type = "text/xml";
		$filename = "froogle";
		$ext = "xml";
	}
	else
	{
		$mime_type = "text/plain";
		$filename = "froogle";
		$ext = "txt";
	}

	header('Content-Type: '.$mime_type);
	header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
	header('Content-Disposition: inline; filename="'.$filename.'.'.$ext.'"');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Content-Disposition: attachment; filename="'.$filename.'.'.$ext.'"');

	$noImageUrl = DesignElements::getImage('image-no-image-big');

	// initialize $ms array
	$ms = array();
	
	$db->query("SELECT ".DB_PREFIX."manufacturers.manufacturer_id AS id, ".DB_PREFIX."manufacturers.manufacturer_name FROM ".DB_PREFIX."manufacturers");	
	while ($db->moveNext())
	{ 
		$ms[$db->col["id"]] = $db->col["manufacturer_name"];
	}

	$cid = false;
	if (isset($_POST['product_category']) && intval($_POST['product_category']) > 0)
	{
		$cid = intval($_POST['product_category']);
	}
	
	$db->query('SELECT cid, name 
		FROM '.DB_PREFIX.'catalog c
		'.($cid ? 'WHERE cid = '.$cid : '')
	);
	$catalogMap = array();
	while ($row = $db->moveNext())
	{
		$catalogMap[$row['cid']] = $row['name'];
	}

	if ($export_format == "rss")
	{
		echo '<?xml version="1.0" encoding="UTF-8"?>'."\r\n";
		echo '<rss version="2.0" xmlns:g="http://base.google.com/ns/1.0">'."\r\n";
		echo '<channel>'."\r\n";
		echo '<title>'.$settings["GlobalSiteName"].'</title>'."\r\n";
		echo '<link>'.$settings["GlobalHttpUrl"].'</link>'."\r\n";
		echo '<description>'.$settings["GlobalSiteName"].' Products</description>'."\r\n";
	}
	
	$sql = "
		SELECT ?
		FROM ".DB_PREFIX."products p
		WHERE
			p.is_visible='Yes' 
			AND p.call_for_price='No' 
			".($cid ? " AND p.cid = ".$cid : "")."
		ORDER BY p.title
		";

	if (isset($_POST['product_group']) && intval($_POST['product_group']) > 0)
	{
		$productsGroupsSql = "p.pid IN (SELECT pid FROM ".DB_PREFIX."products_groups_products pgp WHERE pgp.group_id = ".intval($_POST['product_group']).") AND ";
		$sql = str_replace('WHERE', 'WHERE '.$productsGroupsSql, $sql);
	}
	
	if (isset($_POST['product_count']) && intval($_POST['product_count']) > 0)
	{
		$totalRecordCount = $batchSize = intval($_POST['product_count']);
	}
	else
	{
		$countSql = str_replace('SELECT ?', 'SELECT COUNT(0) as totalrecords', $sql);
		$db->query($countSql);
		if ($db->moveNext())
		{
			$totalRecordCount = intval($db->col['totalrecords']);
		}
		$batchSize = 10000;
	}
	
	$sql = str_replace('SELECT ?', 'SELECT *, IF (p.url_custom = "", p.url_default, p.url_custom) AS product_url', $sql);
	
	$batchCount = 0;
	$batchSizeCount = ceil($totalRecordCount / $batchSize);
	
	while ($batchCount < $batchSizeCount)
	{
		$batchSql = $sql.' LIMIT '.($batchCount * $batchSize).', '.$batchSize;
		
		$db->query($batchSql);

		$imageTypes = array( "jpg", "gif", "jpeg", "png");

		while ($db->moveNext())
		{
			if ($export_format == "rss")
			{
				$product_url = getProductUrl($db->col["product_url"], $db->col["pid"], $db->col["cid"]);
				$name = $db->col["title"];
				$pid = $db->col["product_id"];
				$upc = $db->col["product_upc"];
				$gtin = $db->col["product_gtin"];
				$mpn = $db->col["product_mpn"];
				$weight = $db->col["weight"];
				$tax_class_id = $db->col["tax_class_id"];
				$is_taxable = $db->col["is_taxable"] == "Yes";
				$tax_rate = $db->col["tax_rate"];
				$free_shipping = $db->col["free_shipping"] == "Yes";

				$estimated_shipping_price = $db->col["estimated_shipping_price"];

				// Newly added variables.
				$brand = (array_key_exists($db->col["manufacturer_id"], $ms)) ? $ms[$db->col["manufacturer_id"]] : null;
				$brand = is_null($brand) || empty($brand) ? "Unknown" : $brand;
				$condition = $db->col['google_item_condition'];
				// $producttype = $db->col["cat_name"];
				$producttype = (isset($catalogMap[$db->col['cid']])) ? $catalogMap[$db->col['cid']] : 'Category';

				$google_product_type = $db->col["google_product_type"];

				$gender = $db->col['google_gender'];
				$age_group = $db->col['google_age_group'];
				$color = $db->col['google_color'];
				$size = $db->col['google_size'];
				$material = $db->col['google_material'];
				$pattern = $db->col['google_pattern'];

				$online_only = $db->col['google_online_only'];

				$availability = $db->col['google_availability'];

				if ($availability == '' || $availability == 'inventory_control')
				{
					$availability = 'in stock';

					if (($db->col['inventory_control'] == 'AttrRuleExc' || $db->col['inventory_control'] == 'Yes') && $db->col['stock'] == 0)
					{
						$availability = 'out of stock';
					}
				}
				// end add 

				switch($de)
				{
					case "description" : $_description = $db->col["description"]; break;
					case "overview" : $_description = trim($db->col["overview"])==""?$db->col["title"]:$db->col["overview"]; break;
				}

				$description = trim($_description)==""?$name:$_description;
				$description = str_replace("!", ".",$description);
				$description = str_replace("  ", "", $description);			

				$price = (intval($db->col['case_pack']) > 0)
					? $db->col["price"] * $db->col['case_pack']
					: $db->col["price"];

				$image_url = "";

				if ($db->col["image_location"] == "Web" && $db->col["image_url"] != "")
				{
					$image_url = $db->col["image_url"];
				}
				else
				{
					foreach ($imageTypes as $ext)
					{
						if (file_exists($settings["GlobalServerPath"]."/images/products/".imageFileName($db->col["product_id"]).".".$ext))
						{
							$image_url = fr_normalize($settings["GlobalHttpUrl"]."/images/products/".imageFileName($db->col["product_id"]).".".$ext); //normalize again
							break;
						}
					}
				}

				$image_url = trim($image_url) == "" ? fr_normalize($settings["GlobalHttpUrl"].'/'.$noImageUrl) : $image_url;

				echo "<item>\r\n";
				echo "<title>".st_normalize($name)."</title>\r\n";
				echo "<link>".st_normalize($product_url)."</link>\r\n";
				echo "<description>".st_normalize($description)."</description>\r\n";
				echo "<g:id>".st_normalize($pid)."</g:id>\r\n";
				echo "<g:upc>".st_normalize($upc)."</g:upc>\r\n";
				echo "<g:gtin>".st_normalize($gtin)."</g:gtin>\r\n";
				echo "<g:mpn>".st_normalize($mpn)."</g:mpn>\r\n";
				echo "<g:image_link>".st_normalize($image_url)."</g:image_link>\r\n";
				echo "<g:price>".st_normalize(number_format($price, 2, ".", ""))."</g:price>\r\n";

				if ($weight > 0) echo "<g:weight>".st_normalize($weight.($settings["LocalizationWeightUnits"] == "kg" ? " kg" : " lb"))."</g:weight>\r\n";

				//added for google base ver
				echo "<g:brand>".st_normalize($brand)."</g:brand>\r\n";
				echo "<g:condition>".st_normalize($condition)."</g:condition>\r\n";
				echo "<g:product_type>".st_normalize($producttype)."</g:product_type>\r\n";
				echo "<g:google_product_category>".st_normalize($google_product_type)."</g:google_product_category>\r\n";
				//echo "<g:service_type>".st_normalize($service_type)."</g:service_type>\r\n";
				echo "<g:location>".st_normalize($store_location)."</g:location>\r\n";

				if ($expdate != '')
					echo "<g:expiration_date>".st_normalize($expdate)."</g:expiration_date>\r\n";
				if ($gender != '')
					echo "<g:gender>".st_normalize($gender)."</g:gender>\r\n";
				if ($age_group != '')
					echo "<g:age_group>".st_normalize($age_group)."</g:age_group>\r\n";
				if ($color != '')
					echo "<g:color>".st_normalize($color)."</g:color>\r\n";
				if ($size != '')
					echo "<g:size>".st_normalize($size)."</g:size>\r\n";
				if ($material != '')
					echo "<g:material>".st_normalize($material)."</g:material>\r\n";
				if ($pattern != '')
					echo "<g:pattern>".st_normalize($pattern)."</g:pattern>\r\n";
				if ($online_only == 'y')
					echo "<g:online_only>".st_normalize($online_only)."</g:online_only>\r\n";

				echo "<g:availability>".st_normalize($availability)."</g:availability>";

				if ($free_shipping)
				{
					echo "<g:shipping><g:country>".$defaultTaxCountry."</g:country><g:region>*</g:region><g:price>0.00</g:price><g:service>Standard</g:service></g:shipping>\r\n";
				}
				else
				{
					if ($estimated_shipping_price >= 0)
					{
						echo "<g:shipping><g:country>".$defaultTaxCountry."</g:country><g:region>*</g:region><g:price>".myNum($estimated_shipping_price)."</g:price><g:service>Standard</g:service></g:shipping>\r\n";
					}
				}

				if ($export_taxes && $is_taxable)
				{
					if ($tax_rate >=0)
					{	
						echo "<g:tax><g:country>".$defaultTaxCountry."</g:country><g:region>*</g:region><g:rate>".myNum($tax_rate)."</g:rate><g:tax_ship>".($settings["ShippingTaxable"]?"y":"n")."</g:tax_ship></g:tax>\r\n";
					}
					else if (isset($tax_classes[$tax_class_id]))
					{
						echo $tax_classes[$tax_class_id];
					}
				}
				else if ($export_taxes)
				{
					echo "<g:tax><g:country>".$defaultTaxCountry."</g:country><g:region>*</g:region><g:rate>0.00</g:rate><g:tax_ship>".($settings["ShippingTaxable"]?"y":"n")."</g:tax_ship></g:tax>\r\n";
				}

				//end added
				echo "</item>\r\n";
			}
			else
			{
				$product_url = fr_normalize(getProductUrl($db->col["product_url"], $db->col["pid"], $db->col["cid"]));
				$name = substr(fr_normalize($db->col["title"]), 0, 80);

				switch ($de)
				{
					case "description" : $_description = $db->col["description"]; break;
					case "overview" : $_description = trim($db->col["overview"])==""?$db->col["description"]:$db->col["overview"]; break;
				}

				$description = substr(fr_normalize($_description), 0, 1000);
				$price = fr_normalize($db->col["price"]);

				foreach ($imageTypes as $ext)
				{
					if (file_exists($settings["GlobalServerPath"]."/images/products/". $db->col["product_id"] . "." . $ext))
					{
						$image_url = fr_normalize($settings["GlobalHttpUrl"]."/images/products/".$db->col["product_id"] . "." . $ext); //normalize again
						break;
					}
				}

				if (isset($image_url) && $image_url != "")
				{
					echo $product_url."\t".$name."\t".$description."\t".number_format($price, 2, ".", "")."\t".$image_url."\r\n";
				}
			}
			unset($image_url);
		}
		
		$batchCount++;
	}
	
	if ($export_format == "rss")
	{
		echo '</channel>'."\r\n";
		echo '</rss>'."\r\n";
	}

	session_write_close();
	$db->done();
	
	die();
