<?php

	if (!defined("ENV")) exit();

	pageHeader("Shopzilla Data Feed Export", "", "icb-shopping-cart");
	$action = isset($action)?trim($action):"";
	if ($action == "update_shopzilla_settings" && !DEMO_LOCK)
	{
		$form = isset($form)?$form:array();
		reset($form);
		foreach ($form as $name=>$value)
		{
			$db->reset();
			$db->assignStr("value", $value);
			$db->update(DB_PREFIX."settings", "WHERE name='".$name."'");
			$settings[$name] = $value;
		}
		pageNote(array(
			array("class"=>"ic-info", "text"=>"<b>Shopzilla Settings have been saved</b>", "url"=>"", "visible"=>true),
			array("class"=>"ic-shopping-cart", "text"=>"Back to Shopzilla Page", "url"=>"admin.php?p=export_shopzilla", "visible"=>true),
		));
	}
	else
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>
				"For your products to appear in Shopzilla's product search engine, you must provide a Product Listings ".
				"Datafeed. Shopzilla will process your datafeed every 36 - 48 hours to ensure that the most current version  ".
				"of your product listings appear in our product search engine.", "url"=>"", "visible"=>true),
			array("class"=>"ic-info", "text"=>
				"<b>ROI Tracker: </b>".
				"Monitor your conversion rates and improve your campaign performance using Shopzilla's free conversion tracking tool.",
				"url"=>"", "visible"=>true),
			array("class"=>"ic-link", "text"=>"<a target=\"_new\" href=\"http://www.shopzilla.com/\">Click Here to Visit Shopzilla</a>", "url"=>"", "visible"=>true)
		));

		$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"settings";
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-shopzilla">
<?php 
		pageTabs(array(
			array("title"=>"Settings", "id"=>"settings"),
			array("title"=>"Export Data Feed", "id"=>"datafeed"),
		), "tabs-shopzilla", $last_active_tab);
?>
	<div id="admin-tab-sheet-settings" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<form name="frmShopzillaSettings" action="admin.php?p=export_shopzilla" method="post">
				<input type="hidden" name="action" value="update_shopzilla_settings">
				<div class="admin-form-header first"><span class="icon ic-icon ic-shopping-cart"></span>Shopzilla Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Shopzilla Merchant Identification Number</td>
						<td class="formItemControl"><input type="text" name="form[ShopzillaMerchantId]" value="<?=htmlspecialchars($settings["ShopzillaMerchantId"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Shopzilla Username</td>
						<td class="formItemControl"><input type="text" name="form[ShopzillaUsername]" value="<?=htmlspecialchars($settings["ShopzillaUsername"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Shopzilla Password</td>
						<td class="formItemControl"><input type="text" name="form[ShopzillaPassword]" value="<?=htmlspecialchars($settings["ShopzillaPassword"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Shopzilla's ROI Tracker</td>
						<td class="formItemControl">
							<select class="short" name="form[ShopzillaROITracker]">
								<option value="YES">Yes</option>
								<option value="NO" <?=$settings["ShopzillaROITracker"]=="NO"?"selected":""?>>No</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">BizRate Survey Invitation</td>
						<td class="formItemControl">
							<select class="short" name="form[SurveyInvitation]">
								<option value="YES">Yes</option>
								<option value="NO" <?=$settings["SurveyInvitation"]=="NO"?"selected":""?>>No</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</form>
		</div>
	</div>

	<div id="admin-tab-sheet-datafeed" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<form name="frmShopzill" target="iframe-download" action="admin.php?no-acceleration=true&p=export_shopzilla_process&chart=true" method="post">
				<div class="admin-form-header first"><span class="icon ic-icon ic-download"></span>Export Data Feed</div>
<?php
		pageNote(array(
			array("class"=>"ic-info", "text"=>
				"This feature allows you to save shopzilla datafeed file on your computer.<br/>".
				"Click \"Export Datafeed\" button below to get your file"
			)
		));
?>

				<div class="admin-form-buttons">
					<input type="submit" value="Export data feed"/>
				</div>
			</form>
		</div>
	</div>
</div>
<?php
	}
?>