<?php
	
	if (!defined("ENV")) exit();

	$action = isset($_REQUEST['action']) ? $_REQUEST['action'] : '';
	
	switch ($action) 
	{
		/**
		 * Output a printable page for use within an iframe
		 */
		case 'label_view_iframe':
		{
			$oid = isset($_REQUEST['oid']) ? intval($_REQUEST['oid']) : 0;
			$olid = isset($_REQUEST['olid']) ? intval($_REQUEST['olid']) : 0;
			$image_urls = '';

			if (isset($_REQUEST['image_urls']))
			{
				$image_urls = trim($_REQUEST['image_urls']);
			}
			else
			{
				$db->reset();
				$db->query("SELECT oid, olid, url FROM ".DB_PREFIX."orders_labels WHERE oid=".intval($oid)." AND olid=".intval($olid)." AND type='stampscom'");
				if ($db->moveNext())
				{
					$image_urls = trim($db->col['url']);
				}
			}

			if (strlen($image_urls))
			{
				$is_pdf = preg_match('@/-\d+\.pdf\?@', $image_urls) ? true : false;
				$image_urls_arr = preg_split('/\s+/', $image_urls);
?>
<style type="text/css">
* {
	margin:0 !important;
	padding:0 !important;
}
</style>
<?php
				foreach ($image_urls_arr as $image_url)
				{
					if ($is_pdf)
					{
?>
	<div class="pdf">
		<object style="width:<?php echo($width_in); ?>in; height:<?php echo($height_in); ?>in;" width="100%" height="100%" type="application/pdf" data="<?php gs($image_url); ?>" class="pdf-content">
			<span>Your browser does not support inline PDF displays.  Click <a href="<?php echo gs($image_url); ?>"><strong>here</strong></a> to download the PDF file.</span>
		</object>
	</div>
<?php
					}
					else
					{
						echo '<img src="'.$image_url.'" class="print-label-image">';
					}
				}
			}
			break;
		}


		/**
		 * Output a table with tracking information for a label
		 */
		case 'label_track_iframe':
		{
			$oid = isset($_REQUEST['oid']) ? $_REQUEST['oid'] : false;
			$olid = isset($_REQUEST['olid']) ? $_REQUEST['olid'] : false;
			$db->reset();
			$db->query("SELECT oid, olid, url, transaction_id, tracking_number FROM ".DB_PREFIX."orders_labels WHERE oid=".intval($oid)." AND olid=".intval($olid)." AND type='stampscom'");

			if ($db->moveNext())
			{
				$stampscom_tmp_db = null; # not $db to use read-only
				$stampscom_obj = new Stampscom($stampscom_tmp_db, $settings);
				$arguments = array('StampsTxID'=>$db->col['transaction_id']);
				$return = $stampscom_obj->apiCall('TrackShipment', $arguments);

				$events = isset($return['TrackingEvents']) ? is_array($return['TrackingEvents']) ? $return['TrackingEvents'] : array() : array();

				if (count($events))
				{
?>
	<table id="tracking_table" class="admin-list-table" width="100%" cellpadding="0" cellspacing="0" border="0">
		<thead>
			<tr>
				<th>Date</th>
				<th>Event</th>
				<th>Location</th>
			</tr>
		</thead>
		<tbody>
<?php
					if (isset($events['TrackingEvent']))
					{
						$events = array($events);
					}

					foreach ($events as $event)
					{
						if (isset($event['TrackingEvent']))
						{
							$event = $event['TrackingEvent'];
						}
?>
			<tr>
				<td nowrap="nowrap"><?php echo gs($event['Timestamp']); ?></td>
				<td nowrap="nowrap"><?php echo gs($event['Event']); ?></td>
				<td nowrap="nowrap">
<?php
					$location_string = '';
					if ($event['City']) $location_string .= $event['City'];
					if ($event['State']) $location_string .= ($location_string!=''?', ':'') . $event['State'];
					if ($event['Zip']) $location_string .= ($location_string!=''?', ':'') . $event['Zip'];
					if ($event['Country']) $location_string .= ($location_string!=''?', ':'') . $event['Country'];
					echo gs($location_string);
?>
				</td>
			</tr>
<?php
					}
?>
		</tbody>
	</table>
<?php
				}
				else
				{
?>
	<div>There is no tracking information available at this moment</div>
<?php
				}
			}
			break;
		}
	}