<?php
	if (!defined("ENV")) exit();
	
	loadJS("orders.js");
	loadJS("cd_order.js");

	//check variable
	$uid = isset($uid)?$uid*1:0;
	$action = isset($action)?trim($action):"search";
	$order_num = isset($order_num)?intval($order_num):0;
	
	$lname = isset($lname)?trim($lname):"";
	$status = isset($status)?$status:"Process";
	$payment_status = isset($payment_status)?$payment_status:"any";
	$period = isset($period)?$period*1:0;
	$sort_by = isset($sort_by)?$sort_by:"order_num_desc";
	$sort_options = array(
		"date_placed_desc" => "placed_date DESC",
		"date_placed" => "placed_date",
		"date_changed_desc" => "status_date DESC",
		"date_changed" => "status_date",
		"order_num" => "order_num",
		"order_num_desc" => "order_num DESC",
		"amount" => "total_amount",
		"amount_desc" => "total_amount DESC"
	);

	$sort_by = array_key_exists($sort_by, $sort_options) ? $sort_by : "order_num_desc";
	
	/////////////////////////////////////////
	//prepare select orders
	$where = ($status!="Abandon"?"(".DB_PREFIX."orders.status <> 'Abandon' AND ".DB_PREFIX."orders.status <> 'New') AND ":"")." (".DB_PREFIX."orders.removed='No')";
	
	//check user id
	$is_user = false;
	$show_orders = false;
	
	if ($uid > 0)
	{
		$db->query("SELECT * FROM ".DB_PREFIX."users WHERE uid='".$uid."' AND removed='No'");
		
		if ($db->moveNext())
		{
			$is_user = true;
			$user_name = $db->col["fname"]." ".$db->col["lname"];
			$where .= " AND (".DB_PREFIX."orders.uid='".$uid."')";
			$show_orders = true;
		}
	}
	/////////////////////////////////////////////////
	//if user id is not set, try to use fileters data
	if (!$is_user && $action == "search")
	{
		$show_orders = true;
		if ($order_num > 0) $where .= " AND (".DB_PREFIX."orders.order_num = '".$order_num."')";
		
		if ($lname != "") $where .= " AND (".DB_PREFIX."users.lname LIKE '%".$db->escape($lname)."%')";
		
		if ($status != "any") $where .= " AND (".DB_PREFIX."orders.status='".$status."')";
		
		if ($payment_status != "any") $where .= " AND (".DB_PREFIX."orders.payment_status='".$payment_status."')";
		
		if ($period != 0) $where .= " AND (DATE_ADD(".DB_PREFIX."orders.status_date, INTERVAL ".$period." HOUR) >= NOW())";
	}
	
	$_SESSION["orders-search-where"] = $where;
	////////////////////////////
	//and finally, select orders
	pageHeader("Orders", $is_user?("user: ".gs($user_name)):"", "icb-list2");
	if (!$is_user)
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"<b>Please enter in your search criteria.</b><br>You need to enter at least one search criteria for search to be effective", "url"=>"", "visible"=>true)
		));
	}
	else
	{
		echo "&nbsp;";
	}
	
	/////////////////////////////////////////////////
	//show search form if here no user selected by id
	if (!$is_user)
	{
?>
<form action="admin.php?p=orders" method="GET">
	<input type="hidden" name="p" value="orders"/>
	<input type="hidden" name="action" value="search"/>
	
	<div class="admin-search-form">
		<div class="admin-search-form-header">Search Orders</div>
		<div class="admin-search-form-wrap clearfix">
			<div class="admin-search-form-item">
				<label>Order ID</label>
				<input type="text" name="order_num" value="<?=$order_num > 0 ? htmlspecialchars($order_num) : ""?>"/>
			</div>
			<div class="admin-search-form-item">
				<label>Order status</label>
				<select name="status">
					<option value="any">Any</option>
					<option value="Process" <?=$status=="Process"?"selected":""?>>Process</option>
					<option value="Backorder" <?=$status=="Backorder"?"selected":""?>>Backorder</option>
					<option value="Canceled" <?=$status=="Canceled"?"selected":""?>>Canceled</option>
					<option value="Completed" <?=$status=="Completed"?"selected":""?>>Completed</option>
					<option value="Failed" <?=$status=="Failed"?"selected":""?>>Failed</option>
					<option value="Abandon" <?=$status=="Abandon"?"selected":""?>>Abandoned</option>
				</select>
			</div>
			<div class="admin-search-form-item">
				<label>Customer's Last Name</label>
				<input type="text" name="lname" value="<?=htmlspecialchars($lname)?>"/>
			</div>
			<div class="admin-search-form-item">
				<label>Order payment status</label>
				<select name="payment_status">
					<option value="any">Any</option>
					<option value="Pending" <?=$payment_status=="Pending"?"selected":""?>>Pending</option>
					<option value="Partial" <?=$payment_status=="Partial"?"selected":""?>>Partial</option>
					<option value="Received" <?=$payment_status=="Received"?"selected":""?>>Received</option>
					<option value="Refunded" <?=$payment_status=="Refunded"?"selected":""?>>Refunded</option>
					<option value="Declined" <?=$payment_status=="Declined"?"selected":""?>>Declined</option>
					<option value="Canceled" <?=$payment_status=="Canceled"?"selected":""?>>Canceled</option>
					<option value="Error" <?=$payment_status=="Error"?"selected":""?>>Error</option>
					<option value="Auth Expired" <?=$payment_status=="Auth Expired"?"selected":""?>>Auth Expired</option>
					<option value="Reversed" <?=$payment_status=="Reversed"?"selected":""?>>Reversed</option>
				</select>
			</div>
			<div class="admin-search-form-item">
				<label>Order period</label>
				<select name="period">
					<option value="any">Any</option>
					<option value="24" <?=$period=="24"?"selected":""?>>Last 24 hours</option>
					<option value="72" <?=$period=="72"?"selected":""?>>Last 3 days</option>
					<option value="168" <?=$period=="168"?"selected":""?>>Last week</option>
					<option value="336" <?=$period=="336"?"selected":""?>>Last 2 weeks</option>
					<option value="744" <?=$period=="744"?"selected":""?>>Last month</option>
				</select>
			</div>
			<div class="admin-search-form-item">
				<label>Sort by</label>
				<select name="sort_by">
					<option value="date_placed_desc" <?=$sort_by=="date_placed_desc"?"selected":""?>>Placed date (recent first)</option>
					<option value="date_placed" <?=$sort_by=="date_placed"?"selected":""?>>Placed date (oldest first)</option>
					<option value="date_changed_desc" <?=$sort_by=="date_changed_desc"?"selected":""?>>Change date (recent first)</option>
					<option value="date_changed" <?=$sort_by=="date_changed"?"selected":""?>>Change date (oldest first)</option>
					<option value="order_num" <?=$sort_by=="order_num"?"selected":""?>>Order number</option>
					<option value="order_num_desc" <?=$sort_by=="order_num_desc"?"selected":""?>>Order number (descending)</option>
					<option value="amount" <?=$sort_by=="amount"?"selected":""?>>Total amount (lower first)</option>
					<option value="amount_desc" <?=$sort_by=="amount_desc"?"selected":""?>>Total amount (higher first)</option>
				</select>
			</div>
		</div>
		<div class="admin-form-buttons admin-search-form-buttons">
			<input type="submit" value="Search"/>
			<input type="reset" value="Reset Search"/>
		</div>
	</div>
</form>

<?php
	
	}//end if "is_user"

	if ($show_orders)
	{
		$countResult = $db->selectOne("
			SELECT count(".DB_PREFIX."orders.oid) AS c
			FROM ".DB_PREFIX."orders 
			INNER JOIN ".DB_PREFIX."users ON ".DB_PREFIX."users.uid=".DB_PREFIX."orders.uid AND ".DB_PREFIX."users.removed='No'
			WHERE ".$where."
		");
		
		$items_count = $countResult["c"];
		$ccc = 20;
		$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 ) ? 1 : 0);
		$pg = isset($pg) ? ($pg*1) : 1;
		$pg = (($pg < 1) || ($pg > $pages_count)) ? 1 : $pg;
		
		if ($is_user)
		{
			$pages_line = format_pages_line(
				$pg, // current pare
				$pages_count, // total pages
				7, 
				"admin.php?p=orders&uid=".$uid
			);
		}
		else
		{
			$pages_line = format_pages_line(
				$pg, // current pare
				$pages_count, // total pages
				7, 
				"admin.php?p=orders".
					"&action=search".
					"&order_num=".urlencode($order_num).
					"&lname=".urlencode($lname).
					"&status=".urlencode($status).
					"&payment_status=".$payment_status.
					"&period=".$period.
					"&sort_by".$sort_by
			);
		}
		
		$db->query("
			SELECT ".DB_PREFIX."orders.*, ".DB_PREFIX."users.*, DATE_FORMAT(status_date, '".$settings["LocalizationDateTimeFormat"]."') AS sd 
			FROM ".DB_PREFIX."orders 
			INNER JOIN ".DB_PREFIX."users ON ".DB_PREFIX."users.uid=".DB_PREFIX."orders.uid AND ".DB_PREFIX."users.removed='No'
			WHERE ".$where."
			ORDER BY ".DB_PREFIX."orders.".$sort_options[$sort_by]."
			LIMIT ".(($pg-1)* $ccc).", ".$ccc."
		");
?>


<div class="listHeader clearfix">
	<div class="listHeaderIcon"><img src="images/icons/a/zoom.png"/></div>
	<div class="listHeaderCaption">
		Orders Search Results
	</div>
	<div class="listHeaderCaption" style="float:right;font-weight:normal;">
		Orders found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
</div>
<?php
		if ($db->numRows()>0)
		{
?>
<div class="clearfix"></div>
<form name="frmOrders" action="" onSubmit="return false;">
	<table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
		<thead>
			<th class="icon"></th>
			<th style="width:80px;"><?=$status=="Abandon"?"Abandon":"Order"?> ID</th>
			<th>Customer's Name</th>
			<th style="width:200px;">Last Update</th>
			<th style="width:80px;">Status</th>
			<th style="width:80px;">Payment</th>
			<th style="width:80px;text-align:right;">Amount</th>
			<th style="width:80px;text-align:right;">Action</th>
		</thead>
		<tbody>
<?php
			$uid = "";
			while ($db->moveNext())
			{
?>
			<tr>
				<td>
					<input type="checkbox" name="order_<?=$db->col["oid"]?>"/>
					<input type="hidden" name="order_<?=$db->col["oid"]?>_hidden" value="<?=$db->col["oid"]?>"/>
				</td>
				<td>
					<a href="admin.php?p=order&oid=<?=$db->col["oid"]?>">
<?php
				if ($db->col["status"]=="Abandon")
				{
?>
					A<?=$db->col[$status!="Abandon"?"order_num":"oid"]?>
<?php			}
				else
				{
					echo $db->col["order_num"];
					if(isset($first_A))	echo " / A".$db->col["oid"];
				}
?>
					</a> 
				</td>
				<td><a href="admin.php?p=order&oid=<?=$db->col["oid"]?>"><?=htmlspecialchars($db->col["fname"]." ".$db->col["lname"])?></a></td>
				<td><?=$db->col["sd"]?></td>
				<td><?=$db->col["status"]?></td>
				<td><?=$db->col["payment_status"]?></td>
				<td style="text-align:right;"><?=getAdminPrice($db->col["total_amount"]-$db->col['gift_cert_amount'])?></td>
				<td style="text-align:right;">
					<a href="admin.php?p=order&oid=<?=$db->col["oid"]?>"><img title="Order Details" src="images/icons/a/pencil.png" border="0" title="Edit"></a>
					<a href="admin.php?p=order_invoice&orders=<?=$db->col["oid"]?>&printing" target="_print"><img title="Print Invoice" src="images/icons/a/printer.png" border="0"></a>
<?php
				if ($db->col["shipping_carrier_id"]=="usps_domestic" || $db->col["shipping_carrier_id"]=="usps_international")
				{
?>
					<a href="admin.php?p=shipping_label_usps&oid=<?=$db->col["oid"]?>" target="_new"><img title="Print Label" src="images/icons/a/printer.png" border="0"></a>
<?php
				}
?>	
					<a href="JavaScript:ConfirmDeleteOrder(<?=$db->col["oid"]?>)"><img title="Delete Order" src="images/icons/a/delete.png" border="0"></a>
				</td>
			</tr>
<?php
			}
?>
		</tbody>
		<tfoot>
			<tr>
				<td><img src="images/icons/a/arrow_up.png"/></td>
				<td colspan="7">
					<a href="javascript:checkBoxes('check')">check all</a> | 
					<a href="javascript:checkBoxes('uncheck')">uncheck all</a>
				</td>
			</tr>
		</tfoot>
	</table>
</form>

<div class="clearfix"></div>
<form name="frmOrdersStatus" onSubmit="return false;" style="margin:0px;padding:0px;">
	<div style="clear:both;"></div>

	<div class="listForm">
		<div class="listFormLine">
			<label>Set New Order Status</label><br />
			<select name="order_status">
				<option value="">Keep current</option>
				<option value="Process">Process</option>
				<option value="Backorder">Backorder</option>
				<option value="Canceled">Canceled</option>
				<option value="Completed">Completed</option>
			</select>
		</div>
		<div class="listFormLine">
			<label>Set New Payment Status</label><br />
			<select name="payment_status">
				<option value="">Keep current</option>
				<option value="Pending">Pending</option>
				<option value="Received">Received</option>
				<option value="Declined">Declined</option>
				<option value="Canceled">Canceled</option>
				<option value="Error">Error</option>
			</select>
		</div>
		<div class="listFormLine">
			<label for="send_notification_email">Send notification to user when order completed?</label>
			<input type="checkbox" checked="checked" id="send_notification_email" name="send_notification_email" value="yes" />
		</div>
		<div class="listFormLine">
			<div class="admin-form-buttons">
				<input type="button" value="Print selected" onClick="printSelectedOrders();" /> 
				<input type="button" value="Update status" onClick="changeOrdersStatus();" /> 
				<input type="button" value="Delete checked" class="warning" onClick="deleteCheckedOrders();" />
			</div>
		</div>
		<div class="clearfix"></div>
	</div>
</form>

<div class="clearfix"></div>
<div class="listFooter clearfix">
	<div class="listFooterCaption" style="float:left;font-weight:normal;">
		<form action="admin.php?no-acceleration=true&p=backup_restore&action=export&mode=csv&from=orders-search&chart=true" method="POST" target="_blank" name="">
			<input type="hidden" name="export_what" value="orders"/>
			<input type="hidden" name="separator" value=",">
			<input type="hidden" name="decimal_separator" value=".">
			<input type="submit" value="Export to CSV" />
		</form>
	</div>
	<div class="listFooterCaption" style="float:right;font-weight:normal;">
		Orders found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
</div>
<?php
		}
		else
		{
?>
<div class="listEmpty">
	No results were found. Please check search criteria<br/>
	<a href="admin.php?p=orders">Reset Search</a>
</div>
<?php
		}
	}
