<?php

	if (!defined('ENV')) exit();
	
	$payment_method_id = isset($_REQUEST['payment_method_id']) ? $_REQUEST['payment_method_id'] : '';

	$adminView = Ddm_AdminView::getInstance();

	$adminView->assign('isLabeledApp', IS_LABEL ? 1 : 0);

	$paymentMethod = DataAccess_Repository::get('PaymentMethodRepository')->getPaymentMethodById($payment_method_id);

	if ($paymentMethod != null)
	{
		if (DataAccess_Repository::get('PaymentMethodRepository')->methodAvailable($paymentMethod['id']))
		{
			$paymentMethodObject = null;
			
			if ($paymentMethod['type'] == 'cc')
			{
				require_once('content/engine/payment/payment_'.escapeFileName($paymentMethod['id']).'.php');

				//class name suppose to be defined in gateway's file
				$paymentMethodObject = new $payment_processor_class();
			}

			if (isset($_REQUEST['action']))
			{
				switch ($_REQUEST['action'])
				{
					/**
					* Activate payment solution
					*/
					case 'activate' :
					{

						$paypalEnabledPre = Payment_PayPal_PayPalApi::isPayPalEnabled();

						$db->query("UPDATE ".DB_PREFIX."payment_methods SET active='Yes' WHERE id='".$db->escape($payment_method_id)."'");

						$paymentMethod["active"] = "Yes";

						Admin_Flash::setMessage('Selected payment method has been activated');

						$paypalEnabled = Payment_PayPal_PayPalApi::isPayPalEnabled();
						if (!$paypalEnabledPre && $paypalEnabled)
						{
							// Activate financing banner widgets
							$db->query("UPDATE ".DB_PREFIX."layout_elements SET is_active = 1 WHERE name LIKE 'element_panels_panel-paypalbml-%'");
						}
						Admin_Log::log('Payment method '.$payment_method_id.' has been activated', Admin_Log::LEVEL_IMPORTANT);
					}

					/**
					 * Save settings
					 */
					case 'saveAdvancedSettings' :
					case 'saveSettings' :
					{
						/**
						 * Save settings
						 */
						if (isset($_REQUEST['form']) && is_array($_REQUEST['form']))
						{
							$form = $_REQUEST['form'];
							foreach ($paymentMethod['settings'] as $settingsOption)
							{
								$name = $settingsOption['name'];

								if (isset($form[$name]))
								{
									$oldValue = $settings[$name];
									$value = $form[$name];
									$db->query('UPDATE '.DB_PREFIX.'settings SET value="'.$db->escape($value).'" WHERE name="'.$db->escape($name).'"');
									$settings[$name] = $value;
								}
								elseif (isset($_FILES[$name]))
								{
									if (is_uploaded_file($_FILES[$name]['tmp_name']))
									{
										//check image type
										$is = getimagesize($_FILES[$name]['tmp_name']);
										if ($is && in_array($is[2], array(IMAGETYPE_GIF, IMAGETYPE_PNG, IMAGETYPE_JPG, IMAGETYPE_JPEG)))
										{
											$extensions = array(
												IMAGETYPE_GIF => 'gif', 
												IMAGETYPE_PNG => 'png', 
												IMAGETYPE_JPG => 'jpg', 
												IMAGETYPE_JPEG => 'jpg'
											);

											$destination = 'images/payment/'.escapeFileName($name).'.'.$extensions[$is[2]];

											@unlink('images/payment/'.escapeFileName($name).'.jpg');
											@unlink('images/payment/'.escapeFileName($name).'.gif');
											@unlink('images/payment/'.escapeFileName($name).'.png');

											move_uploaded_file($_FILES[$name]['tmp_name'], $destination);
											chmod($destination, getFilePermissionMode());

											$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($destination)."' WHERE name='".$db->escape($name)."'");
											$settings[$name] = $destination;
										}
									}
								}
							}

							if (isset($_REQUEST["payment_method_id"]) && in_array($_REQUEST["payment_method_id"], array('paypaladv', 'paypalpflink')))
							{
								if (isset($_FILES['paypalec_Logo']))
								{
									if (is_uploaded_file($_FILES['paypalec_Logo']['tmp_name']))
									{
										//check image type
										$is = getimagesize($_FILES['paypalec_Logo']['tmp_name']);
										if ($is && in_array($is[2], array(IMAGETYPE_GIF, IMAGETYPE_PNG, IMAGETYPE_JPG, IMAGETYPE_JPEG)))
										{
											$extensions = array(
												IMAGETYPE_GIF => 'gif', 
												IMAGETYPE_PNG => 'png', 
												IMAGETYPE_JPG => 'jpg', 
												IMAGETYPE_JPEG => 'jpg'
											);

											$destination = 'images/payment/'.escapeFileName('paypalec_Logo').'.'.$extensions[$is[2]];

											@unlink('images/payment/'.escapeFileName('paypalec_Logo').'.jpg');
											@unlink('images/payment/'.escapeFileName('paypalec_Logo').'.gif');
											@unlink('images/payment/'.escapeFileName('paypalec_Logo').'.png');

											move_uploaded_file($_FILES['paypalec_Logo']['tmp_name'], $destination);
											chmod($destination, getFilePermissionMode());

											$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($destination)."' WHERE name='".$db->escape('paypalec_Logo')."'");
											$settings['paypalec_Logo'] = $destination;
										}
									}
								}
							}
						}

						/**
						* Set gateway properties 
						*/
						if (isset($_REQUEST["payment_method"]) && is_array($_REQUEST["payment_method"]))
						{
							$data = $_REQUEST["payment_method"];
							$db->reset();
							$db->assignStr('priority', $data['priority']);
							$db->assignStr('name', $data['name']);
							$db->assignStr('title', $data['title']);
							$db->assignStr('message_payment', $data['message_payment']);
							$db->assignStr('message_thankyou', $data['message_thankyou']);

							if (isset($data['url_to_gateway'])) $db->assignStr('url_to_gateway', $data['url_to_gateway']);
							if (isset($data['enable_ccs'])) $db->assignStr('enable_ccs', $data['enable_ccs']);
							if (isset($data['url_to_gateway'])) $db->assignStr('url_to_gateway', $data['url_to_gateway']);

							$db->update(DB_PREFIX.'payment_methods', 'WHERE pid="'.intval($paymentMethod['pid']).'"');
						}

						/**
						* Certificate file 
						*/
						if (array_key_exists("certificate_file", $_FILES) && file_exists($_FILES["certificate_file"]["tmp_name"]))
						{
							$certificate_path = isset($_REQUEST['certificate_path']) ? trim($_REQUEST['certificate_path']) : '';
							if ($certificate_path != "" && is_writable($certificate_path))
							{
								copy($_FILES["certificate_file"]["tmp_name"], $certificate_path);
							}
						}

						Admin_Flash::setMessage('Payment method settings have been updated');

						Admin_Log::log('Payment method "'.$payment_method_id.'" settings have been changed', Admin_Log::LEVEL_IMPORTANT);

						break;
					}

					/**
					* Disable payment solution 
					*/
					case 'disable' :
					{
						$paypalEnabledPre = Payment_PayPal_PayPalApi::isPayPalEnabled();

						$db->query("UPDATE ".DB_PREFIX."payment_methods SET active='No' WHERE `id`='".$db->escape($payment_method_id)."'");
						$paymentMethod["active"] = "No";

						Admin_Flash::setMessage('Selected payment method has been disabled');

						Admin_Log::log('Payment method "'.$payment_method_id.'" settings have been changed', Admin_Log::LEVEL_IMPORTANT);

						$paypalEnabled = Payment_PayPal_PayPalApi::isPayPalEnabled();
						if ($paypalEnabledPre && !$paypalEnabled)
						{
							// Deactivate financing banner widgets
							$db->query("UPDATE ".DB_PREFIX."layout_elements SET is_active = 0 WHERE name LIKE 'element_panels_panel-paypalbml-%'");
						}

						header("Location: admin.php?p=payment_methods".(isset($_REQUEST["last_active_tab"]) ? "&last_active_tab=".urlencode($_REQUEST["last_active_tab"]) : ""));
						break;
					}

					/**
					* Save supported credit card types 
					*/
					case 'saveSupportedCC' :
					{
						$acceptedCCs = isset($_REQUEST["accepted_cc"]) ? $_REQUEST["accepted_cc"] : array();
						$acceptedCCs = is_array($acceptedCCs) ? $acceptedCCs : array();

						foreach ($acceptedCCs as $ccid=>$acceptedCC)
						{
							$db->reset();
							$db->assignStr("enable", isset($acceptedCC["enable"]) ? "Yes" : "No");
							$db->assignStr("code", $acceptedCC["code"]);
							$db->assignStr("name", $acceptedCC["name"]);
							$db->assignStr("enable_cvv2", isset($acceptedCC["enable_cvv2"]) ? "Yes" : "No");
							$db->update(DB_PREFIX."payment_accepted_cc", "WHERE ccid='".intval($ccid)."'");
						}

						Admin_Log::log('Payment method "'.$payment_method_id.'" supported CC have been changed', Admin_Log::LEVEL_IMPORTANT);

						break;
					}

					/**
					* Add a new supported card type 
					*/
					case 'addSupportedCC' :
					{
						$acceptedCC = isset($_REQUEST["new_accepted_cc"]) ? $_REQUEST["new_accepted_cc"] : array();
						$db->reset();
						$db->assignStr("pid", $paymentMethod["pid"]);
						$db->assignStr("enable", isset($acceptedCC["enable"]) ? "Yes" : "No");
						$db->assignStr("code", $acceptedCC["code"]);
						$db->assignStr("name", $acceptedCC["name"]);
						$db->assignStr("enable_cvv2", isset($acceptedCC["enable_cvv2"]) ? "Yes" : "No");
						$ccid = $db->insert(DB_PREFIX."payment_accepted_cc");

						Admin_Log::log('Payment method "'.$payment_method_id.'" supported CC have been changed', Admin_Log::LEVEL_IMPORTANT);
						break;
					}

					/**
					* Delete supported CC type 
					*/
					case 'deleteSupportedCC' :
					{
						$ccid = isset($_REQUEST['ccid']) ? $_REQUEST['ccid'] : 0;
						$db->query('DELETE FROM payment_accepted_cc WHERE ccid='.intval($ccid));

						Admin_Log::log('Payment method "'.$payment_method_id.'" supported CC have been changed', Admin_Log::LEVEL_IMPORTANT);

						break;
					}			
				}

				/**
				* Check for PayPal Express Checkout Boarding
				*/
				if (!DEMO_LOCK && (AccessManager::checkAccess('PAYMENT_PAYPAL_BASIC') || AccessManager::checkAccess('PAYMENT_PAYPAL_ALL')) && 
					((in_array($_REQUEST['action'], array('activate', 'saveAdvancedSettings', 'saveSettings')) && in_array($payment_method_id, array('paypalipn', 'paypalpro', 'paypalpflink', 'paypaladv'))) || isset($_POST["paypalEC"]))
				)
				{
					if (isset($_POST['paypalECEmail']))
					{
						$ecParams = array(
							'paypalec_Email' => $_POST['paypalECEmail'],
							'paypalec_Payment_Action' => 'Sale'
						);

						foreach ($ecParams as $ecOptionName=>$ecOptionValue)
						{
							$db->query('UPDATE '.DB_PREFIX.'settings SET value="'.$db->escape($ecOptionValue).'" WHERE name="'.$db->escape($ecOptionName).'"');
						}
					}

					$db->reset();
					$db->assignStr('active', 'Yes');
					$db->update(DB_PREFIX.'payment_methods', 'WHERE id="paypalec"');

					Admin_Log::log('Payment method paypalec has been activated', Admin_Log::LEVEL_IMPORTANT);
				}

				/**
				 * Reread with changes
				 */
				$paymentMethod = DataAccess_Repository::get('PaymentMethodRepository')->getPaymentMethodById($payment_method_id);
			}

			$adminView->assign('paymentMethod', $paymentMethod);
			$adminView->assign('settings', $settings);

			$adminView->assign('supportCC', $supportCC = $paymentMethod["type"] == "cc" && !is_null($paymentMethodObject) && $paymentMethodObject->support_accepted_cc);

			/**
			* Generate settings form from settings table
			*/
			$editableFormBuilders = array();
			$staticFormBuilder = new core_Form_FormBuilder('static', array('label' => 'Properties', 'class' => 'ic-payment', 'first' => true));
			foreach ($paymentMethod['settings'] as $settingsOption)
			{
				$groupId = $settingsOption['group_id'];

				if (!isset($editableFormBuilders[$groupId]))
				{
					$editableFormBuilders[$groupId] = new core_Form_FormBuilder('editable'.$groupId, array('label' => 'Properties', 'class' => 'ic-payment', 'first' => $groupId==0));
				}

				switch ($settingsOption['input_type'])
				{
					case 'text' :
					{
						$editableFormBuilders[$groupId]->add('form['.$settingsOption['name'].']', 'text', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'], 'note' => $settingsOption['description']));
						if ($groupId == 0) $staticFormBuilder->add('static['.$settingsOption['name'].']', 'static', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'] == "" ? "-" : $settingsOption['value']));
						break;
					}
					case 'password' :
					{
						$passwd =  str_repeat('*', strlen($settingsOption['value']));
						$editableFormBuilders[$groupId]->add('form['.$settingsOption['name'].']', 'password', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'], 'note' => $settingsOption['description']));
						if ($groupId == 0) $staticFormBuilder->add('static['.$settingsOption['name'].']', 'static', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $passwd == "" ? "-" : $passwd));
						break;
					}
					case 'color' :
					{
						$editableFormBuilders[$groupId]->add('form['.$settingsOption['name'].']', 'color', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'], 'note' => $settingsOption['description']));
						if ($groupId == 0) $staticFormBuilder->add('static['.$settingsOption['name'].']', 'static', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'] == "" ? "-" : $settingsOption['value']));
						break;
					}
					case 'textarea' :
					{
						$editableFormBuilders[$groupId]->add('form['.$settingsOption['name'].']', 'textarea', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'], 'note' => $settingsOption['description']));
						if ($groupId == 0) $staticFormBuilder->add('static['.$settingsOption['name'].']', 'static', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'] == "" ? "-" : $settingsOption['value']));
						break;
					}
					case 'label' :
					{
						$editableFormBuilders[$groupId]->add('form['.$settingsOption['name'].']', 'static', array('label' => $settingsOption['caption'], 'value' => $settingsOption['value'], 'note' => $settingsOption['description']));
						if ($groupId == 0) $staticFormBuilder->add('static['.$settingsOption['name'].']', 'static', array('label' => $settingsOption['caption'], 'value' => $settingsOption['value'] == "" ? "-" : $settingsOption['value']));
						break;
					}
					case 'hidden' :
					{
						$editableFormBuilders[$groupId]->add('form['.$settingsOption['name'].']', 'hidden', array('value' => $settingsOption['value']));
						if ($groupId == 0) $staticFormBuilder->add('static['.$settingsOption['name'].']', 'hidden', array('value' => $settingsOption['value'] == "" ? "-" : $settingsOption['value']));
						break;
					}
					case 'select' :
					{
						$fieldOptionsArray = explode(',', $settingsOption['options']);
						$fieldOptions = array();

						foreach ($fieldOptionsArray as $fieldOption)
						{
							if (strpos($settingsOption['name'], 'Currency_Code') !== false)
							{
								$fieldOptions[] = new core_Form_Option(trim($fieldOption), $fieldOption);
							}
							else
							{
								$fieldOptions[] = new core_Form_Option(trim($fieldOption), ucwords(strtolower($fieldOption)));
							}
						}

						$editableFormBuilders[$groupId]->add('form['.$settingsOption['name'].']', 'choice', array('label' => $settingsOption['caption'], 'required'=>false, 'value' => $settingsOption['value'], 'options' => $fieldOptions, 'note' => $settingsOption['description']));
						if ($groupId == 0) $staticFormBuilder->add('static['.$settingsOption['name'].']', 'static', array('label' => $settingsOption['caption'], 'required'=>false, 'value'=>ucwords(strtolower($settingsOption['value']))));
						break;
					}
					case 'image' :
					{
						$editableFormBuilders[$groupId]->add($settingsOption['name'], 'file', array('label' => $settingsOption['caption'], 'note' => $settingsOption['description']));
						if ($settingsOption['value'] != '')
						{
							$editableFormBuilders[$groupId]->add(
								'form[preview_'.$settingsOption['name'].']', 'imagepreview', 
								array('label' => 'Current image', 'value' => $settingsOption['value'], 'note' => 'Click over image to see it real size')
							);
						}
						break;
					}
				}
			}

			if (isset($_REQUEST["payment_method_id"]) && in_array($_REQUEST["payment_method_id"], array('paypaladv', 'paypalpflink')))
			{
				$db->query('SELECT * FROM '.DB_PREFIX.'settings WHERE name =\'paypalec_Logo\'');
				if ($settingsOption = $db->moveNext())
				{
					$editableFormBuilders[$groupId]->add($settingsOption['name'], 'file', array('label' => $settingsOption['caption'], 'note' => $settingsOption['description']));
					if ($settingsOption['value'] != '')
					{
						$editableFormBuilders[$groupId]->add(
							'form[preview_'.$settingsOption['name'].']', 'imagepreview', 
							array('label' => 'Current image', 'value' => $settingsOption['value'], 'note' => 'Click over image to see it real size')
						);
					}
				}
			}

			$editableForms = array();
			foreach ($editableFormBuilders as $groupId=>$editableFormBuilder)
			{
				$editableForms[$groupId] = $editableFormBuilder->getForm();
			}

			$adminView->assign('editableForm', $editableForms);

			$staticForm = $staticFormBuilder->getForm();
			$adminView->assign('staticForm', $staticForm);

			/**
			* Generate advanced settings form 
			*/
			$advancedFormBuilder = new core_Form_FormBuilder('advanced');

			/**
			* Form / presentation settings
			*/
			$advancedPresentationFormBuilder = new core_Form_FormBuilder('advanced-presentation', array('label' => 'Form/Presentation Settings', 'class' => 'ic-document', 'first'=>true));
			$advancedFormBuilder->add($advancedPresentationFormBuilder);

			$priorityOptions = array();

			for ($i=1; $i<=10; $i++) $priorityOptions[] = new core_Form_Option($i, $i);

			$advancedPresentationFormBuilder->add('payment_method[priority]', 'choice', array(
				'label' => 'Priority',
				'options' => $priorityOptions, 'value' => $paymentMethod['priority'],
				'attr' => array('class' => 'short'),
				'note' => 'Priority is used to sort available payment methods in the Select Payment Method drop-down box'
			));

			// Title
			$advancedPresentationFormBuilder->add('payment_method[name]', 'text', array(
				'label' => 'Payment method name',
				'value' => $paymentMethod['name'],
				'note' => 'This is the text that will help customers identify this payment method. It will appear in the Payment Selection area.',
				'required'=>true
			));

			$advancedPresentationFormBuilder->add('payment_method[title]', 'text', array(
				'label' => 'Payment form title',
				'value' => $paymentMethod['title'],
				'note' => 'This is the text that will help customers identify this payment method if it is selected. It will appear on the Payment Form.',
				'required' => true
			));

			$advancedPresentationFormBuilder->add('payment_method[message_payment]', 'textarea', array(
				'label' => 'Payment page message / instructions',
				'value' => $paymentMethod['message_payment'],
				'note' => 'Message you would like to appear on the Payment Page'
			));

			$advancedPresentationFormBuilder->add('payment_method[message_thankyou]', 'textarea', array(
				'label' => 'Thank you page message / instructions',
				'value' => $paymentMethod['message_thankyou'],
				'note' => 'Message you would like to appear on the Thank You Page'
			));

			/**
			 * Payment Server Settings
			 */
			$ccs = !is_null($paymentMethodObject) && $paymentMethodObject->support_ccs && $settings['SecurityCCSActive'] == '1' && (AccessManager::checkAccess('CCS'));

			if ($paymentMethod['type'] != 'custom' || $ccs)
			{
				$advancedOtherFormBuilder = new core_Form_FormBuilder('advanced-other', array('label' => 'Other Settings', 'class' => 'ic-server', 'no-collapsable'=>true));

				// CCS 
				if ($ccs)
				{
					$ccsOptions = array(new core_Form_Option('1', 'Yes'), new core_Form_Option('0', 'No'));

					$advancedOtherFormBuilder->add('payment_method[enable_ccs]', 'choice', array(
						'label' => 'Enable CCS',
						'options' => $ccsOptions, 'value' => $paymentMethod['enable_ccs'],
						'attr' => array('class' => 'short'),
						'note' => 'Select "Yes" if you want to enable CCS'
					));
				}

				// URL
				if ($paymentMethod['type'] != 'custom' && substr($paymentMethod['id'], 0, strlen('paypal')) != 'paypal' && $paymentMethod['id'] != 'cart_ccs')
				{
					$advancedOtherFormBuilder->add('payment_method[url_to_gateway]', 'text', 
						array(
							'label' => 'URL to gateway', 'value' => $paymentMethod["url_to_gateway"],
							'note' => 'Changing this URL may disable your gateway. You should never need to change this information unless you have been notified to do so by your gateway company'
						)
					);
				}

				// Certificate
				if (!is_null($paymentMethodObject) && is_object($paymentMethodObject) && $paymentMethodObject->is_certificate)
				{
					$cfile = 'content/engine/payment/'.$paymentMethodObject->certificate_path;
					$cdir = dirname($cfile);

					if (!is_dir($cdir) || !is_writable($cdir))
					{
						$advancedOtherFormBuilder->add('certificate_file_error', 'static', 
							array(
								'label' => 'Certificate File'.($paymentMethodObject->certificate_optional?' (optional)':''), 
								'value' => '<strong><span style="color:#dd0000;">Certificate directory is not writable ('.$cdir.'). Please change directory permissions.</span></strong>'
							)
						);
					}
					elseif (file_exists($cfile) && !is_writable($cfile))
					{
						$advancedOtherFormBuilder->add('certificate_file_error', 'static', 
							array(
								'label' => 'Certificate File', 
								'value' => '<strong><span style="color:#dd0000;">File is not writable ('.$cfile.'). Please change file permissions to add/update file.</span></strong>'
							)
						);
					}
					else
					{
						$note = 'This gateway requires a Security Certificate to work properly.<br/>Typically, this will be located in the "My Account" area of most gateway providers.';
						if ($paymentMethodObject->certificate_optional)
						{
							$note = 'Optional: this gateway can be configured with a Security Certificate.<br/>Typically, this will be located in the "My Account" area of most gateway providers.';
						}

						$advancedOtherFormBuilder->add('certificate_file', 'file', 
							array(
								'label' => 'Certificate File',
								'note' => $note
							)
						);
						$advancedOtherFormBuilder->add('certificate_path', 'hidden', array('value' => $cfile));
					}

					if (file_exists($cfile))
					{
						$advancedOtherFormBuilder->add('certificate_file_current', 'static', 
							array(
								'label' => 'Current Certificate',
								'value' => $cfile,
								'note' => 'File Size: '.filesize($cfile).' bytes. File change time: '.date("F j, Y, g:i a", filemtime($cfile))
							)
						);
					}
				}

				if ($advancedOtherFormBuilder->childCount() > 0)
				{
					$advancedFormBuilder->add($advancedOtherFormBuilder);
				}
			}

			// Render advance settings form
			$advancedForm = $advancedFormBuilder->getForm();
			$adminView->assign('advancedForm', $advancedForm);

			pageHeader('Payment Settings - '.$paymentMethod['name']);
			
			if ($paymentMethod['id'] == 'cart_ccs' && $settings['SecurityCCSActive'] == '0')
			{
				pageNote(array(
					array('class' => 'ic-info', 'text' => '<strong>To use this payment method you have to activate Credit Card Storage and generate security certificate</strong>'),
					array('class '=> '', 'text' => 'Click here to go to CCS settings page', 'url' => 'admin.php?p=settings_ccs')
				));
				exit;
			}
			
			echo '&nbsp;';

			$last_active_tab = isset($_REQUEST['last_active_tab']) ? $_REQUEST['last_active_tab'] : '';

			echo '<div id="tabs-payment-method" class="admin-tabs admin-tabs-framed">';

			$templatesPath = 'content/admin/skins/default/templates/pages/payment/solutions/'.escapeFileName($payment_method_id).'/';
			$initialSetupFile = $templatesPath.'initial-setup.html';
			$instructionsFile = $templatesPath.'instructions.html';
			$advancedSettingsFile = $templatesPath.'advanced-settings.html';
			$methodFile = $templatesPath.'method.html';

			/**
			 * PayPal EC Cross sell
			 */
			if (!in_array($payment_method_id, array('paypalipn', 'paypalpro', 'paypalpflink', 'paypalec', 'paypaladv')))
			{
				$db->query('SELECT * FROM '.DB_PREFIX.'payment_methods WHERE id="paypalec" AND active="Yes"');
				$paypalExpressCheckoutActive = $db->moveNext();

				if (!$paypalExpressCheckoutActive && (AccessManager::checkAccess('PAYMENT_PAYPAL_BASIC') || AccessManager::checkAccess('PAYMENT_PAYPAL_ALL')))
				{
					$adminView->assign('admin_email', $admin['email']);
					$paypalECForm = $adminView->fetch('pages/payment/paypal-ec-form');

					$adminView->assign('paypalECForm', $paypalECForm);
				}
			}

			if ($paymentMethod['active'] == 'No' && is_file($initialSetupFile))
			{
				pageTabs(array(
					array('title' => 'Payment Settings', 'id' => 'main')
				), 'tabs-payment-method', $last_active_tab);

				echo $adminView->render('pages/payment/solutions/'.escapeFileName($payment_method_id).'/initial-setup');
			}
			else
			{
				if (is_file($instructionsFile))
				{
					$adminView->assign('instructionsFile', $a = 'templates/pages/payment/solutions/'.escapeFileName($payment_method_id).'/instructions.html');
				}

				if (is_file($advancedSettingsFile))
				{
					$adminView->assign('advancedSettingsFile', $a = 'templates/pages/payment/solutions/'.escapeFileName($payment_method_id).'/advanced-settings.html');
				}

				pageTabs(array(
					array('title' => 'Payment Settings', 'id' => 'main'),
					array('title' => 'Additional Settings', 'id' => 'advanced-settings'),
					array('title' => 'Supported Credit Card Types', 'id' => 'supported-cards', 'visible' => $supportCC)
				), 'tabs-payment-method', $last_active_tab);

				if (is_file($methodFile))
				{
					$adminView->render('pages/payment/solutions/'.escapeFileName($payment_method_id).'/method');
				}
				else
				{
					$adminView->render('pages/payment/method');
				}
			}

			echo '</div>';

		}
		else
		{
			AccessManager::notAllowed();
		}
	}
