<?php
	if (!defined("ENV")) exit();
    unset($msg_alert);// Alert message array
	
	pageHeader("Payment Methods", "Quick Setup", "icb-payment");
	
	$adminView = Ddm_AdminView::getInstance();
	
	$adminView->assign('isLabeledApp', IS_LABEL ? 1 : 0);
	
	pageNote(array(
		array("class"=>"ic-info", "text"=>"Use this section to select and create payment methods for your website to process your customer's purchases. You can create a Custom Payment Method if none of our Supported Payment Methods meet your needs. Activate the Cardinal Centinel Module to take advantage of Verified by Visa in our Supported Payment Methods.", "url"=>"", "visible"=>true),
		array("class"=>"ic-add", "class"=>"ic-add", "text"=>"<b>Add a New Custom Payment Method</b>", "url"=>"admin.php?p=payment_method_custom&mode=insert", "visible"=>true),
        array("class"=>"ic-cardinal", "text"=>"<b>Setup Cardinal Centinel Module</b>", "url"=>"admin.php?p=payment_cardinal", "visible"=>AccessManager::checkAccess('CARDINAL_CENTINEL')),
	));
	
	loadjs("payment.js");
	
	$businessLocations = array(
		"US" => "United States of America",
		"CA" => "Canada",
		"GB" => "United Kingdom",
		"AU" => "Australia",
		"" => "Global / Other countries"
	);
	
	$action = isset($action)?trim($action):"";
	
	switch ($action)
	{
		/**
		 * Update active payment gateways priority 
		 */
		case "updatePriority" :
		{
			$priority = isset($priority)?$priority:array();
			reset($priority);

			foreach ($priority as $pid=>$value)
			{
				$db->reset();
				$db->assignStr("priority", $priority[$pid]);
				$db->update(DB_PREFIX."payment_methods", "WHERE pid='".$pid."'");
			}

			$msg_alert[]= "Payment Methods settings have been successfully updated.";
			break;
		}
		
		/**
		 * Change business location filter
		 */
		case "setBusinessLocation" :
		{
			$_SESSION["businessLocation"] = isset($_REQUEST["businessLocation"]) ? $_REQUEST["businessLocation"] : "US";
			break;
		}
	}

	$adminView->assign('businessLocations', $businessLocations);
	
	$businessLocation = isset($_SESSION["businessLocation"]) ? $_SESSION["businessLocation"] : "US";
	$adminView->assign('currentBusinessLocation', $businessLocation);
	$adminView->assign('currentBusinessLocationName', $businessLocations[$businessLocation]);
	
	if (isset($msg_alert))
	{
		foreach ($msg_alert as $key => $val)
		{
			if (strlen($val)>0)
			{
				pageNote(array(
					array("class"=>"ic-info", "text"=>"<span style=\"color:#990000\"><b>$val</b></a>", "url"=>"", "visible"=>true)
				));
			}
		}
	}
?>
<form id="frmActivatePayPal" action="admin.php?p=payment_method&mode=update" method="post">
	<input type="hidden" name="action" value="enable"/>
	<input type="hidden" name="last_active_tab" value="settings"/>
	<input type="hidden" name="pid"/>
</form>
<div class="admin-tabs admin-tabs-framed" id="tabs-payment">
<?php 
	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"settings";
	pageTabs(array(
		array("title"=>"Payment Configuration", "id"=>"settings"),
		array("title"=>"Manage Payment Options", "id"=>"active"),
		array("title"=>"Signup For a Payment Processing Account", "id"=>"signup")
	), "tabs-payment", $last_active_tab);		
?>
	<div id="admin-tab-sheet-settings" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			
<?php

	$paymentMethodsGroups = DataAccess_Repository::get('PaymentMethodRepository')->getPaymentMethodsGroups();
			
	$adminView->assign('paymentMethodsGroups', $paymentMethodsGroups);
	$adminView->assign('paymentMethods', DataAccess_Repository::get('PaymentMethodRepository')->getPaymentMethods());
	$adminView->assign('eOnlineDataAvailable', DataAccess_Repository::get('PaymentMethodRepository')->methodAvailable('authorizenet'));
	$adminView->assign('paypalAdvancedAvailable', DataAccess_Repository::get('PaymentMethodRepository')->methodAvailable('paypaladv'));
	$adminView->assign('paypalProAvailable', DataAccess_Repository::get('PaymentMethodRepository')->methodAvailable('paypalpro'));
	
	echo $adminView->render('pages/payment/methods');
?>

		</div>
	</div>
	<div id="admin-tab-sheet-active" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form name="frmPaymentMethods" action="admin.php?p=payment_methods&last_active_tab=active" method="post">
				<input type="hidden" name="action" value="updatePriority">
				<input type="hidden" name="last_active_tab" value="active"/>
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Active Payment Gateways</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
							<th>Payment Solution</th>
							<th style="width:150px;">Priority</th>
							<th style="width:100px;">Active</th>
							<th style="width:100px;">&nbsp;</th>
						</tr>
					</thead>
					<tbody>		
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE active='Yes' OR type='custom' ORDER BY priority, gateway_name");
		
	if ($db->numRows()>0)
	{
?>
				
<?php
		while ($db->moveNext())
		{
?>
						<tr>
							<td class="icon"><span class="icon ic-icon ic-server"></span></td>
							<td><a href="admin.php?p=payment_method<?php echo $db->col["type"] == 'custom' ? '_custom' : '';?>&mode=update&payment_method_id=<?=$db->col["id"]?>""><?php echo htmlspecialchars($db->col["gateway_name"]);?></a></td>
							<td>
								<select name="priority[<?=$db->col["pid"]?>]" class="tiny">
<?php
			for ($i=1; $i<=10; $i++)
			{
				echo '<option value="'.$i.'" '.($db->col["priority"]==$i?"selected":"").'>'.$i.'</option>';
			}
?>		
								</select>
							</td>
							<td><?php echo $db->col["active"];?></td>
							<td align="right">
								<a href="admin.php?p=payment_method<?php echo $db->col["type"] == 'custom' ? '_custom' : '';?>&mode=update&payment_method_id=<?=$db->col["id"]?>"><img src="images/icons/a/pencil.png" border="0" title="Update payment method settings"></a>
<?php				
					if ($db->col["type"] == "custom")
					{
?>
								<a href="javascript:ConfirmDeletePaymentMethod('<?php echo htmlspecialchars($db->col["id"]);?>')" title="Delete this custom payment method"><span class="icon ic-icon ic-delete"></span></a>
<?php				}
					else
					{
?>
								<a href="javascript:ConfirmDisablePaymentMethod('<?php echo htmlspecialchars($db->col["id"]);?>')" title="Disable this payment solution"><span class="icon ic-icon ic-delete"></span></a>			
<?php
					}
?>			
							</td>
						</tr>
<?php
				}
?>
					</tbody>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
<?php		}
			else
			{
?>
						<tr>
							<td class="icon">&nbsp;</td>
							<td colspan="5">
								You currently do not have an active payment method.
							</td>
						</tr>
					</tbody>
				</table>
<?php
			}
?>					
			</form>
		</div>
	</div>
<?php 
	require_once("content/admin/admin_merchant_signup.php");
?>		
</div>
