<?php 
	if (!defined("ENV")) exit();

	$adminView = Ddm_AdminView::getInstance();

	$secondary_images_count = 0;
	if ($mode == 'update' || $mode == 'insert')
	{
		$db->query("SELECT * FROM ".DB_PREFIX."products_images WHERE pid='".$pid."' ORDER BY iid");
		$records = $db->getRecords();
		$secondary_images_count = count($records);
		$secondary_images = array();
	
		$settings["CatalogThumbSize"] = $settings["CatalogThumbSize"] > 160 ? 160 : $settings["CatalogThumbSize"];
		if ($secondary_images_count > 0)
		{
			$i = 0;
			foreach ($records as $secondary_image)
			{
				$i++;
				$x = $secondary_image["width"];
				$y = $secondary_image["height"];

				$img_src = $product_secondary_images_dir."/".$secondary_image["filename"].".".$secondary_image["type"];
				$img_thumb = $product_secondary_images_dir."/thumbs/".$secondary_image["filename"].".jpg";
				$image_priority = $secondary_image["image_priority"];

				if (file_exists($img_thumb))
				{
					$img_img = $img_thumb;
				}
				else
				{
					$img_img = $img_src;
				}

				$is_img = @getImageSize($img_src);
				$is_thumb = @getImageSize($img_img);

				if($is_thumb[0] > $is_thumb[1])
				{
					$image_size = 'width="'.$settings["CatalogThumbSize"].'"';
				}
				else
				{
					$image_size = 'height="'.$settings["CatalogThumbSize"].'"';
				}
				$secondary_image['img_src'] = $img_src;
				$secondary_image['img_thumb'] = $img_thumb;
				$secondary_image['image_priority'] = $image_priority;
				$secondary_image['img_img'] = $img_img;
				$secondary_image['is_img'] = $is_img;
				$secondary_image['is_thumb'] = $is_thumb;
				$secondary_image['image_size'] = $image_size;

				$secondary_image['filesize'] = number_format(@filesize($img_src)/1024, 2, ".", ",");

				$secondary_images[] = $secondary_image;
			}
		}
	}

	$adminView->assign('pid', $pid);
	$adminView->assign('mode', $mode);
	$adminView->assign('secondary_images', $secondary_images);
	$adminView->assign('secondary_images_count', $secondary_images_count);
	$adminView->assign('product_delete_secondary_image_nonce', create_nonce('product_delete_secondary_image'));

	$formBuilder = new core_Form_FormBuilder('secondary-images', array('label' => 'Upload New Secondary Image(s)', 'class' => 'ic-upload', 'first' => true));

	for ($i = 1; $i <= 3; $i++)
	{
		$formBuilder->add('secondary_image_'.$i, 'file', array('label' => 'Upload secondary image file '.$i));
		$formBuilder->add('secondary_image_alt_text_'.$i, 'text', array('label' => 'Image Alt Text'));
		$formBuilder->add('secondary_image_visible_'.$i, 'checkbox', array('label' => 'Is this image visible on user site?', 'value' => 'Yes', 'current_value' => 'Yes'));
	}

	$form = $formBuilder->getForm();

	$adminView->assign('form', $form);

	$adminView->render('pages/product/secondary-images-tab');
