<?php
	if (!defined('ENV') || $mode == 'insert') exit();
	
	require_once('content/classes/class.qr.php');
	require_once('content/classes/class.offsite_commerce_campaigns.php');
	
	$qr = new QR($settings);
	
	$offsite_commerce_campaigns = new OffsiteCommerceCampaigns($db, $settings);
	$campaigns = $offsite_commerce_campaigns->getCampaigns('qr');
	
	loadJS('qr-product.js');

	$adminView = Ddm_AdminView::getInstance();

	$formBuilder = new core_Form_FormBuilder('qr-codes', array('label' => 'QR Codes for this product', 'class' => 'ic-raster', 'first' => true));

	$campaignOptions = array();
	$campaignOptions[] = new core_Form_Option('', 'No campaign');
	if ($campaigns)
	{
		foreach ($campaigns as $campaign)
		{
			$campaignOptions[$campaign['campaign_id']] = $campaign['name'];
		}
	}
	$formBuilder->add('qr_campaign_id', 'choice', array('label' => 'Campaign', 'options' => $campaignOptions));

	$formBuilder->add('qr_generate_product_url_type', 'choice', array('label' => 'Product Url Type', 'options' => array(
			'product' => 'Product page',
			'cart' => 'Add product to cart',
		)		
	));

	$formBuilder->add('qr_generate_image_type', 'choice', array('label' => 'Image type', 'value' => $settings['qr_image_type'], 'options' => array(
			IMAGETYPE_PNG => 'PNG',
			IMAGETYPE_JPG => 'JPG',
			IMAGETYPE_GIF => 'GIF',
		)
	));
	$formBuilder->add('qr_generate_media', 'choice', array('label' => 'Media', 'value' => $settings['qr_media'], 'options' => array(
			'1' => 'Web - Small',
			'2' => 'Web - Big',
			'3' => 'Print Ad - Small',
			'4' => 'Print Ad - Big',
			'5' => 'Parcel Label',
			'6' => 'Factory Environment',
			'0' => 'Custom',
		)
	));

	$formBuilder->add(
		'qr_generate_error_check', 'choice',
		array(
			'label' => 'Error Correction Level',
			'value' => $settings['qr_error_check'],
			'options' => array(
				'L' => 'Low',
				'M' => 'Medium',
				'Q' => 'Good',
				'H' => 'The best',
			),
			'tooltip' =>
				'Low - approx. 7% of codewords can be restored.<br/>'.
				'Medium - approx. 15% of codewords can be restored.<br/>'.
				'Good - approx. 25% of codewords can be restored.<br/>'.
				'The best - approx. 30% of codewords can be restored.'
		)
	);

	$qr_sizes = array();

	for ($i = 4; $i <= 12; $i++)
	{
		$qr_sizes[$i] = $i;
	}

	$formBuilder->add('qr_generate_default_size', 'choice', array('label' => 'Pixels per QR Code Dot', 'value' => $settings['qr_default_size'], 'options' => $qr_sizes, 'tooltip' => 'QR Code dot size in pixels'));

	$form = $formBuilder->getForm();

	$adminView->assign('form', $form);

	$adminView->render('pages/product/product-qr-tab');