<?php
	if (!defined("ENV") || $mode == "insert") exit();
	
	require_once('content/classes/class.offsite_commerce_campaigns.php');
	
	$offsite_commerce_campaigns = new OffsiteCommerceCampaigns($db, $settings);
	$campaigns = $offsite_commerce_campaigns->getCampaigns("wg");
	
	loadJS('widgets-product.js');

	$adminView = Ddm_AdminView::getInstance();

	$formBuilder = new core_Form_FormBuilder('off-site', array('label' => 'Off-Site Widgets', 'class' => 'ic-window', 'first' => true));

	$campaignOptions = array();
	$campaignOptions[] = new core_Form_Option('', 'No campaign');
	if ($campaigns)
	{
		foreach ($campaigns as $campaign)
		{
			$campaignOptions[$campaign['campaign_id']] = $campaign['name'];
		}
	}
	$formBuilder->add('widget_campaign_id', 'choice', array('label' => 'Campaign', 'options' => $campaignOptions));

	$formBuilder->add('form[widgets_type]', 'choice', array('label' => 'Select widget type', 'value' => $settings['widgets_type'], 'options' => array(
			'page' => 'Product page',
			'cart' => 'Add product to cart',
		)
	));
	$formBuilder->add('form[widgets_image_type]', 'choice', array('label' => 'Select product image', 'value' => $settings["widgets_image_type"], 'options' => array(
			'product' => 'Product page image',
			'thumb' => 'Thumbnail',
			'none' => 'No image',
		)
	));
	$formBuilder->add('form[widgets_style]', 'choice', array('label' => 'Select widget style', 'value' => $settings["widgets_style"], 'options' => array(
			'1' => '300x250',
			'2' => '600x100',
			'3' => '160x300'
		)
	));

	$form = $formBuilder->getForm();
	$adminView->assign('form', $form);

	$adminView->render('pages/product/product-widgets-tab');