<?php
	if (!defined("ENV")) exit();
?>
<div class="admin-form-header">
	<div class="admin-form-header-buttons">
		<a href="<?php echo $_SERVER["PHP_SELF"]."?".($_SERVER["QUERY_STRING"]);?>&printing" target="_blank" title="Print Report"><span class="icon ic-icon ic-printer"></span></a>
	</div>
	<span class="icon ic-icon ic-list"></span>Orders by Products (<?php echo GetReportDate();?>)
</div>
<?php
	$db->query("
		SELECT 
			oc.*,
			SUM(oc.admin_price * oc.admin_quantity) AS product_amount,
			SUM(oc.admin_quantity) AS product_quantity,
			SUM(oc.admin_price * oc.admin_quantity * o.gift_cert_amount / o.total_amount) AS gift_cert_amount,
			SUM(oc.admin_price * oc.admin_quantity * (1 - o.gift_cert_amount / o.total_amount)) AS total_amount
		FROM ".DB_PREFIX."orders_content oc
		INNER JOIN ".DB_PREFIX."orders o ON o.oid = oc.oid
		WHERE 
			o.removed='No' AND
			o.placed_date >= '".$mysql_from."' AND
			o.placed_date <= '".$mysql_to."' AND
			o.status='Completed' AND
			o.payment_status='Received'
		GROUP BY oc.pid
		ORDER BY
			product_amount DESC
	");
	
	if ($db->numRows() > 0)
	{
?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table admin-stat-table">
	<thead>
		<tr>
			<th class="item-num">#</th>
			<th width="20%">Product ID</th>
			<th>Product Name</th>
			<th class="text-align-right" width="10%">Items Sold</th>
			<th class="text-align-right" width="10%">Subtotal</th>
			<th class="text-align-right" width="10%">Gift Certificate</th>
			<th class="text-align-right" width="10%">Total</th>
		</tr>
	</thead>
	<tbody>
<?php
		$subtotal = 0;
		$giftCert = 0;
		$total = 0;
		$i = 0;
		
		while ($db->moveNext())
		{
			$subtotal += $db->col["product_amount"];
			$giftCert += $db->col['gift_cert_amount'];
			$total += $db->col['total_amount'];
?>
		<tr>
			<td class="item-num"><?php echo $i+1;?></td>
			<td><?php echo gs($db->col["product_id"]);?></td>
			<td><?php echo gs($db->col["title"]);?></td>
			<td class="text-align-right"><?php echo $db->col["product_quantity"];?></td>
			<td class="text-align-right"><?php echo getAdminPrice($db->col["product_amount"]);?></td>
			<td class="text-align-right"><?php if ($db->col["gift_cert_amount"] > 0) { ?>-<?php } ?><?php echo getAdminPrice($db->col["gift_cert_amount"]);?></td>
			<td class="text-align-right"><?php echo getAdminPrice($db->col["total_amount"]);?></td>
		</tr>

<?php
			$i++;
		}
?>
	</tbody>
	<tfoot>
		<tr>
			<td colspan="4" class="text-align-right">Total:</td>
			<td class="text-align-right"><?php echo getAdminPrice($subtotal);?></td>
			<td class="text-align-right"><?php if ($giftCert > 0) { ?>-<?php } ?><?php echo getAdminPrice($giftCert);?></td>
			<td class="text-align-right"><?php echo getAdminPrice($total);?></td>
		</tr>
	</tfoot>
</table>
<?php
	}
	else
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"No data available for selected period", "url"=>"", "visible"=>true)
		));
	}
