<?php
	if (!defined("ENV")) exit();
?>
<div class="admin-form-header">
	<div class="admin-form-header-buttons">
		<a href="<?php echo $_SERVER["PHP_SELF"]."?".($_SERVER["QUERY_STRING"]);?>&printing" target="_blank" title="Print Report"><span class="icon ic-icon ic-printer"></span></a>
	</div>
	<span class="icon ic-icon ic-list"></span>Top QR Campaigns (<?php echo GetReportDate();?>)
</div>
<?php

	/**
	 * Select incomming traffic by QR campaigns
	 */
	$db->query("
		SELECT 
			s.*,
			COUNT(*) AS views
		FROM ".DB_PREFIX."statistics AS s
		WHERE 
			s.visit_date >= '".$mysql_from."' AND 
			s.visit_date <= '".$mysql_to."' AND 
			s.page='qr'
		GROUP BY s.id
		ORDER BY
			views DESC
	");
	
	if ($db->numRows()>0)
	{
?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table admin-stat-table">
	<thead>
		<tr>
			<th class="item-num">#</th>
			<th>Campaign Name</th>
			<th class="stat-bar">&nbsp;</th>
			<th class="text-align-right" width="10%">Views</th>
			<th class="text-align-right" width="10%">Orders</th>
		</tr>
	</thead>
	<tbody>
<?php
		$campaignViews = $db->getRecords();
		
		/**
		 * Select orders (conversions) by QR campaigns
		 */
		$ordersCount = array();
		$db->query("
			SELECT 
				o.offsite_campaign_id,
				COUNT(*) AS orders_count
			FROM ".DB_PREFIX."orders AS o
			WHERE 
				o.placed_date >= '".$mysql_from."' AND 
				o.placed_date <= '".$mysql_to."' AND 
				o.status = 'Completed' AND
				o.payment_status = 'Received'
				
			GROUP BY o.offsite_campaign_id
			ORDER BY
				orders_count DESC
		");
		while ($c = $db->moveNext())
		{
			$ordersCount[$c["offsite_campaign_id"]] = $c["orders_count"];
		}
		
		$totalOrders = 0;
		$totalViews = 0;
		$i = 0;
		$ruler = 0;
		
		foreach ($campaignViews as $campaignView)
		{
			$totalViews += $campaignView["views"];
			$campaignOrdes = isset($ordersCount[$campaignView["id"]]) ? $ordersCount[$campaignView["id"]] : 0;
			$totalOrders += $campaignOrdes;
			
			if ($i == 0)
			{
				$ruler = 100 / $campaignView["views"];
			}
?>
			<tr>
				<td class="item-num"><?php echo $i+1;?></td>
				<td><?php echo gs($campaignView["caption"]);?></td>
				<td class="stat-bar"><?php echo GetStatBar($campaignView["views"] * $ruler);?></td>
				<td class="text-align-right"><?php echo $campaignView["views"];?></td>
				<td class="text-align-right"><?php echo $campaignOrdes;?></td>
			</tr>

<?php
			$i++;
		}
?>	
	</tbody>
	<tfoot>
		<tr>
			<td colspan="3" class="text-align-right">Totals:</td>
			<td class="text-align-right"><?php echo $totalViews;?></td>
			<td class="text-align-right"><?php echo $totalOrders;?></td>
		</tr>
	</tfoot>
</table>
<?php
	}
	else
	{
		pageNote(array(
			array("class"=>"ic-info", "text"=>"No data available for selected period", "url"=>"", "visible"=>true)
		));
	}

