<?php
	if (!defined("ENV")) exit();

	if (!$printing)
	{
		pageHeader("Reports", "", "icb-list");
		pageNote(array(
			array("class"=>"ic-info", "text"=>"This section allows you to view many different types of reports regarding your cart.<br>To view a report, select a date range, report type and click \"Show Report\".", "url"=>"", "visible"=>true)
		));
	}
	
	function GetStatBar($rate)
	{
		$s = '<table cellpadding="0" cellspacing="0" border="0">';
		$s.= '<tr><td style="padding:0px;"><img src="images/admin/stat_left.gif"></td>';
		$s.= '<td style="padding:0px;"><img src="images/admin/stat.gif" height="12" width="'.round($rate*1.5).'"></td>';
		$s.= '<td style="padding:0px;"><img src="images/admin/stat_right.gif"></td></tr>';
		$s.= '</table>';
		return $s;
	}
	
	$from_y = isset($from_y)?$from_y:date("Y");
	$from_m = isset($from_m)?$from_m:date("n");
	$from_d = isset($from_d)?$from_d:1;
	$to_y = isset($to_y)?$to_y:date("Y");	
	$to_m = isset($to_m)?$to_m:date("n");
	$to_d = isset($to_d)?$to_d:date("t", mktime(1,1,1,$to_m, 1, $to_y));
	
	function GetReportDate()
	{
		global $from_y, $from_m, $from_d, $to_y, $to_m, $to_d;
		return 
			date("F j, Y", mktime(1, 1, 1, $from_m, $from_d, $from_y))." - ".
			date("F j, Y", mktime(1, 1, 1, $to_m, $to_d, $to_y));
	}
	
	$mysql_from =  $from_y."-".$from_m."-".$from_d." 00:00:00";
	$mysql_to =  $to_y."-".$to_m."-".$to_d." 23:59:59";
	
	$report_type = isset($report_type)?trim($report_type):"";
	$report_type = in_array($report_type, array(
		"top_products", "top_categories", "referrers", "users_activity", "payment",
		"orders", "products", "dates", "payment", "customers", "promo", "tax", "profit", "qr_campaigns", "widgets_campaigns", 'shift4', 'shift4_failures'))?$report_type:"";
	
	if (!$printing)
	{
		loadJS("cf_reports.js");
?>
<form action="admin.php" method="get" onSubmit="return CheckFormReports(this)">
	<input type="hidden" name="p" value="reports">
	<div class="admin-tabs admin-tabs-framed" id="tabs-page">
<?php 
		pageTabs(array(
			array("title"=>"Reports", "id"=>"main"),
		), "tabs-page");
?>	
		
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Select Report Date Range</div>

				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">From</td>
						<td class="formItemControl">
							<select name="from_m" class="date-month">
<?php
		for ($i=1; $i<=12; $i++) echo '<option value="'.$i.'" '.($i == $from_m ? "selected" : "").'>'.$months[$i].'</option>';
?>
								</select>
								<select name="from_d" class="date-day">
<?php
		for ($i=1; $i<=31; $i++) echo '<option value="'.$i.'" '.($i == $from_d ? "selected" : "").'>'.$i.'</option>';
?>
								</select>
								<select name="from_y" class="date-year">
<?php
		for ($i=2003; $i<=date("Y"); $i++) echo '<option value="'.$i.'" '.($i == $from_y ? "selected" : "").'>'.$i.'</option>';
?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">To</td>
						<td class="formItemControl">
							<select name="to_m" class="date-month">
<?php
		for ($i=1; $i<=12; $i++) echo '<option value="'.$i.'" '.($i == $to_m ? "selected" : "").'>'.$months[$i].'</option>';
?>
							</select>
							<select name="to_d" class="date-day">
<?php
		for ($i=1; $i<=31; $i++) echo '<option value="'.$i.'" '.($i == $to_d ? "selected" : "").'>'.$i.'</option>';
?>
							</select>
							<select name="to_y" class="date-year">
<?php
		for ($i=2003; $i<=date("Y"); $i++) echo '<option value="'.$i.'" '.($i == $to_y ? "selected" : "").'>'.$i.'</option>';
?>
							</select>
						</td>
					</tr>
					<?php if ($report_type == 'shift4') {
						$shift4_cc_type = isset($_REQUEST['shift4_cc_type']) ? $_REQUEST['shift4_cc_type'] : '';
					?>
					<tr style="vertical-align:top;">
						<td class="formItemCaption">Card Type</td>
						<td class="formItemControl">
							<select name="shift4_cc_type">
								<option value="">-- All --</option>
								<option value="AX" <?= $shift4_cc_type == 'AX' ? 'selected="selected"' : '' ?>>American Express</option>
								<option value="DC" <?= $shift4_cc_type == 'DC' ? 'selected="selected"' : '' ?>>Diners Club</option>
								<option value="JC" <?= $shift4_cc_type == 'JC' ? 'selected="selected"' : '' ?>>JC</option>
								<option value="MC" <?= $shift4_cc_type == 'MC' ? 'selected="selected"' : '' ?>>MasterCard</option>
								<option value="NS" <?= $shift4_cc_type == 'NS' ? 'selected="selected"' : '' ?>>Discover</option>
								<option value="VS" <?= $shift4_cc_type == 'VS' ? 'selected="selected"' : '' ?>>Visa</option>
								<option value="DB" <?= $shift4_cc_type == 'DB' ? 'selected="selected"' : '' ?>>Debit</option>
								<option value="SR" <?= $shift4_cc_type == 'SR' ? 'selected="selected"' : '' ?>>Sears</option>
								<option value="SC" <?= $shift4_cc_type == 'SC' ? 'selected="selected"' : '' ?>>Sears Canada</option>
							</select>
						</td>
					</tr>
					<?php } ?>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Show report"/>
				</div>
<?php
	}
	
	if ($report_type == "")
	{
		$reports = array(
			array("top_products", "Top Viewed Products"),
			array("top_categories", "Top Viewed Categories"),
			array("products", "Orders by Products"),
			array("users_activity", "Users Activity Report"),
			array("referrers", "Top Referring Sites"),
			array("customers", "Sales by Customer"),
			array("payment", "Payment Types", "Shows purchase statistics by payment type"),
			array("dates", "Consolidated Orders by Date", "This report shows overall statistics by dates from selected period.<br/>It includes subtotal, tax, shipping, discount, and total amounts for each day."),
			array("orders", "Individual Orders by Date", "This report shows overall statistics by completed orders with received payment.<br/>It includes subtotal, tax, shipping, discount, and total amounts for orders."),
			array("promo", "Promo Codes Usage"),
			array("tax", "Total Tax"),
			array("profit", "Total Profit"),
			array("qr_campaigns", "QR Campaigns"),
			array("widgets_campaigns", "Widgets Campaigns"),
			array('shift4', 'Shift4 End-of-Day'),
			array('shift4_failures', 'Shift4 Failed Transactions'),
		);
?>
				<div class="admin-form-header"><span class="icon ic-icon"></span>Select Report Type</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
					<tbody>
<?php
		foreach ($reports as $report)
		{
?>
						<tr>
							<td class="icon">&nbsp;</td>
							<td style="width:20px;">
								<input type="radio" name="report_type" value="<?php echo $report[0];?>" id="radio_<?php echo $report[0];?>" <?php echo $report[0] == "top_products" ? "checked" : "";?>>
							</td>
							<td><label for="radio_<?php echo $report[0];?>"><?php echo $report[1];?></label></td>
							<td style="text-align:right;"><input type="submit" value="Show report" onclick="$('#radio_<?php echo $report[0];?>').click();"/></td>
						</tr>
<?php
		}
?>
					</tbody>
				</table>
<?php
	}
	else
	{
		echo '<input type="hidden" name="report_type" value="'.$report_type.'">';
		require_once("content/admin/admin_report_".$report_type.".php");
	}
	
	if (!$printing)
	{
?>

			</div>
		</div>
	</div>
</form>
<?php
	}
?>