<?php
	if (!defined("ENV")) exit();

	$adminView = new Ddm_AdminView();

	$endicia_balance = '0';
	$force_change_passphrase = false;

	if (!AccessManager::checkAccess('ENDICIA'))
	{
		$adminView->assign('can_access_endicia', false);
	}
	else
	{
		$message = '';

		$adminView->assign('can_access_endicia', true);

		$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
		$nonce = isset($_REQUEST["nonce"]) ? $_REQUEST["nonce"] : "";

		$endicia = null;

		switch ($action)
		{
			/**
			 * Update settings
			 */
			case "update_settings" :
			{
				if (!verify_nonce($nonce, "endicia_update_settings"))
				{
					invalid_nonce_message();
					exit;
				}
				$settings['EndiciaShippingLabelsAccountID'] = isset($_POST['EndiciaShippingLabelsAccountID']) ? $_POST['EndiciaShippingLabelsAccountID'] : $settings['EndiciaShippingLabelsAccountID'];
				$settings['EndiciaShippingLabelsTestMode'] = isset($_POST['EndiciaShippingLabelsTestMode']) ? $_POST['EndiciaShippingLabelsTestMode'] : $settings['EndiciaShippingLabelsTestMode'];
				$settings['EndiciaShippingLabelsActive'] = isset($_POST['EndiciaShippingLabelsActive']) ? $_POST['EndiciaShippingLabelsActive'] : $settings['EndiciaShippingLabelsActive'];

				$password = trim(isset($_POST['EndiciaShippingLabelsPassword']) ? $_POST['EndiciaShippingLabelsPassword'] : '');

				if ($password != '')
				{
					$settings['EndiciaShippingLabelsPassword'] = $password;
				}

				$endicia = Shipping_Endicia::getInstance($settings);

				$statusResponse = $endicia->GetEndiciaAccountStatus();

				if ($statusResponse['Status'] != '0')
				{
					if ($statusResponse['Status'] == '2011')
					{
						$force_change_passphrase = true;
					}
					else if ($statusResponse['Status'] == '12507')
					{
						$message = 'Passphrase is incorrect';
					}
				}
				else
				{
					$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($settings['EndiciaShippingLabelsAccountID'])."' WHERE name='EndiciaShippingLabelsAccountID'");
					$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($settings['EndiciaShippingLabelsTestMode'])."' WHERE name='EndiciaShippingLabelsTestMode'");
					$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($settings['EndiciaShippingLabelsActive'])."' WHERE name='EndiciaShippingLabelsActive'");

					if ($password != '')
					{
						$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($settings['EndiciaShippingLabelsPassword'])."' WHERE name='EndiciaShippingLabelsPassword'");
					}

					$message = "Settings are updated";
				}
				break;
			}

			/**
			 * Buy postage
			 */
			case "buy_postage" :
			{
				if (!verify_nonce($nonce, "endicia_buypostage"))
				{
					invalid_nonce_message();
					exit;
				}

				$amount = isset($_POST['addfundsamount']) ? $_POST['addfundsamount'] : '';

				$endicia = Shipping_Endicia::getInstance($settings);

				$response = $endicia->AddFundsToEndiciaAccount($amount);
				$getPostageStatusCode = $response['Status'];

				if ($getPostageStatusCode == '0')
				{
					$request_id = $response['RequestID'];
					$certifiedi = $response['CertifiedIntermediary'];
					$serial_number = $certifiedi['SerialNumber'];
					$postage_balance = $certifiedi['PostageBalance'];
					$ascending_balance = $certifiedi['AscendingBalance'];
					$device_id = $certifiedi['DeviceID'];

					$query1 = $db->query("INSERT INTO ".DB_PREFIX."endicia_recreditrequests (request_id, serial_number, postage_balance, ascending_balance, device_id, request_status) VALUES ('$request_id', '$serial_number', '$postage_balance', '$ascending_balance', '$device_id', '$getPostageStatusCode')");
					$message = "You have added Funds to Your Endicia Account. Your Balance is now ".$endicia->GetEndiciaAccountBalance();
				}	

				else
				{
					if (isset($response['ErrorMessage']))
					{
						$message = $response['ErrorMessage'];
					}
					else
					{
						$message = "There was a problem adding Funds to your Endicia Account";
					}
				}

				break;
			}

			// /**
			//  * Password change
			//  */
			// case "passwordchange" :
			// {
			// 	if (!verify_nonce($nonce, "endicia_changepassword"))
			// 	{
			// 		invalid_nonce_message();
			// 		exit;
			// 	}

			// 	$newpass = isset($_POST['changepwnewpassword1']) ? $_POST['changepwnewpassword1'] : '';

			// 	$endicia = Shipping_Endicia::getInstance($settings);

			// 	$did_endicia_password_change = $endicia->ChangeEndiciaAccountPassword($newpass);

			// 		if ($did_endicia_password_change == '0')
			// 		{
			// 			$settings['EndiciaShippingLabelsPassword'] = $newpass;
			// 			$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($newpass)."' WHERE name='".$db->escape('EndiciaShippingLabelsPassword')."'");	
			// 			$message = "Your Endicia Account Passphrase has been changed successfully.";
			// 		}

			// 		else
			// 		{
			// 			$message = "There was a problem changing your Endicia Account Passphrase.";
			// 		}

				
			// 	break;
			// }	

			/**
			 * Refund request
			 */
			case "refundrequest" :
			{
				if (!verify_nonce($nonce, "endicia_refundrequest"))
				{
					invalid_nonce_message();
					exit;
				}				

				$endicia = Shipping_Endicia::getInstance($settings);

				$pic_number = isset($_POST['refund_PICNumber']) ? $_POST['refund_PICNumber'] : '';
				$customs_id = isset($_POST['refund_CustomsID']) ? $_POST['refund_CustomsID'] : '';
				$piece_id = isseT($_POST['refund_PieceID']) ? $_POST['refund_PieceID'] : '';

				$refundStatus = $endicia->RequestEndiciaPostageRefund($pic_number, $customs_id, $piece_id);

				$message = $refundStatus['status'] ? 'Your Refund Request was Submitted Successfully.' : 'Your Refund failed: '.$refundStatus['status_message'];

				if ($refundStatus)
				{
					$db->query('DELETE FROM '.DB_PREFIX.'endicia_shippinglabels WHERE pic_number =\''.$db->escape($pic_number).'\'');
				}
				break;
			}
		}

		if (is_null($endicia))
		{
			$endicia = Shipping_Endicia::getInstance($settings);
		}

		if ($settings['EndiciaShippingLabelsActive'] == 'Yes')
		{
			$endicia_balance = $endicia->GetEndiciaAccountBalance();
		}
		else
		{
			$endicia_balance = '';
		}

		$adminView->assign('force_change_passphrase', $force_change_passphrase);
		$adminView->assign('endicia_enabled', $settings['EndiciaShippingLabelsActive'] == 'Yes');
		$adminView->assign('last_active_tab', isset($last_active_tab) ? $last_active_tab: 'about')  ;
		$adminView->assign('message', $message);

		$adminView->assign('endicia_update_settings_nonce', create_nonce('endicia_update_settings'));
		$adminView->assign('endicia_buypostage_nonce', create_nonce('endicia_buypostage'));
		$adminView->assign('endicia_refundrequest_nonce', create_nonce('endicia_refundrequest'));
		$adminView->assign('endicia_passwordchange_nonce', create_nonce('endicia_passwordchange'));
		$adminView->assign('endicia_balance', $endicia_balance);
	
		$formBuilder = new core_Form_FormBuilder('settings', array('label' => 'Endicia Settings', 'class' => 'ic-settings', 'first' => true));

		$formBuilder
			->add('EndiciaShippingLabelsActive', 'choice', array('label' => 'Enable Endicia Shipping Labels', 'value' => $settings['EndiciaShippingLabelsActive'], 'options' => array(
					'No' => 'No',
					'Yes' => 'Yes',
				), 'attr' => array('class'=>'short')
			))

			->add('EndiciaShippingLabelsAccountID', 'text', array('label' => 'Account ID', 'value' => $settings['EndiciaShippingLabelsAccountID']))
			->add('EndiciaShippingLabelsPassword', 'password', array('label' => 'Passphrase', 'value' => '')) //$settings['EndiciaShippingLabelsPassword']))
			->add('EndiciaShippingLabelsTestMode', 'choice', array('label' => 'Test Mode', 'value' => $settings['EndiciaShippingLabelsTestMode'], 'options' => array(
					'No' => 'No',
					'Yes' => 'Yes',
				), 'attr' => array('class'=>'short')
			))
		;

		$form = $formBuilder->getForm();
		$adminView->assign('settingsForm', $form);

		// states
		$db->query('SELECT stid, short_name, name FROM '.DB_PREFIX.'states WHERE coid=1 ORDER BY name');
		$states = array();
		$shippingOriginState = '';

		$companyState = '';

		while ($db->moveNext())
		{
			$states[$db->col['short_name']] = $db->col['name'];

			if ($db->col['stid'] == $settings['ShippingOriginState'])
			{
				$shippingOriginState = $db->col['short_name'];
			}

			$cs = trim(strtoupper($settings['CompanyState']));
			if (trim(strtoupper($db->col['short_name'])) == $cs || trim(strtoupper($db->col['name'])) == $cs)
			{
				$companyState = $db->col['short_name'];
			}
		}

		if ($shippingOriginState == '') $shippingOriginState = $settings['ShippingOriginProvince'];

		$formBuilder = new core_Form_FormBuilder('postage', array('label' => "Add Postage to Your Endicia Account", 'class' => 'ic-settings', 'first' => true));
		$formBuilder
			->add('addfundspassword', 'password', array('label' => 'Your Endicia Passphrase'))
			->add('addfundsamount', 'text', array('label' => 'Amount of Funds to Add', 'attr' => array('class' => 'number tiny')))
		;

		$form = $formBuilder->getForm();
		$adminView->assign('postageform', $form);

		$formBuilder = new core_Form_FormBuilder('resetpw', array('label' => "Reset Your Endicia Account Passphrase", 'class' => 'ic-settings', 'first' => true));
		$formBuilder
			->add('changepwpassword', 'password', array('label' => 'Your Current Passphrase'))
			->add('changepwnewpassword1', 'password', array('label' => 'New Endicia Passphrase'))
			->add('changepwnewpassword2', 'password', array('label' => 'Repeat the New Passphrase'))
		;

		$form = $formBuilder->getForm();
		$adminView->assign('resetpwform', $form);

		$formBuilder = new core_Form_FormBuilder('refundreq', array('label' => "Request Postage Refund", 'class' => 'ic-settings', 'first' => true));
		$formBuilder
			->add('refundList', 'hidden', array('value' => '1'))
			->add('refund_PICNumber', 'text', array('label' => 'PIC Number', 'value' => isset($_GET['pic_num']) ? $_GET['pic_num'] : ''))
			//->add('refund_CustomsID', 'text', array('label' => 'Customs ID (If Needed)'))
			//->add('refund_PieceID', 'text', array('label' => 'Package Piece ID'))
		;

		$form = $formBuilder->getForm();
		$adminView->assign('refundreqform', $form);

		if ((isset($_POST['postage_buy'])) && ($_POST['postage_buy'] == 'Y'))
		{

			$buyamount = $_POST['RecreditAmount'];
			$did_endicia_buypostage = $endicia->AddFundsToEndiciaAccount($buyamount);
			$postagegetstatus = $did_endicia_buypostage['Status'];

				if ($postagegetstatus == '0')
				{


				}
		}


		if ((isset($_POST['resetpw'])) && ($_POST['resetpw'] == 'Y'))
		{

			$new_pass = $_POST['NewPassPhrase'];
		}
	}

	$adminView->assign('isLabeledApp', IS_LABEL ? 1 : 0);

	$adminView->render('pages/settings/endicia');