<?php
	if (!defined("ENV")) exit();

	$allow_product_level_shipping_price = false;
	
	$action = isset($action)?trim($action):"";
	
	$method_names = array(
		"base_weight"=>"Base + Weight",
		"weight"=>"Weight",
		"flat"=>"Flat (per item)",
		"price"=>"Price-based"
	);

	if ($allow_product_level_shipping_price)
	{
		$method_names["product_level"] = "At Product Level";
	}

	/**
	 * INSERT NEW CUSTOM METHOD
	 */
	if ($action == "insert_custom" && !DEMO_LOCK)
	{
		$new_carrier_name = isset($_REQUEST['new_carrier_name']) ? trim($_REQUEST['new_carrier_name']) : "Unnamed";
		$new_method_id = isset($_REQUEST['new_method_id']) ? trim($_REQUEST['new_method_id']) : "Unnamed";
		$new_method_calc_mode = isset($_REQUEST['new_method_calc_mode']) ? trim($_REQUEST['new_method_calc_mode']) : 'before';
		$new_method_name = $method_names[$new_method_id];
		$new_countries = isset($_REQUEST['new_countries']) ? $_REQUEST['new_countries'] : array();
		$new_states = isset($_REQUEST['new_states']) ? $_REQUEST['new_states'] : array();
		
		if (in_array('0', $new_countries) || count($new_countries) == 0)
		{
			$cl = '0';
		}
		else
		{
			$cl = count($new_countries) > 0 ? implode(',', $new_countries) : '0';
		}
		
		if (in_array('0', $new_states) || count($new_states) == 0)
		{
			$sl = '0';
		}
		else
		{
			$sl = count($new_states) > 0 ? implode(',', $new_states) : '0';
		}
		
		$new_priority = isset($new_priority)?$new_priority*1:5;
		$new_hidden = isset($new_hidden)?trim($new_hidden):"Yes";
		$autofill = isset($autofill)?trim($autofill):"No";
		$db->reset();
		$db->assignStr("carrier_id", "custom");
		$db->assignStr("carrier_name", $new_carrier_name);
		$db->assignStr("method_id", $new_method_id);
		$db->assignStr("method_calc_mode", $new_method_calc_mode);
		$db->assignStr("method_name", $new_method_name);
		$db->assignStr("priority", $new_priority);
		$db->assignStr("country", $cl);
		$db->assignStr("state", $sl);
		$db->assignStr("hidden", $new_hidden);
		$db->assignStr("notes", "");
		$ssid = $db->insert(DB_PREFIX."shipping_selected");
		
		if ($autofill == "Yes" && $new_method_id != "product_level")
		{
			for ($i=0; $i<=3; $i++)
			{
				$db->reset();
				$db->assign("ssid", $ssid);
				$db->assign("rate_min", $i * 10 + 0.01);
				$db->assign("rate_max", ($i+1) * 10);
				
				if ($new_method_id == "price")
				{
					$db->assign("base", 0);
					$db->assign("price", $i);
				}
				else
				{
					$db->assign("base", 10 - $i);
					$db->assign("price", 4 - $i);
				}
				
				$db->insert(DB_PREFIX."shipping_custom_rates");
			}
		}
		if (in_array($new_method_id, array("base_weight", "weight", "flat", "price")))
		{
?>
<script language="javascript">
	document.location="admin.php?p=shipping_custom_rates&ssid=<?php echo $ssid;?>&last_active_tab=rates	";
</script>
<?php
		}
		$show_message = "New custom shipping method has been successfully added!";
	}

	/**
	 * UPDATE CUSTOM METHOD
	 */
	if ($action == "update_custom" && !DEMO_LOCK)
	{
		$carrier_name = isset($carrier_name)?$carrier_name:array();
		$method_id = isset($method_id)?$method_id:array();
		$priority = isset($priority)?$priority:array();
		$hidden = isset($hidden)?$hidden:array();
		$pr_l = false;
		reset($carrier_name);
		foreach ($carrier_name as $ssid=>$data)
		{
			$db->reset();
			$db->assignStr("priority", $priority[$ssid]);
			$db->assignStr("hidden", $hidden[$ssid]);
			$db->assignStr("carrier_name", $carrier_name[$ssid]);
			$db->assignStr("method_id", $method_id[$ssid]);
			$db->assignStr("method_name", $method_names[$method_id[$ssid]]);
			$db->assignStr("notes", "");
			$db->update(DB_PREFIX."shipping_selected", "WHERE ssid='".$ssid."'");
		}
		$show_message = "Changes have been successfully saved!";
	}

	/**
	 * DELETE CUSTOM METHOD
	 */
	if ($action == "delete_custom" && !DEMO_LOCK)
	{
		$ssid = isset($ssid)?$ssid*1:0;
		$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE carrier_id='custom' AND ssid='".$ssid."'");
		if ($db->moveNext())
		{
			$db->query("DELETE FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$ssid."'");
			$db->query("DELETE FROM ".DB_PREFIX."shipping_selected WHERE ssid='".$ssid."'");
			$db->query("DELETE FROM ".DB_PREFIX."products_shipping_price WHERE ssid='".$ssid."'");
			
			$show_message = "Selected custom shipping method has been successfully removed!";
		}
		else
		{
			$show_message = "Can not remove custom shipping method! Incorrect method ID.";
		}
	}
?>
<div id="admin-tab-sheet-custom" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
	
<script type="text/javascript" language="JavaScript">
	statesCustom = new Array();
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."states ORDER BY coid, name");
	$i = 0;
	while ($db->moveNext())
	{
?>
	statesCustom[<?=$i++?>] = new Array(<?=$db->col["stid"]?>, <?=$db->col["coid"]?>, "<?=$db->col["name"]?>");

<?php
	}
?>
</script>

		<div class="admin-form-header slide-manager first"><span class="icon ic-icon ic-add"></span>Add a new custom shipping method</div>
		<div class="slide-area">
			<form name="frmNewCustom" action="admin.php?p=shipping" method="post" onSubmit="return CheckNewCustomShippingForm(this)">
				<input type="hidden" name="action" value="insert_custom">
				<input type="hidden" name="last_active_tab" value="custom">
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">Carrier Name</td>
						<td class="formItemControl"><input type="text" name="new_carrier_name"/></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Calculation Method</td>
						<td class="formItemControl">
							<select name="new_method_id">
								<option value="base_weight">Base + Weight</option>
								<option value="weight">Weight</option>
								<option value="flat">Flat (per item)</option>
<?php
	if ($allow_product_level_shipping_price)
	{
?>
								<option value="product_level">At product level</option>
<?php
	}
?>
								<option value="price">Price-based</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Calculate shipping based on</td>
						<td class="formItemControl">
							<select name="new_method_calc_mode">
								<option value="before_discount">Subtotal before discount</option>
								<option value="after_discount">Subtotal after discount</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Countries</td>
						<td class="formItemControl">
							<select name="new_countries[]" onChange="updateCustomStates()" multiple class="multiselect">
								<option value="0" selected>ALL COUNTRIES</option>
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE ".DB_PREFIX."countries.available = 'Yes' ORDER BY country_priority DESC, name");
	while ($db->moveNext())
	{
?>
								<option value="<?=$db->col["coid"]?>"><?=gs($db->col["name"])?></option>
<?php
	}
?>
							</select>
							<div class="formHelp">Hold down the control key to select multiple categories.</div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">States/Provinces</td>
						<td class="formItemControl"><select name="new_states[]" multiple class="multiselect"></select></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Priority</td>
						<td class="formItemControl">
							<select name="new_priority" class="short">
<?php
		for ($i=1; $i<=10; $i++)
		{
?>
								<option value="<?=$i?>" <?=$i==5?"selected":""?>><?=$i?></option>
<?php
		}
?>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Hidden</td>
						<td class="formItemControl">
							<select name="new_hidden" class="short">
								<option value="Yes">Yes</option>
								<option value="No" selected>No</option>
							</select>
						</td>
					</tr>
					<input type="hidden" name="autofill" value="No">
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
				</div>
			</form>
		</div>

		<form name="frmCustom" action="admin.php?p=shipping" method="post" onsubmit="return CheckCustomForm(this)">
			<input type="hidden" name="action" value="update_custom">
			<input type="hidden" name="last_active_tab" value="custom">

			<div class="admin-form-header"><span class="icon ic-icon ic-truck"></span>Custom shipping costs calculation settings</div>
			
			<table width="100%" cellpadding="5" cellspacing="0" border="0">
				<tr>
					<td class="formListHeaderIcon">&nbsp;</td>
					<td class="formListHeaderCaption">Carrier name</td>
					<td class="formListHeaderCaption">Calculation method</td>
					<td class="formListHeaderCaption">Country/State</td>
					<td class="formListHeaderCaption">Priority</td>
					<td class="formListHeaderCaption">Hidden</td>
					<td class="formListHeaderCaption">&nbsp;</td>
				</tr>
<?php
	/**
	 * SELECT STORE CUSTOM METHODS
	 */
	$db->query("
		SELECT
			".DB_PREFIX."shipping_selected.*
		FROM ".DB_PREFIX."shipping_selected
		WHERE carrier_id='custom'
		".(!$allow_product_level_shipping_price?" AND method_id <> 'product_level'":"")."
	");

	/**
	 * IF THERE ARE RESULTS - SHOW THEM
	 */
	if ($db->numRows()>0)
	{
		$ml = $db->getRecords();
		$j = 0;
		for ($i = 0; $i<count($ml); $i++)
		{
			$m = $ml[$i];
			if ($m["country"]=="0")
			{
				$m["country_name"] = "All";
			}
			else
			{
				$coids = explode(",", $m["country"]);
				$where = "";
				for ($k=0; $k<count($coids); $k++)
				{
					if($where != "") $where.=" OR ";
					$where.=" coid = '".$coids[$k]."' ";
				}
				$db->query("SELECT name FROM ".DB_PREFIX."countries WHERE ".$where." ORDER BY country_priority DESC, name");
				$m["country_name"] = "";
				while ($db->moveNext())
				{
					if ($m["country_name"] != "") $m["country_name"].=", ";
					$m["country_name"].= $db->col["name"];
				}
			}
			if ($m["state"]=="0")
			{
				$m["state_name"] = "All";
			}
			else
			{
				$stids = explode(",", $m["state"]);
				$where = "";
				for ($k=0; $k<count($stids); $k++)
				{
					if($where != "") $where.=" OR ";
					$where.=" stid = '".$stids[$k]."' ";
				}
				$db->query("SELECT name FROM ".DB_PREFIX."states WHERE ".$where." ORDER BY name");
				$m["state_name"] = "";
				while ($db->moveNext())
				{
					if ($m["state_name"] != "") $m["state_name"].=", ";
					$m["state_name"].= $db->col["name"];
				}
			}
?>

				<tr valign="top">
					<input type="hidden" name="cm_id_<?=$m["ssid"]?>" value="<?=$m["ssid"]?>"/>
					<td class="formListItemIcon"><img src="images/icons/a/server.png"></td>
					<td class="formListItemText" width="40%"><input type="text" name="carrier_name[<?=$m["ssid"]?>]" value="<?=htmlspecialchars($m["carrier_name"])?>" style="width:95%;"></td>
					<td class="formListItemText">
						<select name="method_id[<?=$m["ssid"]?>]" class="short">
							<option value="base_weight">Base + Weight</option>
							<option value="weight" <?=$m["method_id"]=="weight"?"selected":""?>>Weight</option>
							<option value="flat" <?=$m["method_id"]=="flat"?"selected":""?>>Flat (per item)</option>
<?php
			if ($allow_product_level_shipping_price)
			{
?>
							<option value="product_level" <?=$m["method_id"]=="product_level"?"selected":""?>>At product level</option>
<?php
			}
?>	
							<option value="price" <?=$m["method_id"]=="price"?"selected":""?>>Price-based</option>
						</select>
					</td>
					<td class="formListItemText">
						<i><?=$m["country"]==0?"ALL":$m["country_name"]?> -	<?=$m["state"]==0?"ALL":$m["state_name"]?></i>
					</td>
					<td class="formListItemText">
						<select name="priority[<?=$m["ssid"]?>]" style="width:70px;">
<?php
			for ($pri=1; $pri<=10; $pri++)
			{
?>
							<option value="<?=$pri?>" <?=$m["priority"]==$pri?"selected":""?>><?=$pri?></option>
<?php
			}
?>
						</select>
					</td>
					<td class="formListItemText">
						<select name="hidden[<?=$m["ssid"]?>]" style="width:70px;">
							<option value="Yes">Yes</option>
							<option value="No" <?=$m["hidden"]=="No"?"selected":""?>>No</option>
						</select>
					</td>
					<td class="formListItemButtons">
<?php
			if ($m["method_id"]!="product_level")
			{
?>
						<a href="admin.php?p=shipping_custom_rates&ssid=<?=$m["ssid"]?>"><img src="images/icons/a/pencil.png" border="0" alt="Edit Shipping Rates for This Method" title="Edit Shipping Rates for This Method"></a>
<?php
			}
			else
			{
?>
						<img src="images/zerro.gif" width="16">
<?php
			}
?>
						<a href="javascript:ConfirmDeleteCustomShipping(<?=$m["ssid"]?>)"><img src="images/icons/a/delete.png" border="0" alt="Delete Custom Method" title="Delete Custom Method"></a>
					</td>
				</tr>

<?php
			$j++;
		}
?>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes"/>
				<input type="reset" value="Reset form"/>
			</div>
<?php
	}
	else
	{
?>
			</table>
			<div class="formListEmpty">
				<img src="images/icons/a/info.png" align="left" hspace="4">
				<b>No results were found. Please check search criteria</b>
			</div>
<?php
	}
?>
		</form>
	</div>
</div>
<script type="text/javascript" language="JavaScript">
	updateCustomStates();
</script>