<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.regions.php");
	require_once("content/classes/class.taxes.php");

	$taxes = new Taxes($db);
	$taxes->demo = defined('DEMO_LOCK') && DEMO_LOCK;

	$action = isset($action)?trim($action):"";
	if ($action == "update_settings" && !DEMO_LOCK)
	{
		$request = Framework_Request::createFromGlobals();

		$settingsRepository = DataAccess_SettingsRepository::getInstance();
		$settingsRepository->save($request->get('form', array()));

		Admin_Flash::setMessage('Shipping settings have been updated');
	}

	$forceAddressValidation = $settings['ExactorEnableTax'] == 'Yes' || $settings['AvalaraEnableTax'] == 'Yes';
	if ($forceAddressValidation)
	{
		$settings["EndiciaUspsAddressValidation"] = '1';
	}

	$taxService = Tax_ProviderFactory::getTaxService();
?>
<script type="text/javascript" language="JavaScript">
	statesSettings = new Array();
<?php
	$db->query("SELECT * FROM ".DB_PREFIX."states ORDER BY coid, name");
	$i = 0;
	while($db->moveNext())
	{
?>
	statesSettings[<?=$i++?>] = new Array(<?=$db->col["stid"]?>, <?=$db->col["coid"]?>, "<?=$db->col["name"]?>");
<?php
	}
?>
</script>
<div id="admin-tab-sheet-settings" class="admin-tab-sheet">
	<div class="admin-tab-sheet-wrap">
		<form name="frmSettings" action="admin.php?p=shipping" method="post" data-auto-validate="1" onsubmit="return CheckSettingsForm(this)">
			<input type="hidden" name="action" value="update_settings"/>
			<input type="hidden" name="last_active_tab" value="settings"/>
			<div class="admin-form-header first"><span class="icon ic-icon ic-checkmark"></span>Enable/Disable Shipping Calculation</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td class="formItemCaption">Enable Shipping?</td>
					<td class="formItemControl">
						<select name="form[ShippingCalcEnabled]" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingCalcEnabled"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Allow international shipping?</td>
					<td class="formItemControl">
						<select name="form[ShippingInternational]" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingInternational"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Should the cart display the shipping price on the product page?</td>
					<td class="formItemControl">
						<select name="form[ShippingShowPriceAtProductLevel]" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingShowPriceAtProductLevel"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Allow orders to be completed if no shipping methods are available?</td>
					<td class="formItemControl">
						<select name="form[ShippingWithoutMethod]" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingWithoutMethod"]=="NO"?"selected":""?>>No</option>
						</select>
						<div class="formItemComment">
							If "No" is selected the cart will not allow an order to be completed if it cannot calculate a shipping price.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Display the shipping weight on the product / catalog pages?</td>
					<td class="formItemControl">
						<select name="form[ShippingShowWeight]" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingShowWeight"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Enable "Shipping Quote" feature?</td>
					<td class="formItemControl">
						<select name="form[ShippingAllowGetQuote]" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingAllowGetQuote"]=="NO"?"selected":""?>>No</option>
						</select>
						<div class="formItemComment">
							If enabled, customers will be able to get a shipping quote for products within their cart before they register.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Display alternative shipping methods when shipping is free?</td>
					<td class="formItemControl">
						<select name="form[ShippingShowAlternativeOnFree]" class="short">
							<option value="YES">Yes</option>
							<option value="NO" <?=$settings["ShippingShowAlternativeOnFree"]=="NO"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
<?php
	if ($taxService instanceof Tax_CustomProvider)
	{
?>
				<tr valign="top">
					<td class="formItemCaption">Is shipping taxable?</td>
					<td class="formItemControl">
						<select name="form[ShippingTaxable]" class="short">
							<option value="1">Yes</option>
							<option value="0" <?=$settings["ShippingTaxable"]=="0"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Shipping tax class</td>
					<td class="formItemControl">
<?php
		$tax_classes = $taxes->getTaxClassesList();
		if (count($tax_classes) > 0)
		{
?>
						<select name="form[ShippingTaxClassId]">
							<option value="0">Tax class is not assigned</option>
<?php
			for ($i=0; $i<count($tax_classes); $i++)
			{
?>
							<option value="<?=$tax_classes[$i]["class_id"]?>" <?=$settings["ShippingTaxClassId"]==$tax_classes[$i]["class_id"]?'selected="selected"':''?>><?=htmlspecialchars($tax_classes[$i]["class_name"])?></option>
<?php
			}
?>
						</select>
<?php
		}
		else
		{
			echo "There are no taxes classes defined";
		}
?>
					</td>
				</tr>
<?php
	}
?>
				<tr valign="top">
					<td class="formItemCaption">Allow separate billing and shipping?</td>
					<td class="formItemControl">
						<select name="form[ShippingAllowSeparateAddress]" class="short">
							<option value="1">Yes</option>
							<option value="0" <?=$settings["ShippingAllowSeparateAddress"]=="0"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
			</table>
			
			<div class="admin-form-header"><span class="icon ic-icon ic-checkmark"></span>USPS Address Validation / Standardization</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td class="formItemCaption">Use USPS Validation Services</td>
					<td class="formItemControl">
						<select name="form[EndiciaUspsAddressValidation]" class="short" <?= $forceAddressValidation ? 'disabled' : '';?>>
							<option value="1">Yes</option>
							<option value="0" <?=$settings["EndiciaUspsAddressValidation"]=="0"?"selected":""?>>No</option>
						</select>
						<?=$forceAddressValidation ? '<input type="hidden" name="form[EndiciaUspsAddressValidation]" value="1">' : '';?>
					</td>
				</tr>
			</table>

			<div class="admin-form-header"><span class="icon ic-icon ic-pencil"></span>Shipping Label</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td class="formItemCaption"><b>Free shipping title</b></td>
					<td class="formItemControl">
						<input name="form[ShippingFreeDescription]" type="text" value="<?=htmlspecialchars($settings["ShippingFreeDescription"])?>">
						<div class="formItemComment">
							This is the name for the free shipping method on the order and invoice page.
							The default is "Free Shipping" but you can use something like "Free ground shipping" or "Free delivery".
						</div>
					</td>
				</tr>
			</table>
			
			<div class="admin-form-header"><span class="icon ic-icon"></span>Handling Fee</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td class="formItemCaption">&nbsp;</td>
					<td class="formItemControl">
						<div class="formItemComment">
							Handling fees are optional. You may set up a handling fee as a percentage of the sale or a flat rate.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Charge per-order handling fee</b></td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingHandlingFee]" value="<?=number_format($settings["ShippingHandlingFee"], 2, ".", "")?>" class="short">
						<select name="form[ShippingHandlingFeeType]" class="short">
							<option value="percent">%</option>
							<option value="amount" <?=$settings["ShippingHandlingFeeType"]=="amount"?"selected":""?>><?=$admin_currency["code"]?></option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Charge per-order handling fee when shipping is free</b></td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingHandlingFeeWhenFreeShipping]" value="<?php echo number_format($settings["ShippingHandlingFeeWhenFreeShipping"], 2, ".", "");?>" class="short">
						<?php echo $admin_currency["code"];?>
					</td>
				</tr>
<?php
	if ($taxService instanceof Tax_CustomProvider)
	{
?>
				<tr valign="top">
					<td class="formItemCaption">Is handling fee taxable?</td>
					<td class="formItemControl">
						<select name="form[ShippingHandlingTaxable]" class="short">
							<option value="1">Yes</option>
							<option value="0" <?=$settings["ShippingHandlingTaxable"]=="0"?"selected":""?>>No</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Handling tax class</td>
					<td class="formItemControl">
<?php
		if (count($tax_classes) > 0)
		{
?>
						<select name="form[ShippingHandlingTaxClassId]">
							<option value="0">Tax class is not assigned</option>
<?php
			for ($i=0; $i<count($tax_classes); $i++)
			{
?>
							<option value="<?=$tax_classes[$i]["class_id"]?>" <?=$settings["ShippingHandlingTaxClassId"]==$tax_classes[$i]["class_id"]?'selected="selected"':''?>><?=htmlspecialchars($tax_classes[$i]["class_name"])?></option>
<?php
			}
?>
						</select>
<?php
		}
		else
		{
			echo "There are no taxes classes defined";
		}
?>
					</td>
				</tr>
<?php
	}
?>
				<tr valign="top">
					<td class="formItemCaption">Show handling separately?</td>
					<td class="formItemControl">
						<select name="form[ShippingHandlingSeparated]" class="short">
							<option value="1">Yes</option>
							<option value="0" <?=$settings["ShippingHandlingSeparated"]=="0"?"selected":""?>>No</option>
						</select>
						<div class="formItemComment">
							If handling is not separated then shipping tax will be applied
						</div>
					</td>
				</tr>
			</table>
			
			<div class="admin-form-header"><span class="icon ic-icon ic-location"></span>Shipping Origin Settings (real-time)</div>
			<table cellpadding="0" cellspacing="0" border="0" width="100%">
				<tr valign="top">
					<td>&nbsp;</td>
					<td class="formItemControl">
						<div class="formItemComment">
							This information will be used to calculate real-time shipping costs. Please enter in the origin information for all shipments from your store.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Name</td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginName]" data-required="1" value="<?php echo gs($settings['ShippingOriginName']); ?>" />
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Address Line 1</td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginAddressLine1]" data-required="1" value="<?php echo gs($settings['ShippingOriginAddressLine1']); ?>" />
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Address Line 2</td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginAddressLine2]"  value="<?php echo gs($settings['ShippingOriginAddressLine2']); ?>" />
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">City</td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginCity]" data-required="1" value="<?=gs($settings["ShippingOriginCity"])?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Country of origin</td>
					<td class="formItemControl">
						<select name="form[ShippingOriginCountry]" data-required="1" onChange="updateSettingsStates('<?=gs($settings["ShippingOriginState"])?>')">
							<?php
							$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE ".DB_PREFIX."countries.available = 'Yes' ORDER BY country_priority DESC, name");
							while ($db->moveNext())
							{
								?>
								<option value="<?=$db->col["coid"]?>" <?=$settings["ShippingOriginCountry"]==$db->col["coid"]?"selected":""?>><?=gs($db->col["name"])?></option>
							<?php
							}
							?>
						</select>
					</td>
				</tr>
				<tr valign="top" id="shippingOriginState">
					<td class="formItemCaption">State/Province name</td>
					<td class="formItemControl">
						<select name="form[ShippingOriginState]"><option>All States</option></select>
					</td>
				</tr>
				<tr valign="top" id="shippingOriginProvince" style="display:none;">
					<td class="formItemCaption required">State/Province name</td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginProvince]" value="<?=gs($settings['ShippingOriginProvince']);?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">ZIP/Postal Code</td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginZip]" data-required="1" class="short" value="<?=gs($settings["ShippingOriginZip"])?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Phone number</td>
					<td class="formItemControl">
						<input type="text" name="form[ShippingOriginPhone]" data-required="1" class="short" value="<?=gs($settings["ShippingOriginPhone"])?>">
						<div class="formItemComment">Required for some USPS shipping methods. Please enter numbers only, no letters, dashes or any other characters</div>
					</td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes"/>
				<input type="reset" value="Reset form"/>
			</div>
		</form>
	</div>
</div>

<script type="text/javascript" language="javascript">
	updateSettingsStates('<?=$settings["ShippingOriginState"]?>');
</script>
