<?php
	if (!defined("ENV")) exit();

	$zone_id = isset($_REQUEST["zone_id"])?intval($_REQUEST["zone_id"]):0;
	$tax_zone = $taxes->getTaxZoneById($zone_id);
	
	$countries_states = $taxes->getCountriesStates(false);

	$tax_mode = isset($_REQUEST['tax_mode']) ? $_REQUEST['tax_mode'] : 'simple';

	if (!in_array($tax_mode, array('simple', 'advanced'))) $tax_mode = 'simple';

	$action = isset($_REQUEST['action']) ? $_REQUEST['action'] : '';
	
	if ($action == 'save')
	{
		// TODO: use request object here
		$taxSettings = isset($_REQUEST['taxSettings']) ? $_REQUEST['taxSettings'] : array();

		if (is_array($taxSettings) && count($taxSettings) > 0)
		{
			$settingsRepository = new DataAccess_SettingsRepository($db, $settings);
			$settingsRepository->save($taxSettings);
			$settings = array_merge($settings, $taxSettings);
			Admin_Flash::setMessage('Taxes settings have been updated');
		}
	}

	$taxService = Tax_ProviderFactory::getTaxService();
	$isCustomProvider = $taxService instanceof Tax_CustomProvider;

	$settingsForm = new core_Form_FormBuilder('general');

	$basicPropertiesGroup = new core_Form_FormBuilder('basic', array('label' => 'tax_settings.tax_settings', 'first'=>true));
	$settingsForm->add($basicPropertiesGroup);

	$basicPropertiesGroup->add('taxSettings[TaxAddress]', 'choice', array('label' => 'tax_settings.tax_address', 'value' => $settings['TaxAddress'], 'expanded' => true, 'options' => array(
		'Shipping' => 'tax_settings.tax_address_options.shipping',
		'Billing' => 'tax_settings.tax_address_options.billing',
		'Default' => 'tax_settings.tax_address_options.default',
	)));

	$countryOptions = array('0' => 'common.all_countries');
	foreach ($countries_states as $coid => $country)
	{
		$countryOptions[$coid] = $country['country_name'];
	}
	$stateOptions = array('0' => 'common.all_states_provinces');

	$basicPropertiesGroup->add('taxSettings[TaxDefaultCountry]', 'choice', array('label' => 'tax_settings.default_tax_country', 'value' => $settings['TaxDefaultCountry'], 'options' => $countryOptions));
	$basicPropertiesGroup->add('taxSettings[TaxDefaultState]', 'choice', array('label' => 'tax_settings.default_tax_state', 'value' => $settings['TaxDefaultState'], 'options' => $stateOptions));
	$basicPropertiesGroup->add('taxSettings[TaxExemptionsActive]', 'choice', array('label' => 'tax_settings.enable_tax_exemptions', 'value' => $settings['TaxExemptionsActive'], 'options' => array('0' => 'tax_settings.enable_tax_exemptions_options.no', '1' => 'tax_settings.enable_tax_exemptions_options.yes'), 'attr' => array('class' => 'short')));

	$adminView = Ddm_AdminView::getInstance();

	$adminView->assign('settingsForm', $settingsForm->getForm());
	$adminView->assign('settingsNonce', create_nonce('tax_save'));
	$adminView->assign('taxMode', $tax_mode);
	$adminView->assign('countriesStates', json_encode($countries_states));
	$adminView->assign('selectedTaxDefaultCountry', $settings['TaxDefaultCountry']);
	$adminView->assign('selectedTaxDefaultState', $settings['TaxDefaultState']);
	$adminView->assign('isCustomProvider', $isCustomProvider);

	$adminView->render('pages/taxes/settings');
