<?php
	if (!defined("ENV")) exit();

	loadJS("cd_user.js");
	pageHeader("Customers", "", 'icb-group');
	pageNote(array(
		array("class"=>"ic-info", "text"=>"<b>Please enter in your search criteria.</b><br>You need to enter at least one search criteria for search to be effective", "url"=>"", "visible"=>true)
	));
	
	$action = isset($action) ? trim($action) : "";
	$lname = isset($lname) ? trim($lname) : "";
	$email = isset($email) ? trim($email) : "";
	$login = isset($login) ? trim($login) : "";
	$phone = isset($phone) ? trim($phone) : "";
	$company = isset($company) ? trim($company) : "";
	$ec_users = isset($ec_users) ? true : false;
	
	$from_y = isset($from_y) ? trim($from_y) : "";
	$from_m = isset($from_m) ? trim($from_m) : "";
	$from_d = isset($from_d) ? trim($from_d) : "";
	$to_y = isset($to_y) ? trim($to_y) : "";
	$to_m = isset($to_m) ? trim($to_m) : "";
	$to_d = isset($to_d) ? trim($to_d) : "";
	
	
	$from_date = false;
	$to_date = false;
	
	// Setting date
	if (isset($from_y) && isset($from_m) && isset($from_d) && $from_y != '' && $from_m != '' && $from_d != '')
	{
		$from_date =  intval($from_y)."-".intval($from_m)."-".intval($from_d).' 00:00:01';
	}
	
	if (isset($to_y) && isset($to_m) && isset($to_d) && $to_y != '' && $to_m != '' && $to_d != '')
	{
		$to_date =  intval($to_y)."-".intval($to_m)."-".intval($to_d).' 00:00:01';
	}
?>
<form action="admin.php?p=users" method="GET">
	<input type="hidden" name="p" value="users">
	<input type="hidden" name="action" value="search">
	
	<div class="admin-search-form">
		<div class="admin-search-form-header">Search Customers</div>
		<div class="admin-search-form-wrap clearfix">
			<div class="admin-search-form-item">
				<label for="lname">Last Name</label>
				<input type="text" id="lname" name="lname" value="<?=htmlspecialchars($lname)?>"/>
			</div>
			<div class="admin-search-form-item">
				<label for="email">Email Address</label>
				<input type="text" id="email" name="email" value="<?=htmlspecialchars($email)?>"/>
			</div>
			<div class="admin-search-form-item">
				<label for="login">Username</label>
				<input type="text" id="login" name="login"  value="<?=htmlspecialchars($login)?>"/>
			</div>
			<div class="admin-search-form-item">
				<label for="company">Company</label>
				<input type="text" id="company" name="company" value="<?=htmlspecialchars($company)?>"/>
			</div>
			<div class="admin-search-form-item">
				<label for="phone">Phone Number</label>
				<input type="text" id="phone" name="phone"  value="<?=htmlspecialchars($phone)?>"/>
			</div>
			<div class="admin-search-form-item">
				&nbsp;<br/>
				<input style="display:inline-block;" type="checkbox" id="search-express-checkout-users" value="1" name="ec_users" <?php echo $ec_users ? "checked":"";?>/>
				<label style="display:inline-block;" for="search-express-checkout-users">Search Express Checkout Users</label>
			</div>
			<div class="admin-search-form-item">
				<label>From</label>
				<select name="from_m" class="date-month">
					<option value="">--</option>
					<?php for($i=1; $i<=12; $i++){?><option value="<?=$i?>" <?=$i == $from_m?"selected":""?>><?=$months[$i]?></option><?}?>
				</select>
				<select name="from_d" class="date-day">
					<option value="">--</option>
					<?php for($i=1; $i<=31; $i++){?><option value="<?=$i?>" <?=$i == $from_d?"selected":""?>><?=$i?></option><?}?>
				</select>
				<select name="from_y" class="date-year">
					<option value="">--</option>
					<?php for($i=2004; $i<=date("Y")+10; $i++){?><option value="<?=$i?>" <?=$i == $from_y?"selected":""?>><?=$i?></option><?}?>
				</select>
			</div>
			<div class="admin-search-form-item">
				<label>To</label>
				<select name="to_m" class="date-month">
					<option value="">--</option>
					<? for($i=1; $i<=12; $i++){?><option value="<?=$i?>" <?=$i == $to_m?"selected":""?>><?=$months[$i]?></option><?}?>
				</select>
				<select name="to_d" class="date-day">
					<option value="">--</option>
					<? for($i=1; $i<=31; $i++){?><option value="<?=$i?>" <?=$i == $to_d?"selected":""?>><?=$i?></option><?}?>
				</select>
				<select name="to_y" class="date-year">
					<option value="">--</option>
					<? for($i=2004; $i<=date("Y")+10; $i++){?><option value="<?=$i?>" <?=$i == $to_y?"selected":""?>><?=$i?></option><?}?>
				</select>
			</div>
		</div>
		<div class="admin-form-buttons admin-search-form-buttons">
			<input type="submit" value="Search"/>
			<input type="reset" value="Reset Search" />
		</div>
	</div>
</form>


<?php
	if ($action == "search")
	{
		$where = "WHERE ".
			($ec_users ? "" : DB_PREFIX."users.login <> 'ExpressCheckoutUser' AND ").
			DB_PREFIX."users.removed='No' ".
			"AND ".DB_PREFIX."users.lname LIKE '%".$db->escape($lname)."%' ".
			"AND ".DB_PREFIX."users.email LIKE '%".$db->escape($email)."%' ".
			"AND ".DB_PREFIX."users.login LIKE '%".$db->escape($login)."%' ".
			"AND ".DB_PREFIX."users.phone LIKE '%".$db->escape($phone)."%' ".
			"AND ".DB_PREFIX."users.company LIKE '%".$db->escape($company)."%'";
		
		if ($from_date)
		{
			$where .= " AND ".DB_PREFIX."users.created_date >='".$from_date."' "; 
		}
		
		if ($to_date)
		{
			$where .= " AND ".DB_PREFIX."users.created_date <='".$to_date."' ";
		}

		$_SESSION["users-search-where"] = $where;

		$db->query("SELECT * FROM ".DB_PREFIX."users ".$where." ORDER BY lname, fname ");
?>
<div class="listHeader">
	<div class="listHeaderIcon"><img src="images/icons/a/zoom.png"/></div>
	<div class="listHeaderCaption">
		Users Search Results
	</div>
	<div class="listHeaderCaption" style="float:right;font-weight:normal;">
		Users found : <?=$db->numRows()?>
	</div>
</div>
<?php	
		if ($db->numRows() > 0)
		{
?>
&nbsp;
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
	<thead>
		<th class="icon"></th>
		<th style="width:150px;">Username</th>
		<th>Name</th>
		<th style="width:150px;">Company</th>
		<th style="width:150px;">Email Address</th>
		<th></th>
	</thead>
	<tbody>
<?php
			while ($db->moveNext())
			{
?>
		<tr>
			<td class="icon"><img src="images/icons/a/user.png"/></td>
			<td><a href="admin.php?p=user&uid=<?=$db->col["uid"]?>"><?=htmlspecialchars($db->col["login"])?></a></td>
			<td><a href="admin.php?p=user&uid=<?=$db->col["uid"]?>"><?=htmlspecialchars($db->col["fname"]." ".$db->col["lname"])?></a></td>
			<td><?=htmlspecialchars($db->col["company"])?></td>
			<td><?=htmlspecialchars($db->col["email"])?></td>
			<td style="text-align:right;">
				<a href="admin.php?p=user&uid=<?=$db->col["uid"]?>"><img src="images/icons/a/user.png" title="Show/Edit User's Profile" border="0"></a>
<?php
				if (in_array("orders", $auth_rights) || in_array("all", $auth_rights))
				{
?>
				<a href="admin.php?p=orders&uid=<?=$db->col["uid"]?>"><img src="images/icons/a/invoice.png" title="Show User's Orders" border="0"></a>
<?php
				}
?>
				<a href="javascript:ConfirmDeleteUser(<?=$db->col["uid"]?>)"><img src="images/icons/a/delete.png" title="Delete User" border="0"></a>&nbsp;
			</td>
		</tr>
<?php
			}
?>
	</tbody>
	<tfoot>
		<tr>
			<td></td>
			<td colspan="3">
				<form action="admin.php?no-acceleration=true&p=backup_restore&action=export&mode=csv&from=users-search&chart=true" method="POST" target="_blank" name="">
					<input type="hidden" name="export_what" value="users"/>
					<input type="hidden" name="separator" value=",">
					<input type="hidden" name="decimal_separator" value=".">
					<input type="submit" value="Export to CSV" />
				</form>
			</td>
			<td colspan="2" style="text-align:right">
				Users found : <?=$db->numRows()?>
			</td>
		</tr>
	</tfoot>
</table>
<?php
		}
		else
		{
?>
<div class="listEmpty">
	Your search did not produce any results. Please try again with a different search criteria.<br/>
	<a href="admin.php?p=users">Reset Search</a>
</div>	
<?php
		}
	}
