<?php
	if (!defined("ENV")) exit();

	//groups and privileges
	$admin_pages = array(
		//common privileges
		"any"=>array("home", "profile", "profile_openid", "auto_complete", "plugins", "plugin", "search_export", "test","settings_stampscom"),
		//edit categories
		"categories"=>array("categories", "category", "category_process", "bulk_categories"),
		//manage products
		"products"=>array(
			"products", "product", "product_process",
			"bulk_products", "bulk_images", "thumbs_generator", "thumbs_generator_json",
			"products_attributes", "products_attribute", "products_attribute_process",
			"products_families", "products_family", "products_family_process",
			"manufacturers", "manufacturer_process", "products_groups","products_group",
			"products_reviews_info", "products_reviews", "products_reviews_process",
			"attribute_json", "doba", "doba_json",
			'bulk_manufacturers',
		),
		//users
		"users"=>array("users", "user", "user_shipping", "user_process"),
		//orders
		"orders"=>array("orders", "order", "order_process", "order_invoice", "export_quickbooks", "export_quickbooks_process", "shipping_label_usps", "order_endicia", "endicia_generatepostagelabel", "endicia_addfundstoaccount", "endicia_validateaccountinfo", 'endicia_viewlabel', "intuit_quickstart","order_stampscom_ajax"),
		//emails
		"emails"=>array(
			"email_top_bottom", 
			"email_archive", "email_archive_preview",
			"email_newsletter", "email_updates",
			"email_process", "email_preview", 
			"users_emails", "emails_import",
			"email_notifications", "email_notification", 
			"email_list", "email_edit", "email_check"
		),
		//admins
		"admins"=>array("admins", "admin", "admins_log"), 
		//global
		"global"=>array(
			"settings", 
			"settings_qr",
			"settings_widgets",
			"settings_intuit",
			'settings_endicia',
			"settings_search",
			"about_endicia",
			"countries","states",
			"settings_wholesale",
			"products_locations",
			"products_location",
			"settings_email",
			"settings_dollar_days",
			"languages", "language", "language_process",
			"update",
			"localization", 
			"info","compliance",
		),
		"ccs"=>array("settings_ccs"),
		//business data
		"business"=>array(
			"taxes", "taxes_zones", "taxes_zone", "taxes_classes", "taxes_class", "taxes_rates", "taxes_rate", "taxes_settings",
			"payment_methods", "payment_method", "payment_method_custom", "payment_method_ajax", "payment_cardinal", "merchant_signup",
			"shipping", "shipping_realtime_settings", "shipping_custom_rates",
			"discounts", "promo_edit", "paypalipn_gencsr", "bongo", 'bongo_extend', 'paypal_bml', 'tax_services',
			'postage',
		),
		//content
		"content"=>array(
			"pages", "page", "page_process", 
			"design_layout", "design_settings", "design_images",
			"design_catalog",
			"filemanager", "site_home",
			"forms_control", "custom_field", "custom_field_process",
			'design_mode', 'quick_start_guide', 'layout_helper',
		),
		//export
		"database"=>array("backup_restore"),
		//statistis
		"stats"=>array("stats_charts", "charts", "reports"),
		"marketing"=>array(
			"export_froogle", "export_froogle_process", "google_marketing",
			"export_shopzilla", "export_shopzilla_process", "export_shopzilla_data",
			"export_wholesalecentral",
			"sale_prices", "affiliate", "drift_marketing",
			"plugins", "plugin", "mailchimp","marketing_product_import","marketing_product_export",
			"marketing_qr_ajax", "marketing_widgets_ajax", 
			"testimonials", "settings_social",
			"avalara_tax", "settings_exactor", "exactor_euc_ajax", "exactor_euc_tree", "avalara_tree"
		),
	);
	$zones_names = array(
		"any"=>"Admin Area",
		"categories"=>"Manage Categories",
		"products"=>"Manage Products",
		"users"=>"Users & Orders",
		"orders"=>"Users & Orders",
		"emails"=>"Manage Emails",
		"admins"=>"Administrators",
		"global"=>"Global Cart Settings",
		"business"=>"Order Settings",
		"content"=>"Content Management",
		"database"=>"Database & Backup",
		"stats"=>"Statistics",
		"marketing"=>"Marketing",
		"ccs"=>"CCS",
		"help"=>"Help area"
	);
	$is_page = false;
	$body = "admin_home.php";
	reset($admin_pages);
	$current_zone = "any";
	foreach ($admin_pages as $zone_name => $zone_pages) {
		if(in_array($p, $zone_pages)){
			$is_page = true;
			//check privileges
			if(in_array($zone_name, $auth_rights) || ($zone_name == "any") || in_array("all", $auth_rights)){
				$body = "admin_".$p.".php";
				$current_zone = $zone_name;
			}
			else{
				$body = "admin_security_error.php";
			}
		}
	}
	$zone_title = $zones_names[$current_zone];
?>
