$(document).ready(function(){

	$('#dialog-avalara-tax-codes-login').dialog({
		title: 'Avalara Tax Codes',
		autoOpen: false,
		modal: true,
		width: 570,
		height: 300,
		resizable: false,
		buttons: [
			{
				text: 'Get tax codes',
				click: function(){
					adminShowSpinner('Updating Avalara Tax Codes', true);
					$('#dialog-avalara-tax-codes-login form').submit();
				}
			},
			{
				text: 'Cancel',
				click: function(){
					$('#dialog-avalara-tax-codes-login').dialog('close');
				}
			}
		]
	})

	$('#link-update-avalara-tax-codes').click(function(e){
		e.stopPropagation();
		$('#dialog-avalara-tax-codes-login').dialog('open');
		return false;
	})
})

function deleteTaxCode(codeId)
{
	var codeForm = document.forms['avalara-tax-codes'];
	if (confirm('Are you sure? This can not be undone!'))
	{
		codeForm.delete_tax_code.value = codeId;
		codeForm.action.value = 'delete_tax_code';
		codeForm.submit();
		return true;
	}

	return false;
}

function selectAvalaraCode(code, description)
{
	$('#avalara_tax_code').val(code);
	$('#avalara_tax_name').val(description);
	$('#avalata-tax-codes').submit();
	adminShowSpinner('Adding tax code');
	return false;
}

function displaySelectAvalaraTaxCode()
{
	adminShowSpinner('Loading tax codes');
	$.ajax({
		type: 'GET',
		url: 'admin.php?p=avalara_tree&chart=true'
	}).success(function(data){

		adminHideSpinner();

		$('#avalara_tree_dialog_inner').html(data);
		$('#avalara_tree_dialog').dialog({
			modal: true,
			width: 670,
			height: 400,
			maxWidth: 700,
			showTitle: false,
			autoOpen: true,
			closeOnEscape: false,
			title: 'Avalara Tax Codes',
			buttons: [
				{
					text: 'Close',
					click: function(){
						$('#avalara_tree_dialog').dialog('close');
					}
				}
			]
		});

		$('#avalara_tree_dialog .tree').treeview({collapsed: true, animated: "medium", persist: "none"});
	});
}