var bongoTotalProducts = 0;
var bongoPosition = 0;
var bongoThreadActive = false;
var bongoThreadInterval = null;

$(document).ready(function(){
	bongo().init();
});

/**
 * Init bongo gui
 */
function bongo_init()
{
	$('#divBongoApiProgress .progress').progressbar({value:0});

	$('#buttonBongoApiStart').click(function(){
		$('#divBongoApiStart').hide();
		$('#divBongoApiProgress').show();
		bongo().startSynch();
	});
}

/**
 * Call server function 
 */
function bongo_call(data, callback)
{
	$.ajax({
		type: 'POST',
		url: 'admin.php?chart=true&p=bongo',
		data: data,
  		success: function(data){
  			callback(data);
  		},
  		error: function(XMLHttpRequest, textStatus, errorThrown){
  			
  		},
  		dataType: 'json'
	});
}

/**
 * Get products count
 */
function bongo_startSynch()
{
	bongo().call(
		{
			'action': 'start-synch', 
			'export_all_products': $('#api_export_all_products').val()
		}, 
		function(data)
		{
			bongoTotalProducts = data.count;
			$('#divBongoApiProgress .progress').progressbar({max:bongoTotalProducts});
			$('#divBongoProgressText').html('Total products: ' + bongoTotalProducts);
			bongoThreadInterval = setInterval('bongo().synchProducts()', 250);
		}
	);
}

/**
 * Import products into DB
 */
function bongo_synchProducts()
{
	if (!bongoThreadActive)
	{
		bongoThreadActive = true;
		bongo().call(
			{
				action:'synch', 
				'offset':bongoPosition,
				'export_all_products': $('#api_export_all_products').val()
			},
			function(data)
			{
				bongoPosition = data.processed;
			
				if (bongoPosition + 1 >= bongoTotalProducts)
				{
					clearInterval(bongoThreadInterval);
					$('#divBongoProgressText').html('Synchronization finished');

					setTimeout("$('#divBongoApiProgress').hide();$('#divBongoApiStart').show();", 3000);
				}
				else
				{
					$('#divBongoProgressText').html('Synchronized ' + bongoPosition + ' out of ' + bongoTotalProducts + ' products');
				}

				$('#divBongoApiProgress .progress').progressbar({value:bongoPosition});
				
				bongoThreadActive = false;
			}
		);
	}
}

/**
 * Bongo class
 */
function bongo()
{
	if (typeof bongo.target == 'undefined') this.target = null;

	return {
		'init' : bongo_init,
		'call' : bongo_call,
		'startSynch' : bongo_startSynch,
		'synchProducts' : bongo_synchProducts
	}
}