function showDiv(div, td){
	d = document.getElementById(div);
	d.style.top = $(td).position().top + 10;
	d.style.left = $(td).position().left + 10;
	d.style.display = 'block';
}
function hideDiv(div, td){
	d = document.getElementById(div);
	d.style.display = 'none';
}

function isSelected(frm, field_name){
	var selected = false;
	$(".fields-selector").each(function(){
		if ($(this).val() == field_name)
		{
			selected = true;
			return;
		}
	});
	return selected;
}

function checkAssignForm(frm){
	//check required fields
	
	if(!isSelected(frm, "product_id")){
		alert("Please assign required Product ID");
		return false;
	}
	if(frm.elements["update_rule"].value != "update_only"){
		if(!isSelected(frm, "title")){
			alert("Please assign required Product Name");
			return false;
		}
		if(!isSelected(frm, "price")){
			alert("Please assign required Product Price");
			return false;
		}
	}
	
	//check digital product
	if((!isSelected(frm, "digital_product") && isSelected(frm, "digital_product_file")) ||
		(isSelected(frm, "digital_product") && !isSelected(frm, "digital_product_file"))
	){
		alert("Please assign both Digital Product and Digital Product File");
		return false;
	}
	
	//check attribute 1
	for (var a = 1; a <= 10; a++)
	{
		var s = 
			(isSelected(frm, "attribute_name_" + a) ? 1 : 0) +
			(isSelected(frm, "attribute_caption_" + a) ? 1 : 0) +
			(isSelected(frm, "attribute_options_" + a) ? 1 : 0) +
			(isSelected(frm, "attribute_type_" + a) ? 1 : 0);
		
		if (s > 0 && s < 4)
		{
			alert("Please assign all fields for Attribute " + a);
			return false;
		}
	}
	
	return true;
}

function checkCategoriesAssignForm(frm){
	//check required fields
	
	if(!isSelected(frm, "key_name")){
		alert("Please assign required Category Key");
		return false;
	}
	if(!isSelected(frm, "name")){
		alert("Please assign required Category Name");
		return false;
	}
	return true;
}

function checkManufacturersAssignForm(frm){
	if(!isSelected(frm, "manufacturer_code")){
		alert("Please assign required Manufacturer Id");
		return false;
	}
	if(!isSelected(frm, "manufacturer_name")){
		alert("Please assign required Manufacturer Name");
		return false;
	}
	return true;
}