$(document).ready(function(){
	$.getJSON("admin.php?p=charts&chart=true&version=2&mode=usage_by_month_hits&year="+chartDate.getFullYear()+"&month="+(chartDate.getMonth()+1)+"&chart_view=bar", function(chart){

		var sales_data = chart.data;

		var plot = null;

		if (chartType == "Column3D")
		{
			plot = $.plot($("#chartHits"), [{
					data: sales_data,
					label: chart.title,
					bars: { 
						show: true,barWidth: 24*60*60*1000, fill: true
					},
					color: "#9BCB60"
				}],
				{
					bars: { 
						show: true,barWidth: 24*60*60*1000, fill: true
					},
					grid: {
						hoverable: true,
						clickable: false,
						borderColor: '#ccc',
						borderWidth: 1,
						lineColor: '#fefefe'
					},
					xaxis: { mode: "time", tickSize: [1, "day"], minTickSize: [1, "day"], tickLength: 1, min: chart.xMin, timeformat: '%d' },
					yaxis: { autoscaleMargin: 0.1, tickDecimals: 0, min: 0, max: (chart.max + (chart.max / 4)), tickFormatter: function(v) { return sprintf(chart.yLabelFormat, v); } }
				}
			);
		}
		else
		{
			plot = $.plot($("#chartHits"),
				[{
					data: sales_data,
					label: chart.title,
					lines: { 
						show: true, 
						fill: true
					},
					color: "#9BCB60"
				}], {
					series: {
						lines: { show: true },
						points: { show: false }
					},
					grid: {
						hoverable: true,
						clickable: false,
						borderColor: '#ccc',
						borderWidth: 1,
						lineColor: '#fefefe'
					},
					xaxis: { mode: "time", tickSize: [1, "day"], minTickSize: [1, "day"], tickLength: 1, min: chart.xMin, timeformat: '%d' },
					yaxis: { autoscaleMargin: 0.1, tickDecimals: 0, min: 0, max: (chart.max + (chart.max / 4)), tickFormatter: function(v) { return sprintf(chart.yLabelFormat, v); }
				}
			});
		}

		plot.resize();
		
		var previousPoint = null;
		$('#chartHits').bind('plothover', function(e, pos, item){

			if ($(this).data('previousPoint') === undefined)

			if (item)
			{
				if (previousPoint != item.dataIndex)
				{
					previousPoint = item.dataIndex;
					var y = item.datapoint[1];
					showChartToolTip('hits', item.pageX, item.pageY, item.series.data[item.dataIndex][2]+'<br />'+y);
				}
			}
			else
			{
				$('#chart-tooltip-hits').remove();
				previousPoint = null;
			}
		});
	});

	$.getJSON("admin.php?p=charts&chart=true&version=2&mode=usage_by_month_hosts&year="+chartDate.getFullYear()+"&month="+(chartDate.getMonth()+1)+"&chart_view=bar", function(chart){

		var sales_data = chart.data;

		var plot = null;
		if (chartType == "Column3D")
		{
			plot = $.plot($("#chartTraffic"), [{
					data: sales_data,
					label: chart.title,
					bars: { 
						show: true,barWidth: 24*60*60*1000, fill: true
					},
					color: "#9BCB60"
				}],
				{
					bars: { 
						show: true,barWidth: 24*60*60*1000, fill: true
					},
					grid: {
						hoverable: true,
						clickable: false,
						borderColor: '#ccc',
						borderWidth: 1,
						lineColor: '#fefefe'
					},
					xaxis: { mode: "time", tickSize: [1, "day"], minTickSize: [1, "day"], tickLength: 1, min: chart.xMin, timeformat: '%d' },
					yaxis: { autoscaleMargin: 0.1, tickDecimals: 0, min: 0, max: (chart.max + (chart.max / 4)), tickFormatter: function(v) { return sprintf(chart.yLabelFormat, v); } }
				}
			);
		}
		else
		{
			plot = $.plot($("#chartTraffic"),
				[{
					data: sales_data,
					label: chart.title,
					lines: { 
						show: true, 
						fill: true
					},
					color: "#9BCB60"
				}], {
					series: {
						lines: { show: true },
						points: { show: false }
					},
					grid: {
						hoverable: true,
						clickable: false,
						borderColor: '#ccc',
						borderWidth: 1,
						lineColor: '#fefefe'
					},
					xaxis: { mode: "time", tickSize: [1, "day"], minTickSize: [1, "day"], tickLength: 1, min: chart.xMin, timeformat: '%d' },
					yaxis: { autoscaleMargin: 0.1, tickDecimals: 0, min: 0, max: (chart.max + (chart.max / 4)), tickFormatter: function(v) { return sprintf(chart.yLabelFormat, v); }
				}
			});
		}

		plot.resize();
		
		var previousPoint = null;
		$('#chartTraffic').bind('plothover', function(e, pos, item){

			if ($(this).data('previousPoint') === undefined)

			if (item)
			{
				if (previousPoint != item.dataIndex)
				{
					previousPoint = item.dataIndex;
					var y = item.datapoint[1];
					showChartToolTip('traffic', item.pageX, item.pageY, item.series.data[item.dataIndex][2]+'<br />'+y);
				}
			}
			else
			{
				$('#chart-tooltip-traffic').remove();
				previousPoint = null;
			}
		});
	});

	$.getJSON("admin.php?p=charts&chart=true&version=2&mode=sales_by_month&year="+chartDate.getFullYear()+"&month="+(chartDate.getMonth()+1)+"&chart_view=bar", function(chart){

		var sales_data = chart.data;

		var plot = null;
		if (chartType == "Column3D")
		{
			plot = $.plot($("#chartSales"), [{
					data: sales_data,
					label: chart.title,
					bars: { 
						show: true,barWidth: 24*60*60*1000, fill: true
					},
					color: "#9BCB60"
				}],
				{
					bars: { 
						show: true,barWidth: 24*60*60*1000, fill: true
					},
					grid: {
						hoverable: true,
						clickable: false,
						borderColor: '#ccc',
						borderWidth: 1,
						lineColor: '#fefefe'
					},
					xaxis: { mode: "time", tickSize: [1, "day"], minTickSize: [1, "day"], tickLength: 1, min: chart.xMin, timeformat: '%d' },
					yaxis: { autoscaleMargin: 0.1, tickDecimals: 0, min: 0, max: (chart.max + (chart.max / 4)), tickFormatter: function(v) { return sprintf(chart.yLabelFormat, v); } }
				}
			);
		}
		else
		{
			plot = $.plot($("#chartSales"),
				[{
					data: sales_data,
					label: chart.title,
					lines: { 
						show: true, 
						fill: true
					},
					color: "#9BCB60"
				}], {
					series: {
						lines: { show: true },
						points: { show: false }
					},
					grid: {
						hoverable: true,
						clickable: false,
						borderColor: '#ccc',
						borderWidth: 1,
						lineColor: '#fefefe'
					},
					xaxis: { mode: "time", tickSize: [1, "day"], minTickSize: [1, "day"], tickLength: 1, min: chart.xMin, timeformat: '%d' },
					yaxis: { autoscaleMargin: 0.1, tickDecimals: 0, min: 0, max: (chart.max + (chart.max / 4)), tickFormatter: function(v) { return sprintf(chart.yLabelFormat, v); }
				}
			});
		}

		plot.resize();
		
		var previousPoint = null;
		$('#chartSales').bind('plothover', function(e, pos, item){

			if ($(this).data('previousPoint') === undefined)

			if (item)
			{
				if (previousPoint != item.dataIndex)
				{
					previousPoint = item.dataIndex;
					showChartToolTip('sales', item.pageX, item.pageY, item.series.data[item.dataIndex][2]);
				}
			}
			else
			{
				$('#chart-tooltip-sales').remove();
				previousPoint = null;
			}
		});
	});
	
	
});

