$(document).ready(function(){

	/**
	 * Slider area
	 */
	$('.admin-form-header.slide-manager').each(function(){
		var manager = this;

		if ($(manager).find('.admin-form-header-buttons').length == 0)
		{
			$(manager).prepend('<div class="admin-form-header-buttons"></div>');
		}

		$(manager).find('.admin-form-header-buttons').append('<span class="icon ic-icon ic-arrow-down slide-switch"></span>');

		$(manager).click(function(){
			var area = $(manager).nextAll('.slide-area:first');
			if ($(area).length > 0)
			{
				var swtch = $(manager).find('.slide-switch');


				if ($(area).is(':visible'))
				{
					$(swtch).removeClass('ic-arrow-up').addClass('animate-down');
				}
				else
				{
					$(swtch).removeClass('ic-arrow-down').addClass('animate-up');
				}

				$(area).slideToggle('fast', 'linear', function(){

					if ($(area).is(':visible'))
					{
						$(swtch).removeClass('animate-up').addClass('ic-arrow-up');
					}
					else
					{
						$(swtch).removeClass('animate-down').addClass('ic-arrow-down');
					}
				});
			}
		});
	});

	/**
	 * Text editor
	 */
	$('.admin-form-header.editor-manager').each(function(){
		var manager = this;

		if ($(manager).find('.admin-form-header-buttons').length == 0)
		{
			$(manager).prepend('<div class="admin-form-header-buttons"></div>');
		}
		$(manager).find('.admin-form-header-buttons').append('<span class="icon ic-icon ic-pencil editor-switch"></span>');
		$(manager).find('.editor-switch').click(function(e){
			e.stopPropagation();
			var area = $(manager).next().find('.editor-area:first');
			if ($(area).length > 0)
			{
				toggleEditorMode($(area).attr('id'), false);
			}
		});
	});

	/**
	 * Image Preview
	 */
	$('.field.field-image-preview').each(function(){
		$(this).find('a').click(function(e){
			if ($(this).is('.delete_image'))
			{
				return false;
			}

			e.stopPropagation();

			if ($('#image-preview-dialog').length == 0)
			{
				$('<div id="image-preview-dialog"><div><div class="image-preview-dialog-image"><img/></div><div class="image-preview-dialog-description"></div></div></div>').appendTo('body');

				$('#image-preview-dialog').dialog({
					title: 'Image Preview',
					autoOpen: false,
					modal: true,
					width: 700,
					height: 500,
					open: function(){
						$(this).dialog('option', 'width', 700);
						$(this).dialog('option', 'height', 500);
						//correctDialogPosition("#image-preview-dialog");
					}
				});

				$('#image-preview-dialog .image-preview-dialog-image img').load(function(){
					adminHideSpinner();
					$('#image-preview-dialog').dialog('open');
				});
			}

			adminShowSpinner('Loading image preview');
			$('#image-preview-dialog .image-preview-dialog-description').html($(this).parent().parent().find('.image-preview-info').html());
			$('#image-preview-dialog .image-preview-dialog-image img').attr('src', $(this).attr('href'));

			return false;
		});
	});

	/**
	 * Color picker
	 */
	$('.field-color input[type="text"]').each(function(){
		var input = this;
		$(input).ColorPicker({
			onSubmit: function(hsb, hex, rgb, el) {$(el).val('#'+hex);$(el).ColorPickerHide();},
			onBeforeShow: function() {$(input).ColorPickerSetColor(input.value);return false;},
			onChange: function (hsb, hex, rgb) {
				$(input).val('#' + hex);
				$(input).parent().find('.color-preview-inner').css({backgroundColor:'#' + hex});
			}
		})
		.change(function(){
			$(input).ColorPickerSetColor(this.value);
		});
	});

	/**
	 * Date & time
	 */
	$('.field-date,.field-datetime').each(function(index, field){
		$(field).find('.field-date-month,.field-date-year,.field-datetime-month,.field-datetime-year').change(function(){
			var year = $(field).find('.field-date-year,.field-datetime-year').val();
			var month = $(field).find('.field-date-month,.field-datetime-month').val();
			var daysInMonth = new Date(year, month, 0).getDate();
			var daySelect = $(field).find('.field-date-day,.field-datetime-day');

			$(daySelect).find('option').each(function(dayOptionIndex, dayOption){
				$(dayOption).attr('value') > daysInMonth ? 	$(dayOption).hide() : $(dayOption).show();
			});

			if ($(daySelect).val() > daysInMonth) $(daySelect).val(daysInMonth);
		}).change();
	});

	/**
	 * Basic form validation
	 */
	$('form[data-auto-validate="1"]').each(function(formIndex, form){
		$(form).submit(function(e){
			$(form).find('input,select,textarea').removeClass('error');

			var isError = false;

			$(form).find('input,select,textarea').each(function(elementIndex, element){
				if ($(element).attr('data-required') == '1' && $.trim($(element).val()) == '')
				{
					$(element).addClass('error');
					$(element)
						.click(function(){$(this).removeClass('error');})
						.keypress(function(){$(this).removeClass('error');});
					if (!isError) $(element).focus();
					isError = true;
				}
			});

			if (isError)
			{
				adminHideSpinner();
				$.jGrowl(
					'Please enter all required fields',
					{
						life:12000,
						speed: 'slow',
						sticky: true,
						theme: 'alert alert-error',
						position: 'center',
						width: '300px'
					}
				);
				e.preventDefault();
			}

			return !isError;
		});
	});
});