$(document).ready(function()
{
    $('#admin-tab-sheet-enlabel input').keypress(function(evt){
        var charCode = (evt.which) ? evt.which : evt.keyCode;

        if (charCode == 13)
        {
            $('#postageSubmit').click();
            return false;
        }

        return true;
    });

    $('input.number').keypress(function(evt)
    {
        var num = $(this).val();

        var charCode = (evt.which) ? evt.which : evt.keyCode;
        if (num.indexOf('.') >= 0 && charCode == 46)
        {
            return false;
        }
        if (charCode != 46 && charCode > 31 && (charCode < 48 || charCode > 57))
        {
            return false;
        }

        return true;
    });

    $('#endiciaLabelDialog').dialog({
        autoOpen: false,
        modal: true,
        width: 415,
        height: 700,
        resizable: false,
        buttons: [
            {
                text: "Print",
                click: function() {
                    window.frames["endiciaLabelIframe"].focus();
                    window.frames["endiciaLabelIframe"].print(); }
            },
            {
                text: "Close",
                click: function() { $(this).dialog("close"); }
            }
        ]
    });

    var dialog = $('#endiciaAddPostage').dialog({
        autoOpen: false,
        modal: true,
        width: 500,
        height: 450,
        draggable: false,
        resizable: false
    });

    $('#opener').click(function() {
        dialog.dialog('open');
        return false;
    });

    $('#postageSubmit').click(endiciaGetPostageSubmit);
    $('#fundsSubmit').click(endiciaAddFundsSubmit);

    $('#packagetype').change(function(){
        endiciaControlDeliveryService();
    });

    $('#classofmail').change(function(){
        endiciaOnMailClassChange();
    });

    endiciaControlDeliveryService();

	$('.endicia-view-label-link').each(function(index, a){
		$(a).click(function(e){
			e.stopPropagation();

			endicialShowLabelDialog($(a).attr('href'), $(a).attr('rel'));

			return false;
		})
	});

});

function endiciaIsEmpty(inputName)
{
    return $.trim($('input[name='+inputName+']').val()) == '';
}

function endiciaSetfocus(inputName)
{
    $('input[name='+inputName+']').focus();
}

function endiciaGetValue(inputName)
{
    return $('[name='+inputName+']').val();
}

function endiciaGetRadioValue(inputName)
{
    return $('input[name='+inputName+']:checked').val();
}

function endiciaGetIsChecked(inputName)
{
    return $('input[name='+inputName+']').is(':checked');
}

function endiciaResetCheckbox(inputName)
{
    return $('input[name='+inputName+']').attr('checked', false);
}

function endiciaAddFundsSubmit(form)
{
    if (endiciaIsEmpty('passconfirm'))
    {
        alert("You must confirm your Endicia Account Passphrase.");
        endiciaSetfocus('passconfirm');
        return false;
    }

    if (endiciaIsEmpty('amount_to_add'))
    {
        alert("You must provide an amount to add to your Endicia account.");
        return false;
    }

    $('#endiciapostagestep1').hide();
    $('#endiciapostagestep2').show();

    $.ajax
        ({
            type: "POST",
            url: "admin.php?p=endicia_addfundstoaccount&chart=true",
            data: $('#endiciapostagestep1 input').serialize(),
            success: function(response)
            {
                if(response.result == 1)
                {
                    $('#endiciapostagestep2').hide();
                    $('#endiciabalance').hide();
                    $('#endiciabalanceupdated').show();
                    $('#updatebal').html(response.newbal);
                    $('#endiciaAddPostage').dialog('close');
                }

                else
                {
                    if(response.result == 0)
                    {
                        $('#endiciapostagestep2').hide();
                        $('#endiciapostagestep1').show();
                        $('#error1').show();
                    }

                    else
                    {
                        $('#endiciapostagestep2').hide();
                        $('#endiciapostagestep1').show();

                        if (response.message)
                        {
                            $('#error2').text(response.message);
                        }
                        else
                        {
                            $('#error2').text('We were unable to Add Funds to your Account');
                        }

                        $('#error2').show();
                    }


                }
            },
            dataType: 'json'
        });

    return false;
}


function endicialShowLabelDialog(labelUrl, trackingNumber)
{
	var ifrm = document.getElementById('endiciaLabelIframe');
	ifrm = (ifrm.contentWindow) ? ifrm.contentWindow : (ifrm.contentDocument.document) ? ifrm.contentDocument.document : ifrm.contentDocument;

	iframeHead = '<link rel="stylesheet" type="text/css" href="content/admin/styles/print.css?3714r1">';

	if ($.browser.msie)
	{
		iframeHead += '<link rel="stylesheet" type="text/css" href="content/admin/styles/print-ie.css?3714r1" media="print">';
	}
	else if(/chrom(e|ium)/.test(navigator.userAgent.toLowerCase()))
	{
		iframeHead += '<link rel="stylesheet" type="text/css" href="content/admin/styles/print-chrome.css?3714r1" media="print">';
	}

	ifrm.document.open();
	ifrm.document.write('<html><head>' + iframeHead + '</head><body style="padding:0px;margin:0px;"><img class="print-label-image" style="border:none;" src="admin.php?p=endicia_viewlabel&f=' + labelUrl + '"></body></html>');
	ifrm.document.close();
	$('#endiciaLabelDialog').data('endiciaLabelImageUrl', 'admin.php?p=endicia_viewlabel&f=' + labelUrl);
	$('#endiciaLabelDialog').dialog({title:'USPS Shipping Label - ' + trackingNumber});

	$('form[name="frmEndicia"] input[name="shipping_tracking_number"]').val(trackingNumber);
	$('form[name="frmEndicia"] select[name="shipping_tracking_number_type"]').val('USPS');
	$('#endiciaLabelDialog').dialog('open');
}

function endiciaGetPostageSubmit(form)
{
    if (endiciaIsEmpty('WeightOz'))
    {
        alert("You Must Enter the Package Weight");
        endiciaSetfocus('WeightOz');
        return false;
    }

    if (endiciaIsEmpty('DeclaredValue'))
    {
        alert("You Must Declare the Package's Value");
        endiciaSetfocus('DeclaredValue');
        return false;
    }

    if (endiciaIsEmpty('PackageDescription'))
    {
        alert("You Must fill out the Package Description");
        endiciaSetfocus('PackageDescription');
        return false;
    }

    if (endiciaIsEmpty('Length'))
    {
        alert("You Must Enter the Package Length");
        endiciaSetfocus('Length');
        return false;
    }

    if (endiciaIsEmpty('Width'))
    {
        alert("You Must Enter the Package Width");
        endiciaSetfocus('Width');
        return false;
    }

    if (endiciaIsEmpty('Height'))
    {
        alert("You Must Enter the Package Height");
        endiciaSetfocus('Height');
        return false;
    }

    if ((endiciaGetValue('MailShape')) == 'Choose')
    {
        alert("You must Choose a Package Type");
        return false;
    }

    var mweight = parseFloat(endiciaGetValue('WeightOz'));
    var mclass = endiciaGetValue('MailClass');
    var mvalue = parseFloat(endiciaGetValue('DeclaredValue'));
    var mshiptocountry = endiciaGetValue('shiptocountry');
    var mlength = parseFloat(endiciaGetValue('Length'));
    var mwidth = parseFloat(endiciaGetValue('Width'));
    var mheight = parseFloat(endiciaGetValue('Height'));
    var mpack = endiciaGetValue('MailShape');

    if (mpack == 'Letter' && mweight > 3.5)
    {
        alert("The maximum weight for a standard letter is 3.5 ounces.");
        endiciaSetfocus('WeightOz');
        return false;
    }

    if (mlength > 130)
    {
        alert("The maximum length of a package allowed by the USPS is 130 inches");
        setFocus('Length');
        return false;
    }

    if (mwidth > 130)
    {
        alert("The maximum width of a package allowed by the USPS is 130 inches");
        endiciaSetfocus('Width');
        return false;
    }

    if (mheight > 130)
    {
        alert("The maximum height of a package allowed by the USPS is 130 inches");
        endiciaSetfocus('Height');
        return false;
    }

    if ((endiciaGetIsChecked('CertifiedMail')) && ((mclass != 'First') && (mclass != 'PriorityMail')))
    {
        alert("Certified Mail can only be selected for First-Class or Priority Mail types.");
        endiciaResetCheckbox('CertifiedMail');
        endiciaSetfocus('CertifiedMail');
        return false;
    }

    if ((mclass == 'CriticalMail') && ((mpack != 'Letter') &&  (mpack != 'Flat')))
    {
        alert("Critical Mail can only be used with Letter or Flat Package types.");
        endiciaResetCheckbox('CriticalMail');
        return false;
    }

    if ((mshiptocountry != 'United States') && (endiciaGetIsChecked('ReturnReceipt')) )
    {
        alert("You cannot select Return Receipt with International Mail");
        endiciaResetCheckbox('ReturnReceipt');
        endiciaSetfocus('ReturnRecept');
        return false;
    }

    if ((mclass == 'StandardMail') && (mweight > 16))
    {
        alert("Standard Mail cannot weigh more than 16 ounces.");
        endiciaSetfocus('MailClass');
        return false;
    }

    if ((endiciaGetIsChecked('RestrictedDelivery')) && ((mvalue < 200) || (!endiciaGetIsChecked('CertfiedMail'))))
    {
        alert("Restricted Delivery must be selected in conjunction with Insurace (amount must be over $200) or Certified Mail");
        endiciaResetCheckbox('RestrictedDelivery');
        endiciaSetfocus('RestrictedDelivery');
        return false;
    }

    if ((shipToCountryCode == 'US') && mclass == ('ExpressMailInternational'))
    {
        alert("You cannot ship International Mail to the United States");
        return false;
    }

    if ((mclass == 'Express' || mclass == 'ExpressMailInternational') && (mweight < 13))
    {
        alert("Express Mail must weigh more than 13 ounces");
        return false;
    }

    var _formMode = $('input[name=mode]').val();
    $('input[name=mode]').val('getPostage');

    adminShowSpinner('Generating shipping label');

    var formData = $('form[name=frmEndicia]').serialize();
    $.ajax({
        type: 'POST',
        url: 'admin.php?p=endicia_generatepostagelabel&chart=true',
        data: formData,
        success: function(data){
            $('input[name=mode]').val(_formMode);

			adminHideSpinner();

            if (data.result == 1)
            {
				endicialShowLabelDialog(data.labelUrl, data.trackingNumber);
            }
            else
            {
                alert(data.error);
            }
        },
        error: function()
        {
            $('input[name=mode]').val(_formMode);
            adminHideSpinner();
        }
    });

    $('input[name=mode]').val(_formMode);

    return false;
}

function endiciaControlDeliveryService()
{
    var packtype = endiciaGetValue('MailShape');

    $("#packagetype option[value='Choose']").remove();
    $('#plength').val('');
    $('#pheight').val('');
    $('#pwidth').val('');

    if (packtype == 'Parcel' || packtype == 'LargeParcel' )
    {
        $('#classofmail').children().remove().end();
        if (shipToCountryCode == 'US')
        {
            $('#classofmail').append('<option value="First">First Class Mail</option>');
            $('#classofmail').append('<option value="Express">Express Mail</option>');
            $('#classofmail').append('<option value="Priority">Priority Mail</option>');
            $('#classofmail').append('<option value="ParcelPost">Standard Post</option>');
            $('#classofmail').append('<option value="ParcelSelect">Parcel Select</option>');
        }
        else
        {
            $('#classofmail').append('<option value="FirstClassMailInternational">First-Class Mail International</option>');
            $('#classofmail').append('<option value="ExpressMailInternational">Express Mail International</option>');
            $('#classofmail').append('<option value="PriorityMailInternational">Priority Mail International</option>');
        }

        if ((packtype == 'Parcel') && (shipToCountryCode == 'US'))
        {
            $('#classofmail').append('<option value="LibraryMail">Library Mail</option> ');
            $('#classofmail').append('<option value="MediaMail">Media Mail</option> ');
        }
    }
    else if (packtype == 'Letter')
    {
        $('#classofmail').children().remove().end();

        if (shipToCountryCode == 'US')
        {
            $('#classofmail').append('<option value="First">First Class Mail</option>');
            $('#classofmail').append('<option value="CriticalMail">Critical Mail</option>');
        }
        else
        {
            $('#classofmail').append('<option value="FirstClassMailInternational">First-Class Mail International</option>');
        }

        endiciaSetPackageDimensions(8.375, 0, 4.125, false);
    }
    else if (packtype == 'Card')
    {
        $('#classofmail').children().remove().end();

        if (shipToCountryCode == 'US')
        {
            $('#classofmail').append('<option value="First">First Class Mail</option>');
        }

        endiciaSetPackageDimensions(6.9, 0, 4.9, false);
    }
    else if (packtype == 'Flat')
    {
        $('#classofmail').children().remove().end();

        if (shipToCountryCode == 'US')
        {
            $('#classofmail').append('<option value="First">First Class Mail</option>');
            $('#classofmail').append('<option value="Priority">Priority Mail</option>');
            $('#classofmail').append('<option value="CriticalMail">Critical Mail</option>');
        }
        else
        {
            $('#classofmail').append('<option value="FirstClassMailInternational">First-Class Mail International</option>');
            $('#classofmail').append('<option value="PriorityMailInternational">Priority Mail International</option>');
        }

        $('#pwidth').val('0');
    }
    else if(packtype == 'SmallFlatRateBox' || packtype == 'MediumFlatRateBox' || packtype == 'LargeFlatRateBox' ||
        packtype == 'SmallFlatRateEnvelope' || packtype == 'FlatRateEnvelope' || packtype == 'FlatRateLegalEnvelope' ||
        packtype == 'FlatRatePaddedEnvelope' || packtype == 'FlatRateWindowEnvelope' ||
        packtype == 'FlatRateCardboardEnvelope' || packtype == 'FlatRateGiftCardEnvelope')
    {
        $('#classofmail').children().remove().end();

        if (shipToCountryCode == 'US')
        {
            $('#classofmail').append('<option value="Priority">Priority Mail</option>');
        }
        else
        {
            $('#classofmail').append('<option value="PriorityMailInternational">Priority Mail International</option>');
        }

        // $('#plength').attr('readonly', false);
        // $('#pwidth').attr('readonly', false);
        // $('#pheight').attr('readonly', false);

        if(packtype == 'SmallFlatRateBox')
        {
            endiciaSetPackageDimensions(8.625, 1.625, 5.375, false);
        }

        if(packtype == 'MediumFlatRateBox')
        {
            endiciaSetPackageDimensions(13.625, 3.375, 11.875, true);
        }

        if(packtype == 'LargeFlatRateBox')
        {
            endiciaSetPackageDimensions(12, 5.5, 12, false);
        }

        if(packtype == 'FlatRateEnvelope')
        {
            endiciaSetPackageDimensions(12.5, 0, 9.5, true);
        }

        if(packtype == 'SmallFlatRateEnvelope')
        {
            endiciaSetPackageDimensions(6, 0, 10);
        }

        if(packtype == 'FlatRateWindowEnvelope')
        {
            endiciaSetPackageDimensions(5, 0, 10);
        }

        if(packtype == 'FlatRatePaddedEnvelope')
        {
            endiciaSetPackageDimensions(12.5, 0, 9.5, false);
        }

        if(packtype == 'FlatRateLegalEnvelope')
        {
            endiciaSetPackageDimensions(15, 0, 9.5, true);
        }

        if(packtype == 'FlatRateGiftCardEnvelope' || packtype == 'FlatRateCardboardEnvelope')
        {
            endiciaSetPackageDimensions(10, 0, 7, false);
        }
    }

    endiciaOnMailClassChange();
}

function endiciaOnMailClassChange()
{
    var mailShape = endiciaGetValue('MailShape');
    var mailClass = endiciaGetValue('MailClass');

    if (mailShape == 'Parcel' && mailClass == 'ParcelSelect')
    {
        alert(123);
        $("#endicia-sort-type").show('fast');
        $("#endicia-entry-facility").show('fast');
    }
    else
    {
        $("#endicia-sort-type").hide('fast');
        $("#endicia-entry-facility").hide('fast');
    }
}

function endiciaSetPackageDimensions(length, width, height, appendExpressMail)
{
    $('#plength').val(length);
    $('#pwidth').val(width);
    $('#pheight').val(height);

    if (appendExpressMail)
    {
        if (shipToCountryCode == 'US')
        {
            $('#classofmail').append('<option value="Express">Express Mail</option>');
        }
        else
        {
            $('#classofmail').append('<option value="ExpressMailInternational">Express Mail International</option>');
        }
    }
}