$(document).ready(function() {
	$("#searchStr").autocomplete({
		source: function(request, response) {
			$.ajax({
				url: 'admin.php?p=auto_complete&&chart=true&mode=products_gifts',
				dataType: 'json',
				data: {
					q: request.term,
					l: '10'
				},
				success: function(data) {
					response($.map(data, function(item) {
						return {
							label: item.product_id + ' - ' + item.title,
							value: item.pid
						}
					}));
				}
			});
		},
		select: function(event, ui) {
			if (ui.item) {
				addProduct(ui.item.value, ui.item.label);
			}
			event.preventDefault();
			event.stopPropagation();
		}
	});
});

function addProduct(pid, label)
{
	var prod_quantity = $("#field-gift_product_quantity").val();
	var max_quantity = $("#field-gift_max_product_quantity").val();
	var free_shipping = $("#field-gift_product_free_shipping").val();
	if (!checkNumber(prod_quantity))
	{
		alert("Please enter valid Free Product Quantity value.\nBy default it is 1.");
		$("#field-gift_product_quantity").focus();
		return false;
	}
	if (!checkNumber(max_quantity))
	{
		alert("Please enter valid Maximum Number of Free Product value.\nBy default it is 999.");
		$("#field-gift_max_product_quantity").focus();
		return false;
	}
	code = pid+'|'+prod_quantity+'|'+free_shipping+'|'+max_quantity;
	var nm = prod_quantity + '-' + max_quantity + ' x ' + label + '; Shipping: ' + (free_shipping == "Yes"?"Free":"Not Free");

	var s = document.getElementById('pr_gifts');
	exists = false;
	for(i=0; i < s.options.length; i++){
		var _pid = s.options[i].value;
		if(_pid.substring(0, pid.length) == pid){
			exists = i+1;
			break;
		}
	}
	if(exists){
		alert("This products already exists in gifts list");
		s.options[exists-1] = new Option(nm, code);
		return false;
	}
	else{
		var k = s.options.length;
		s.options[k] = new Option(nm, code);
	}
}

function removeFromGifts(){
	var s = document.getElementById('pr_gifts');
	var a = Array();
	var isSelected = false;
	for(i = 0; i<s.options.length; i++){
		if(!s.options[i].selected){
			a[a.length] = s.options[i];
		}
		else{
			isSelected = true;
		}
	}
	if(isSelected && confirm("Do you really want to remove products?")){
		s.options.length = 0;
		for(i=0; i<a.length; i++){
			s.options[s.length] = a[i];
		}
	}
}
