$(document).ready(function(){
	/**
	 * The onclick event handler for the quick start guide link on the top menu
	 */
	$('#quick-start-guide-link').click(function(){
		QuickStartGuide_show();
		return false;
	});

	$('#QuickStartGuide').data('loader', false);

	if (autoOpenQuickStartGuide) QuickStartGuide_show();
});

/**
 * Load and show HTML from server
 */
function QuickStartGuide_show()
{
	if ($('#QuickStartGuide').data('loaded'))
	{
		// set buttons
		$('#quick-start-guide-complete-link').hide();
		$('#quick-start-guide-previous-step-link').hide();
		$('#quick-start-guide-next-step-link').show();
		$('.turn-off-quick-start').show();
		QuickStartGuide_goToSection(1);
		$("#QuickStartGuide").dialog("open");
		$("#QuickStartGuide").height('680px');
		correctDialogPosition("#QuickStartGuide");
	}
	else
	{
		adminShowSpinner('Preparing guide for you');
		
		$.post(
			'admin.php?p=quick_start_guide&triggerHelper=true',
			{
				'action': 'getDialogHTML',
				'data': true
			},
			function(response)
			{
				adminHideSpinner();
				
				var resp = JSON.parse(response);

				if (!resp.result)
				{
					//alert('There was a problem rendering quick start guide dialog');
				}
				else
				{
					qsg_categoryLayout = resp.qsg_categoryLayout;
					qsg_categoryDefaultView = resp.qsg_categoryDefaultView;
					qsg_productLayout = resp.qsg_productLayout;
					qsg_checkoutProcess = resp.qsg_checkoutProcess;
					
					$("#QuickStartGuideInner").css("min-width", "500px");
					$("#QuickStartGuideInner").html(resp.result);
					$('#QuickStartGuide').dialog({
						modal: true,
						width: 670,
						height: 715,
						maxWidth: 700,
						showTitle: false,
						resizable: false,
						dialogClass: 'quick-start-dialog',
						autoOpen: false,
						closeOnEscape: false,
						title: 'Quick Start Guide',
						open: function(ev, ui)
						{
							correctDialogPosition("#QuickStartGuide");
						}
					}); 
					QuickStartGuide_init();
					
					// set buttons
					$('#quick-start-guide-complete-link').hide();
					$('#quick-start-guide-previous-step-link').hide();
					$('#quick-start-guide-next-step-link').show();
					$('.turn-off-quick-start').show();
					
					QuickStartGuide_goToSection(1);
					$('#QuickStartGuide').data('loaded', true);
					$("#QuickStartGuide").dialog("open");
					$("#QuickStartGuide").height('680px');
					correctDialogPosition("#QuickStartGuide");
					
					//load themes
					QuickStartGuide_loadThemes();
				}
			}
		);
	}
}

/**
 * Load themes from server
 */ 
function QuickStartGuide_loadThemes()
{
	adminShowSpinner('Loading available themes');
	var themeRepository = document.location.protocol + '//www.cartmanual.com/themes';
	$.ajax({
		url: themeRepository + '/list/?v='+cartVersion,
		dataType: 'jsonp',
		success: function (data)
		{
			var html = '';
			//show current themes
			$.each(currentThemes, function(key, theme){
				html = html + 
					'<li class="' + (theme.current ? 'current' : '') + '" id="qst-theme-' + theme.name + '">' + 
						'<p class="title">' + theme.title + '</p>' + 
						'<a class="preview" title="' + theme.title + '" href="content/skins/' + theme.name + '/' + theme.fullsizeImage + '"><img src="content/skins/' + theme.name + '/' + theme.thumbnailImage + '"/></a>' + 
						'<p class="activate"' + (theme.current ? ' style="display:none;"' : '') + '><a class="activate" href="#' + theme.name + '">Activate</a></p>' + 
						'<p class="current"' + (!theme.current ? ' style="display:none;"' : '') + '>Currently Used</p>' + 
					'</li>';
			});
			
			//show loaded themes
			$.each(data.themes, function(key, theme){
				//check is this theme already in a cart
				if (currentThemes[theme.key] == undefined || currentThemes[theme.key] == null)
				{
					var href = themesInstallable ? '#' + theme.key : themeRepository + '/downloads/' + theme.key + '.zip';
					html = html + 
						'<li id="qst-theme-' + theme.key + '">' + 
							'<p>' + theme.name + '</p>' + 
							'<a class="preview" title="' + theme.name + '" href="' + themeRepository + '/downloads/' + theme.preview + '"><img src="' + themeRepository + '/downloads/' + theme.thumbnail + '"/></a>' + 
							'<p class="install">' + 
								'<a class="' + (themesInstallable ? 'installable' : 'downloadable' ) + '" href="' + href + '">' +
									(themesInstallable ? 'Install &amp; Activate' : 'Download') +
								'</a>' + 
							'</p>' + 
							'<p class="activate" style="display:none;"><a class="activate" href="#' + theme.key + '">Activate</a></p>' + 
							'<p class="current" style="display:none;">Currently Used</p>' + 
						'</li>';
				}
			});
			
			$('#QuickStartGuideInner .themes-area ul.themes').html(html);
			
			$('#QuickStartGuideInner .themes-area ul.themes a.preview').fancybox({
				'zoomSpeedIn': 500,
				'zoomSpeedOut': 300,
				'transactionIn': 'elastic',
				'showCloseButton': true,
				'titlePosition': 'inside',
				'titleFormat': 'formatTitle'
			}); 
			
			/**
			 * Activate skin
			 */ 
			$('#QuickStartGuideInner .themes-area ul.themes a.activate').each(function(){
				$(this).click(function(event){
					
					if (!confirm('* * * PLEASE CONFIRM * * *\n\nAre you sure you want to activate the selected theme?\n\nPlease note: activating this theme will discard all layout changes you previously made')) return;
					
					event.stopPropagation();
					var key = $(this).attr('href');
					key = key.substring(1);
					
					QuickStartGuide_activateTheme(key);
				});
			});
			
			/**
			 * Install & Activate
			 */
			$('#QuickStartGuideInner .themes-area ul.themes a.installable').each(function(){
				$(this).click(function(event){
					
					if (!confirm('* * * PLEASE CONFIRM * * *\n\nAre you sure you want to install and activate the selected theme?\n\nPlease note: activating this theme will discard all layout changes you previously made')) return;
					
					event.stopPropagation();
					var key = $(this).attr('href');
					key = key.substring(1);
					
					adminShowSpinner('Installing Theme');
					
					$.get('admin.php?p=design_settings&chart=true&install=' + key , function(response){
						response = eval('(' + response + ')');
						if (response.result == 'success')
						{
							$('#qst-theme-' + key + ' p.install').hide();
							$('#qst-theme-' + key + ' p.activate').show();
							
							QuickStartGuide_activateTheme(key);
						}
						else
						{
							adminHideSpinner();
							alert('Cannot install theme.');
						}
					});
					return false;
				});
			});
			
			adminHideSpinner();
		}
	});
}					

/**
 * Activate theme
 */
function QuickStartGuide_activateTheme(themeName)
{
	adminShowSpinner('Activating Theme');
	$.get('admin.php?p=design_settings&chart=true&skinName=' + themeName + '&layoutConfig=default', function(response){
		response = eval('(' + response + ')');
		if (response.result == 'success')
		{
			adminShowSpinner('Rendering Theme');
			$.get('index.php', function(response2){
				adminHideSpinner();
				$('#QuickStartGuideInner .themes-area .current p.current').hide();
				$('#QuickStartGuideInner .themes-area .current p.activate').show();
				$('#QuickStartGuideInner .themes-area li.current').removeClass('current');
				$('#qst-theme-' + themeName + ' p.activate').hide();
				$('#qst-theme-' + themeName + ' p.current').show();
				$('#qst-theme-' + themeName).addClass('current');
			});
		}
		else
		{
			adminHideSpinner();
			alert('Cannot activate theme.');
		}
	});
}

/**
 * Save information
 * @param step
 */
function QuickStartGuide_saveInformation(step)
{
	var saveAction = '';
	switch (step)
	{
		// Company Information
		case 1:saveAction = 'saveCompanyInformation';break;
		case 3:saveAction = 'saveCategoryLayout';break;
		case 4:saveAction = 'saveProductLayout';break;
		case 5:saveAction = 'saveCheckoutProcess';break;
		case 6:saveAction = 'saveSeoInformation';break;
	}

	if (saveAction != '')
	{
		$.post('admin.php?p=quick_start_guide&triggerHelper=true', {
			'action': saveAction,
			'data': $('#quick-start-guide-form').serialize()
		});
	}
}

/**
 * Displays the requested section on the quick start guide
 * @param step
 */
function QuickStartGuide_goToSection(step)
{
	// store the current section and the new requested section
	var oldSection = parseInt($('#QuickStartGuide').data('selectedSection'));
	var newSection = parseInt(step);

	var totalSections = $('#QuickStartGuide .section').length;

	newSection = newSection < 1 ? 1 : newSection;
	newSection = newSection > totalSections ? totalSections : newSection;


	$('#QuickStartGuide .section').hide();
	$('#QuickStartGuide .section-' + newSection).fadeIn('fast');

	// if old and new do not match, continue with changing sections
	if (oldSection != newSection)
	{
		$('.quick-start-guide-footer span.selected').removeClass('selected');
		$('.quick-start-guide-footer span[section="'+newSection+'"]').addClass('selected');

		$('#QuickStartGuide').data('selectedSection', newSection);

		//var newMargin = 0 - (newSection - 1) * 700;
		//$('#QuickStartGuide .quick-start-guide-sections').animate({marginLeft:newMargin + 'px'}, 500, 'linear');
		
		if (newSection == 1)
		{
			if (oldSection == 8)
			{
				$('#quick-start-guide-complete-link').fadeOut('slow', function(){
					$('.turn-off-quick-start').fadeIn('slow');
					$('#quick-start-guide-next-step-link').fadeIn('slow');
				});
			}
			else
			{
				$('#quick-start-guide-previous-step-link').fadeOut('slow', function(){
					$('.turn-off-quick-start').fadeIn('slow');	
				});
			}
		}
		else if (newSection == 8)
		{
			if (oldSection == 1)
				$('.turn-off-quick-start').fadeOut('slow');
			else
				$('#quick-start-guide-previous-step-link').fadeOut('slow');
			
			$('#quick-start-guide-next-step-link').fadeOut('slow', function(){
				$('#quick-start-guide-complete-link').fadeIn('slow');
			});
		}
		else
		{
			if (oldSection == 1)
			{
				$('.turn-off-quick-start').fadeOut('slow', function(){
					$('#quick-start-guide-previous-step-link').fadeIn('slow');
				});
			}
			else if (oldSection == 8)
			{
				$('#quick-start-guide-complete-link').fadeOut('slow', function(){
					$('#quick-start-guide-next-step-link').fadeIn('slow');
					$('#quick-start-guide-previous-step-link').fadeIn('slow');
				});
			}
			else
			{
				$('#quick-start-guide-previous-step-link').fadeIn('slow');		
			}
		}
	}	
}

/**
 * Goes to the next section from the current position
 */
function QuickStartGuide_goToNextSection()
{
	var step = $('#QuickStartGuide').data('selectedSection') + 1;
	QuickStartGuide_goToSection(step);
}

/**
 * Goes to the previous section from the current position
 */
function QuickStartGuide_goToPreviousSection()
{
	var step = $('#QuickStartGuide').data('selectedSection') - 1;
	QuickStartGuide_goToSection(step);
}

/**
 * Init dialog after loading
 */
function QuickStartGuide_init()
{
	/**
	 * The onclick event handler for the step links
	 */
	$('.quick-start-guide-footer span, .quick-start-guide-footer a').click(function(){
		QuickStartGuide_goToSection(parseInt($(this).attr('section')));
		return false;
	});

	/**
	 * The onclick event handler for the next step button
	 * this event will hide the button if it has reached the last step
	 */
	$('#quick-start-guide-next-step-link').click(function(){
		QuickStartGuide_saveInformation($('#QuickStartGuide').data('selectedSection'));
		QuickStartGuide_goToNextSection();
		return false;
	});

	/**
	 * The onclick event handler for the next step button
	 */
	$('#quick-start-guide-previous-step-link').click(function(){
		QuickStartGuide_goToPreviousSection();
		return false;
	});

	/**
	 * The onclick event handler for the complete button
	 */
	$('#quick-start-guide-complete-link').click(function(){
		$('#QuickStartGuide').dialog('close');
	});

	/**
	 * The onchange event for the display on startup checkbox
	 */
	$('#turn-off-quick-start').change(function(){
		$.post('admin.php?p=quick_start_guide&triggerHelper=true', {
			'action': 'setDisplayOnStartup',
			'data': this.checked
		});
	});

	/**
	 * The onchange event for the display on startup checkbox
	 */
	$('#activate-seo').change(function(){
		$.post('admin.php?p=quick_start_guide&triggerHelper=true', {
			'action': 'setActivateSearchEngineUrl',
			'data': this.checked
		});
	});

	/**
	 * The onclick event for the remove test products/categories button
	 */
	$('#quick-start-guide-remove-items-button').click(function(){
		if (confirm('Are you sure you want to remove test products & categories?'))
		{
            adminShowSpinner('Removing test products & categories');
            
			$.post('admin.php?p=quick_start_guide&triggerHelper=true', {
				'action': 'removeTestItems',
				'data': true
			}, function(response){
                
                adminHideSpinner();
				
                resp = JSON.parse(response);

				if (!resp.result)
				{
					alert('There was a problem removing the test products.');
				}
				else
				{
					alert('You have successfully removed all test products.');
					$('div.add-test-items').show();
					$('div.remove-test-items').hide();
				}
			});
		}
	});

	/**
	 * The onclick event for the add test products/categories button
	 */
	$('#quick-start-guide-add-items-button').click(function(){
		if (confirm('Are you sure you want to add all test products & categories?'))
		{
            adminShowSpinner('Adding test products & categories');
             
			$.post('admin.php?p=quick_start_guide&triggerHelper=true', {
				'action': 'addTestItems',
				'data': null
			}, function(response){
                
                adminHideSpinner();
                
				resp = JSON.parse(response);

				if (!resp.result)
				{
					alert('There was a problem importing test products.');
				}
				else
				{
					alert('You now have test products in your shopping cart.');
					$('div.add-test-items').hide();
					$('div.remove-test-items').show();
				}
			});
		}
	});

	/**
	 * The onclick event handler for the skip import/remove buttons
	 */
	$('#quick-start-guide-skip-add-items-button, #quick-start-guide-skip-remove-items-button').click(function(){
		QuickStartGuide_goToNextSection();
	});

	// set the category layout
	var category_layout = qsg_categoryLayout;
	// loop through each input field and see if it has been selected
	$('#QuickStartGuide .catalog-page-views input[type="checkbox"]').each(function(){
		var checked = (category_layout[$(this).attr('name')] == 'YES');
		if (checked) $(this).attr('checked', 'checked');
	});
	var category_default_view = qsg_categoryDefaultView;
	$('#CatalogDefaultView'+category_default_view).attr('checked', 'checked');
	// set the product layout
	
	var product_layout = qsg_productLayout;
	$('#CatalogProductPage'+product_layout).attr('checked', 'checked');
	// set the checkout process
	var checkout_process = qsg_checkoutProcess;
	
	$('#account-' + checkout_process).attr('checked', 'checked');
	// hide the checkboxes for catalog view
	$('#QuickStartGuide .catalog-page-views input:checkbox').hide();
	if (autoOpenQuickStartGuide) $('#QuickStartGuide').dialog('open');
}