<?php
set_time_limit(300000);

$include_path = "../../../";
require_once($include_path."engine/engine_config.php");
require_once($include_path."engine/engine_label.php");
require_once($include_path."engine/engine_mysql.php");
require_once($include_path."engine/engine_localization.php");
require_once($include_path."engine/engine_functions.php");
require_once($include_path."engine/engine_order.php");
require_once($include_path."classes/class.plugins.php");
require_once($include_path."classes/class.json.php");
require_once($include_path."vendors/smarty/Smarty.class.php");
require_once($include_path."vendors/nusoap/nusoap.php");


$db = new DB;
$db->init(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);

require_once($include_path."engine/engine_settings.php");
require($include_path."engine/engine_url_".($settings["USE_MOD_REWRITE"] == "YES" ? "rewrite" : "default").".php");
$smarty = new Smarty();
$smarty->template_dir = "templates";
$smarty->compile_dir = $include_path."cache/tmp";
session_cache_limiter("nocache");


$username = isset($_REQUEST["username"])?trim($_REQUEST["username"]):"";
$password = isset($_REQUEST["password"])?trim($_REQUEST["password"]):"";
$token = isset($_REQUEST["token"])?trim($_REQUEST["token"]):"";

// authorization should always be false
$plugin_auth = false;

$plugin_active = $settings["plugin_openapi_active"];
$plugin_username = $settings["plugin_openapi_username"];
$plugin_password = $settings["plugin_openapi_password"];
$plugin_token = $settings["plugin_openapi_token"];
$global_http_url = $settings["GlobalHttpUrl"];

// check credentials
if ($plugin_username == $username && checkPasswordHash($password, $plugin_password) && $plugin_token == $token)
{
	$plugin_auth = true;
}

// ensure that the call is created over HTTPS connection and is not currently in DEVMODE
if ($plugin_auth)
{
    if ($_SERVER["SERVER_PORT"] != 443 && (!defined("DEVMODE") || !DEVMODE))
    {
        $plugin_auth = false;
    }
}

/**
 * @var $processors array
 * This holds a list of all available API processors
 */
$processors = array("soap"=>"SoapProcessor",
                    "json"=>"JsonProcessor",
                    "xml"=>"XmlProcessor",
                    "csv"=>"CsvProcessor",
                    "tsv"=>"TsvProcessor",
                    "psv"=>"PsvProcessor",
                    "zip"=>"ZipProcessor",
                    "rss"=>"RssProcessor");
?>