<?php

class Admin_MenuHistory 
{
	protected $sessionVarName = 'admin-menu-history';
	protected $admminId = null;
	protected $db = null;
	
	/**
	 *
	 * @param AdminMenuItem $item 
	 */
	public function remember(Admin_MenuItem $item)
	{
		if ($item != null)
		{
			$items = isset($_SESSION[$this->sessionVarName]) ? $_SESSION[$this->sessionVarName] : array();
			$items[$item->id] = isset($items[$item->id]) ? $items[$item->id] + 1 : 1;
			arsort($items, SORT_NUMERIC);
			$_SESSION[$this->sessionVarName] = $items;
		}
	}
	
	/**
	 *
	 * @param AdminMenu $adminMenu
	 * @param AdminModelPreferencesMenu $adminMenuPreferences
	 * @param int $numberOfItems
	 * @return type 
	 */
	public function recall(Admin_Menu $adminMenu, Admin_ModelPreferencesMenu $adminMenuPreferences)
	{
		$items = isset($_SESSION[$this->sessionVarName]) ? is_array($_SESSION[$this->sessionVarName]) ? $_SESSION[$this->sessionVarName] : array() : array();
		
		if (count($items) == 0)
		{
			$items = $adminMenuPreferences->getHistoryItems();
			
			if (!is_null($items))
			{
				$_SESSION[$this->sessionVarName] = $items;
			}
			else
			{
				unset($_SESSION[$this->sessionVarName]);
			}
		}
		
		if (is_null($items)) return null;
		
		$result = array();
		
		$counter = 1;
		
		foreach ($items as $id => $exposures)
		{
			$item = $adminMenu->getItemById($id);
			if (!is_null($item)) $result[$item->id] = $item;
		}
		
		return count($result) > 0 ? $result : null;
	}
}