<?php

interface DataAccess_OrderRepositoryInterface
{
	public function getLastActiveOrders($dateFormat = '%m/%d/%Y - %r', $count = 7);

	public function resetLineItemShippingPrices($orderId);

	public function resetLineItemDiscounts($orderId);

	public function updateLineItemDiscount($orderId, $lineId, $discountAmount, $promoDiscountAmount);

	public function findExistingLineItemForProduct(ORDER $order, $productId, $options);

	public function getOrderItemsProducts($orderId, &$lineItemIds);

	public function deleteLineItems($orderId, &$lineItemIds);

	public function deleteAllLineItems($orderId);

	public function persistLineItem(ORDER $order, Model_LineItem $lineItemObj, $updateAttributes = false);

	public function incrementPaymentAttempt($orderId, $limit);

	public function getNextOrderNumber($orderId, $minOrderNumber);

	public function checkShippingDigital($orderId);

	public function getShippingAddress($orderId);

	public function getLineItems($orderId);

	public function getOrderData($orderId);

	public function persistOrderData(ORDER $order);

	public function updateLineItemQuantityPricing($orderId, $lineItemId, $finalPrice, $priceWithTax, $freeShipping);

	public function getProductsGiftsData($orderId);
}