<?php

class DataAccess_ProductsRepository
{
	protected $db;

	public function __construct($db)
	{
		$this->db = $db;
	}

	//public function getProduct($pid)
	//{
	//	$this->db->query("SELECT * FROM ".DB_PREFIX."products WHERE pid='".$pid."'");
	//	if ($this->db->moveNext())
	//	{
	//		//$this->db->get
	//	}
	//	return null;
	//}

	/**
	 * @param $productId
	 *
	 * @return bool|Model_Product
	 */
	public function getProductByProductId($productId)
	{
		$productTemp = $this->db->selectOne("SELECT * FROM ".DB_PREFIX."products WHERE product_id='".$this->db->escape($productId)."'", MYSQL_ASSOC);

		if ($productTemp)
		{
			return new Model_Product($productTemp);
		}

		return false;
	}

	public function getProductsInventory($pid, $inventoryList)
	{
		return $this->db->selectOne("SELECT pi_id, product_subid FROM ".DB_PREFIX."products_inventory WHERE pid=".intval($pid)." AND attributes_hash='".md5($inventoryList)."'", MYSQL_ASSOC);
	}

	public function getProductsAttributes($pid)
	{
		return $this->db->selectAll("
			SELECT * FROM ".DB_PREFIX."products_attributes
			WHERE pid = ".intval($pid)." AND is_active = 'Yes'
			ORDER BY priority, name, is_modifier
		");
	}

	public function getInventoryStock($inventoryId)
	{
		return $this->db->selectOne("SELECT stock FROM ".DB_PREFIX."products_inventory WHERE pi_id=".intval($inventoryId), MYSQL_ASSOC);
	}

	public static function getPreviousProductId($db, $pid)
	{
		$db->query("SELECT MAX(pid) AS c FROM ".DB_PREFIX."products WHERE pid < ".intval($pid));
		$ret = $db->moveNext();
		if ($ret)
			return $ret["c"];

		return null;
	}

	public static function getNextProductId($db, $pid)
	{
		$db->query("SELECT MIN(pid) AS c FROM ".DB_PREFIX."products WHERE pid > ".intval($pid));
		$ret = $db->moveNext();
		if ($ret)
			return $ret["c"];

		return null;
	}

	public function getProductsQuantityDiscounts($pid, $quantity)
	{
		return $this->db->selectOne("
			SELECT *
			FROM ".DB_PREFIX."products_quantity_discounts
			WHERE pid = ".$pid." AND is_active = 'Yes' AND ".$quantity." BETWEEN range_min AND range_max
			ORDER BY range_min
			LIMIT 1
			", MYSQL_ASSOC);
	}
}