<?php

class Listener_GiftCertificate
{
	/**
	 * Handle on order status change event
	 * 
	 * @param Events_OrderEvent $event
	 */
	public static function onOrderStatusChange(Events_OrderEvent $event)
	{
		global $db, $settings;

		$order = $event->getOrder();
		$oid = $order->getId();

		$oldPaymentStatus = $event->getData('oldPaymentStatus');
		$newPaymentStatus = $event->getData('newPaymentStatus');

		if ($newPaymentStatus == "Received" && $oldPaymentStatus != "Received")
		{
			require_once(dirname(dirname(dirname(__FILE__)))."/classes/class.gift_certificates.php");

			$gift_cert = new GiftCertificates($db);
			$gift_data = $gift_cert->GetGiftCertificate($oid);

			if ($gift_data !== false)
			{
				// the user has ordered a gift certificate
				$gift_cert->OrderGiftCertificate($gift_data['ocid'], $gift_data['first_name'], $gift_data['last_name'], $gift_data['gift_amount'], $gift_data['voucher']);

				if ($gift_data['email_gift'] == '1')
				{
					$gift_cert->SendNotification($oid);
				}
			}
		}
	}
}