<?php

class Payment_Provider
{
	protected $db;
	protected $payment;

	public function __construct(DB $db)
	{
		$this->db = $db;
		$this->payment = new PAYMENT($db);
	}

	public function getPaymentProcessor(ORDER $order)
	{
		global $payment_processor_class, $payment_processor_id, $payment_processor_name, $payment;

		$payment = $this->payment;

		$paymentMethodId = $order->paymentMethodId;

		if ($this->payment->hasMethod($paymentMethodId))
		{
			$pm = $this->payment->methods[$paymentMethodId];

			if (trim($pm->id) != '' && $pm->type != 'custom')
			{
				$contentDirPath = $this->contentDirPath();

				$gate = $this->payment->methods[$paymentMethodId];
				$gateway_id = escapeFileName($gate->id);
				@require_once($contentDirPath."/engine/payment/payment_".($gateway_id).".php");

				$this->db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE id='".$this->db->escape($gateway_id)."'");
				if ($col = $this->db->moveNext())
				{
					$payment_processor_id = $col["id"];
					$payment_processor_class = $col["class"];
					$payment_processor_name = $col["name"];
				}

				if (isset($pp)) unset($pp);

				// create instance of payment processor (gateway) class
				@eval("\$pp = new ".$payment_processor_class."();");

				if (isset($pp) && is_object($pp))
				{
					$order->getShippingAddress();
					$user = $order->user();

					$pp->enableLog = defined('DEVMODE') && DEVMODE;
					$pp->db_id = $order->paymentMethodId;
					$pp->getSettingsData($this->db);
					$pp->getCommonData($user, $order);
					$pp->isTestMode(); // force test mode check to possibly update URLs

					return $pp;
				}
			}
		}

		return null;
	}

	protected function contentDirPath()
	{
		return dirname(dirname(dirname(__FILE__)));
	}
}