<?php 
/**
 * @class cartPlugin
 */
class cartPlugin{
	var $plugin_group = "";
	var $plugin_caption = "Plugin";
	var $plugin_description = "";

	var $db = false;
	var $settings = false;
	var $request = false;

	var $interface;

	function cartPlugin(){
		return $this;
	}

	function getPluginGroup(){
		return $this->plugin_group;
	}

	function getPluginCaption(){
		return $this->plugin_caption;
	}

	function getPluginDescription(){
		return $this->plugin_description;
	}

	function runPlugin(&$db, &$settings, &$request){
		$this->db = $db;
		$this->settings = $settings;
		$this->request = $request;
		return true;
	}

	function registerAdminInterface() {
		return $this->interface;
	}
}
/**
 * Enter description here...
 *
 */
class cartPlugins{
	var $pluginsDir = "";
	var $pluginsArray = array();
	var $pluginsGroups = array();
	var $events = array();
	var $components = array();

	//constructor
	function cartPlugins($pluginsDir = ""){
		if($pluginsDir != ""){
			$this->setPluginsDir($pluginsDir);
			$this->getPlugins();
		}

		return $this;
	}

	//set plugins directory
	function setPluginsDir($pluginsDir){
		$this->pluginsDir = $pluginsDir[strlen($pluginsDir) - 1] == "/" ? substr($pluginsDir, 0, strlen($pluginsDir)) : $pluginsDir;
		return $this->pluginsDir;
	}

	//return plugins list
	function getPlugins(){
		if(is_dir($this->pluginsDir)){
			$plugins = array();
			$d = dir($this->pluginsDir);
			while(false !== ($entry = $d->read())) {
    				if(is_dir($this->pluginsDir."/".$entry) && $entry[0] != "."){
    					$pluginName = $entry;
                                        $plugInitFile = $this->pluginsDir."/".$entry."/init.php";
    					if(file_exists($plugInitFile) && include_once($plugInitFile)) {
    						eval("\$this->pluginsArray[\$pluginName] = new plugin_".$pluginName."();");
    						$pluginGroup = $this->pluginsArray[$pluginName]->getPluginGroup();
    						$this->pluginsGroups[$pluginGroup][$pluginName] = &$this->pluginsArray[$pluginName];
    					}
    				}
			}
			$d->close();
			return count($this->pluginsArray) > 0 ? $this->pluginsArray : false;
		}
		return false;
	}

	function getAdminInterfaces() {
		if(is_dir($this->pluginsDir)){
			$plugins = array();
			$d = dir($this->pluginsDir);
			while(false !== ($entry = $d->read())) {
    				if(is_dir($this->pluginsDir."/".$entry) && $entry[0] != "."){
    					$pluginName = $entry;
                                        $plugininitFile = $this->pluginsDir."/".$entry."/init.php";
    					if(file_exists($plugininitFile) && include_once($plugininitFile)) {
						eval("\$plugin = new plugin_".$pluginName."();");
						if(method_exists($plugin, "registerAdminInterface")) {
    							eval("\$interfaces[] = \$plugin->registerAdminInterface();");
						}
    					}
    				}
			}
			$d->close();
			return $interfaces;
		}
		return null;
	}

	//check is plugin is correct
	function isPlugin($pluginName){
		return array_key_exists($pluginName, $this->pluginsArray);
	}

	//check is plugin is correct
	function getPluginObject($pluginName){
		return array_key_exists($pluginName, $this->pluginsArray)?$this->pluginsArray[$pluginName]:false;
	}

	//check is there plugins in plugins group
	function isGroup($pluginGroup){
		return array_key_exists($pluginGroup, $this->pluginsGroups);
	}
}
?>
