<?php
/**
 * Add Gift Cert To Order
 * @subpackage EngineLogic
 * @copyright Copyright(c) Gaston Tavella, LLC. All Rights Reserved.
 * @author Gaston Tavella
 */

	if (!defined("ENV")) exit();
	
	/* Init Variabless */
	$first_name = isset($_REQUEST["first_name"]) ? $_REQUEST["first_name"] : '';
	$last_name = isset($_REQUEST["last_name"]) ? $_REQUEST["last_name"] : '';
	$phone = isset($_REQUEST["phone"]) ? $_REQUEST["phone"] : '';
	$rep_email = isset($_REQUEST["rep_email"]) ? $_REQUEST["rep_email"] : '';
	$from_name = isset($_REQUEST["from_name"]) ? $_REQUEST["from_name"] : '';
	$message = isset($_REQUEST["message"]) ? $_REQUEST["message"] : '';
	$gift_amount = isset($_REQUEST["gift_amount"]) ? $_REQUEST["gift_amount"] : 0;
	$email_gift = (isset($_REQUEST["chk_email_gift"]) && $_REQUEST["chk_email_gift"]=='1' ? '1' : '0');
	
	if ($settings["VisitorMayAddItem"] == "YES" || ($user->auth_ok || $userCookie))
	{
		$errors = array();

		if (!validate(str_replace('.', '', $first_name), VALIDATE_NAME))
		{
			$errors[] = $msg['gift_certificate']['giftCertCreateErrors']['recipient_first_name'];
		}

		if (!validate(str_replace('.', '', $last_name), VALIDATE_NAME))
		{
			$errors[] = $msg['gift_certificate']['giftCertCreateErrors']['recipient_last_name'];
		}

		if (!validate(str_replace('.', '', $from_name), VALIDATE_NAME))
		{
			$errors[] = $msg['gift_certificate']['giftCertCreateErrors']['your_name'];
		}

		if (!validate($gift_amount, VALIDATE_FLOAT))
		{
			$errors[] = $msg['gift_certificate']['giftCertCreateErrors']['certificate_amount'];
		}

		if ($gift_amount < 1)
		{
			$errors[] = $msg['gift_certificate']['giftCertCreateErrors']['certificate_amount_gt_zero'];
		}

		if (!validate($rep_email, VALIDATE_EMAIL))
		{
			$errors[] = $msg['gift_certificate']['giftCertCreateErrors']['recipient_email_address'];
		}

		if (count($errors) > 0)
		{
			view()->assign("gift_certificate_error", pageError($msg['gift_certificate']['giftCertCreateError'], $errors));
			view()->assign("first_name", $first_name);
			view()->assign("last_name", $last_name);
			view()->assign("phone", $phone);
			view()->assign("rep_email", $rep_email);
			view()->assign("from_name", $from_name);
			view()->assign("message", $message);
			view()->assign("gift_amount", $gift_amount);
			view()->assign("email_gift", $email_gift);
		}
		else 
		{
			$gift = new GiftCertificates($db);

			$gift->AddGiftCertificate($order, $first_name, $last_name, $phone, $rep_email, $gift_amount, $from_name, $message, $email_gift);

			OrderProvider::refreshSubtotals($order);

			$backurl = $url_dynamic."p=cart";
		}
	}
