<?php 
   	$payment_processor_id = "echo";
	$payment_processor_name = "Echo-Inc.Com";
	$payment_processor_class = "PAYMENT_ECHO";
	$payment_processor_type = "cc";

	class PAYMENT_ECHO extends PAYMENT_PROCESSOR
	{
		function PAYMENT_ECHO()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "echo";
			$this->name = "Echo-Inc.Com";
			$this->class_name = "PAYMENT_ECHO";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->support_ccs = true;
			$this->need_cc_codes = true;
			return $this;
		}

		public function replaceDataKeys()
		{
			return array('merchant_pin', 'merchant_echo_id', 'cc_number', 'cnp_security');
		}

		function process($db, $user, $order, $post_form)
		{
			global $_SERVER;
			global $settings;
			
			if (isset($post_form) && is_array($post_form))
			{
				// build post data for query
				$post_data = "";

				// get post_form, common, settings and custom vars
				$debug = "F";

				if ($this->settings_vars[$this->id."_DebugMode"]["value"] == "True") $debug = "T";
				if ($this->settings_vars[$this->id."_DebugMode"]["value"] == "Certify") $debug = "C";

				reset($this->common_vars);

				$post_data = "".
					"transaction_type=ES".
					"&order_type=S".
					"&counter=".urlencode($this->common_vars["order_id"]["value"]).
					"&debug=".urlencode($debug).
					"&merchant_pin=".urlencode($this->settings_vars[$this->id."_MerchantPin"]["value"]).
					"&merchant_echo_id=".urlencode($this->settings_vars[$this->id."_MerchantId"]["value"]).
					"&billing_ip_address=".urlencode($_SERVER["REMOTE_ADDR"]).
					"&cc_number=".urlencode($post_form["cc_number"]).
					"&order_number=".urlencode($this->common_vars["order_id"]["value"]).
					"&ccexp_month=".urlencode($post_form["cc_expiration_month"]).
					"&ccexp_year=".urlencode(substr($post_form["cc_expiration_year"], 2, 2)).
					"&grand_total=".sprintf("%01.2f",($this->common_vars["order_total_amount"]["value"])).
					"&billing_first_name=".urlencode($post_form["cc_first_name"]).
					"&billing_last_name=".urlencode($post_form["cc_last_name"]).                        
					"&billing_address1=".urlencode($this->common_vars["billing_address"]["value"]).
					"&billing_address2=".urlencode($this->common_vars["billing_address"]["value"]).
					"&billing_city=".urlencode($this->common_vars["billing_city"]["value"]).
					"&billing_state=".urlencode($this->common_vars["billing_state"]["value"]).
					"&billing_zip=".urlencode($this->common_vars["billing_zip"]["value"]).
					"&billing_country=".urlencode($this->common_vars["billing_country_iso_a2"]["value"]).
					"&billing_phone=".urlencode($this->common_vars["billing_phone"]["value"]).
					"&billing_email=".urlencode($this->common_vars["billing_email"]["value"]).
					"&merchant_email=".urlencode($this->common_vars["billing_email"]["value"]).
					"&cnp_security=".urlencode($post_form["cc_cvv2"]);

				$_post_url = trim($this->url_to_gateway)==""?"https://wwws.echo-inc.com/scripts/INR200.EXE":trim($this->url_to_gateway);

				$c = curl_init($_post_url);
				curl_setopt($c, CURLOPT_POST, 1);
				curl_setopt($c, CURLOPT_POSTFIELDS, $post_data);

				if ($settings["ProxyAvailable"] == "YES")
				{
					//curl_setopt($c, CURLOPT_VERBOSE, 1);
					if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
					{
						curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
					}
					
					curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
					
					if ($settings["ProxyRequiresAuthorization"] == "YES")
					{
						curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
					}

					curl_setopt($c, CURLOPT_TIMEOUT, 120);
				}

				curl_setopt($c, CURLOPT_VERBOSE, 0);
				curl_setopt($c, CURLOPT_HEADER, 0);
				curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);

				if (!safe_mode()) set_time_limit(3000);

				curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
				curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
				$buffer = curl_exec($c);

				$requestData = array();
				parse_str($post_data, $requestData);

				$this->log("processAuthCapture Request:\n".$_post_url, $requestData);
				$this->log("processAuthCapture Response:\n".$buffer);

				if (strlen($buffer) > 0)
				{
					// Get status info from Header3 return header
					function GetEchoProp($haystack, $prop)
					{
						if (($start_pos = strpos(strtolower($haystack), "<$prop>"))!==false)
						{
							$start_pos += strlen("<$prop>");
							$end_pos = strpos(strtolower($haystack), "</$prop", $start_pos);
							return substr($haystack, $start_pos, $end_pos - $start_pos);
						}
						else return ""; 
					}
					$status_operation = GetEchoProp($buffer, "status");
					$status_error =  GetEchoProp($buffer, "decline_code");

					//  G - Approved  R - Received 
					if ($status_operation == "G" or $status_operation == "R")
					{
						$this->createTransaction($db, $user, $order, explode("|", $buffer));
						
						if ($this->support_ccs && $this->enable_ccs)
						{
							$card_data = array(
								"fn"=>$post_form["cc_first_name"],
								"ln"=>$post_form["cc_last_name"],
								"ct"=>$post_form["cc_type"],
								"cc"=>$post_form["cc_number"],
								"em"=>$post_form["cc_expiration_month"], 
								"ey"=>$post_form["cc_expiration_year"]
							);
							$this->saveCCdata($db, $order, $card_data, base64_decode($settings["SecurityCCSCertificate"]));
						}
						$this->is_error = false;
						$this->error_message = "";
					}
					else
					{
						//G - Approved  R - Received  D - Declined  C - Cancelled  T - Timeout waiting for host response
						switch ($status_operation)
						{
							case "D" : $error_msg = "Entered Credit Card is Declined"; break;
							case "C" : $error_msg = "Transactions is Cancelled"; break;
							case "T" : $error_msg = "Timeout waiting for host response"; break;
						}
						$this->is_error = true;
						$this->error_message = $error_msg;//." : ".$status_error;
					}
				}
				else
				{
					$this->is_error = true;
					$this->error_message = PAYMENT_SERVER_ERROR_TEXT;
				}

				if ($this->is_error)
				{
					$this->storeTransaction($db, $user, $order, explode("|", $buffer), '', false);
				}
			}
			else
			{
				$this->is_error = true;
				$this->error_message = "Incorrect form params. Please contact site administartor.";
			}
			return !$this->is_error;
		}
	}
