<?php
	$payment_processor_id = "epay";
	$payment_processor_name = "USAepay";
	$payment_processor_class = "PAYMENT_EPAY";
	$payment_processor_type = "cc";

	class PAYMENT_EPAY extends PAYMENT_PROCESSOR
	{
		function PAYMENT_EPAY()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "epay";
			$this->name = "USAepay";
			$this->class_name = "PAYMENT_EPAY";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			return $this;
		}

		function isTestMode()
		{
			if ($this->settings_vars[$this->id."_Test_Request"]["value"] == "TRUE")
			{
				$this->testMode = true;
			}
			else
			{
				$this->testMode = false;
			}
			return $this->testMode;
		}

		public function replaceDataKeys()
		{
			return array('card', 'cvv2', 'pin', 'cavv');
		}

		function getVarStatus($custom1="", $custom2="", $custom3="", $order_status="", $payment_status="")
		{
			global $setting;
			$var_status = array("1"=>false, "2"=>false, "3"=>false);
			if ($custom1 == "AUTH_ONLY" && $payment_status == "Pending")
			{
				$var_status[1] = array(
					"message"=>"<b>Please note: payment transaction is not completed yet and funds are not transfered to your USAePay merchant account. The reason is this transaction is AUTH_ONLY transaction</b>",
					"executable"=>true,
					"link_caption"=>"To complete this transaction, click here"
				);
			}
			if ($payment_status == "Received" && $custom1 == "Sale")
			{
				$var_status[1] = array(
					"message"=>"<div style='padding-top:7px;' OnClick=\"window.open('content/engine/payment/epay/usaepayrefund.php?oid=".$_GET['oid']."','PopupWind','titlebar=no, toolbar=no, menubar=no, status=no, directories=no, resizable=no, scrollbars=no, top=200, left=400, width=320, height=240')\"><a href=\"#\">Credit / Void Transaction</a></div>",
					"executable"=>false,
					"link_caption"=>""
				);
			}

			return $var_status;
		}

		//main payment module entry point
		function process($db, $user, $order, $post_form)
		{
			global $settings;

			require "content/engine/payment/epay/usaepay.php";

			$tran = new umTransaction();
			$tran->transport = 'curl';
			$tran->ignoresslcerterrors = true;

			$tran->key=$this->settings_vars[$this->id."_Key"]["value"];
			
			if ($this->settings_vars[$this->id."_pin"]["value"]!="")
			{
				$tran->pin = $this->settings_vars[$this->id."_pin"]["value"];
			}

			$tran->gatewayurl = $this->url_to_gateway;
			$tran->testmode = $this->testMode;
			$tran->command = $this->settings_vars[$this->id."_Auth_Type"]["value"];
			// card number, no dashes, no spaces
			$tran->card = $post_form["cc_number"];
			//Exp Date
			$tran->exp = $post_form["cc_expiration_month"].substr($post_form["cc_expiration_year"], 2, 2);
			// charge amount in dollars (no international support yet)
			$tran->amount = number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "");
			// invoice number and Order ID.  must be unique.
			$tran->invoice = $this->common_vars["order_id"]["value"];
			$tran->orderid = $this->common_vars["order_id"]["value"];
			// name of card holder
			$tran->cardholder = $post_form["cc_first_name"]." ".$post_form["cc_last_name"];
			// street address
			$tran->street = $this->common_vars["billing_address"]["value"];
			// zip code
			$tran->zip = $this->common_vars["billing_zip"]["value"];
			// description of charge
			$tran->description = "Online Order";
			// cvv2 code
			$tran->cvv2 = $post_form["cc_cvv2"];

			//Billing Details
			$tran->billfname = $this->common_vars["billing_first_name"]["value"];
			$tran->billlname = $this->common_vars["billing_last_name"]["value"];
			$tran->billstreet = $this->common_vars["billing_address"]["value"];
			$tran->billcity = $this->common_vars["billing_city"]["value"];
			$tran->billstate = $this->common_vars["billing_state"]["value"];
			$tran->billzip = $this->common_vars["billing_zip"]["value"];
			$tran->billcountry = $this->common_vars["billing_country"]["value"];
			$tran->billphone = $this->common_vars["billing_phone"]["value"];
			$tran->email = $this->common_vars["billing_email"]["value"];

			//Shipping Details

			$tran->shipfname = $this->common_vars["shipping_name"]["value"];
			//$tran->shiplname = $this->common_vars["shipping_name"]["value"];
			$tran->shipstreet = $this->common_vars["shipping_address"]["value"];
			//$tran->shipstreet2;
			$tran->shipcity = $this->common_vars["shipping_city"]["value"];
			$tran->shipstate = $this->common_vars["shipping_state"]["value"];
			$tran->shipzip = $this->common_vars["shipping_zip"]["value"];
			$tran->shipcountry = $this->common_vars["shipping_country"]["value"];
			//$tran->shipphone;

			// Curl Proxy Setting
			$tran->proxyavailable = $settings["ProxyAvailable"];
			$tran->proxyurl = $settings["ProxyAddress"];
			$tran->proxytype = $settings["ProxyType"];
			$tran->proxyport = $settings["ProxyPort"];
			$tran->proxyauthorization = $settings["ProxyRequiresAuthorization"];
			$tran->proxyusername = $settings["ProxyUsername"];
			$tran->proxypassword = $settings["ProxyPassword"];

			$requestData = get_object_vars($tran);
			$this->log("process Request:", $requestData);

			$isValid = $tran->Process();

			$responseData = explode("\n", $tran->rawresult);
			$resultData = $responseData[count($responseData)-1];
			$responseData = array();
			parse_str($resultData, $responseData);

			$this->log("process Response:", $responseData);

			if ($isValid)
			{
				// Add for Auth_Capture
				$this->createTransaction($db, $user, $order, $responseData, "",
					//custom 1-transaction type,2-cc data,3-amount,
					$this->settings_vars[$this->id."_Auth_Type"]["value"] == "Sale" ? "Sale" : "AUTH_ONLY",
					(number_format($this->common_vars["order_total_amount"]["value"], 2, ".", "") 
					),
					$tran->refnum,
					$tran->refnum
				);

				$this->is_error = false;
				$this->error_message = "";

				return $this->settings_vars[$this->id."_Auth_Type"]["value"] == "Sale" ? "Received" : "Pending";
			}
			else 
			{
				$this->error_message=$tran->error;
				$this->is_error = true; 
			}

			if ($this->is_error)
			{
				$this->storeTransaction($db, $user, $order, $responseData, '', false);
			}

			return !$this->is_error;
		}

		// Custom Process
		function processCustom($db, $custom_id, $order_id)
		{
			global $order;

			$user = $order->user();
			$oldPaymentStatus = $order->getPaymentStatus();

			$this->is_error = false;
			switch ($custom_id)
			{
				case 1 : 
				{
					$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order_id."'");

					if ($db->moveNext())
					{
						$order_data = $db->col;

						//check is transaction completed
						if ($order_data["custom1"] != "AUTH_ONLY")
						{
							$this->is_error = true;
							$this->error_message = "Transaction already completed";
							return false;
						}

						//get captured total amount & x_trans_id
						$captured_total_amount = $order_data["custom2"];
						$refnum = $order_data["custom3"];

						if ($order_data["total_amount"] > $captured_total_amount)
						{
							$this->is_error = true;
							$this->error_message = "New total amount can't be bigger as captured total amount";
							return false;
						}

						// Custom Call Transaction Process
						require "content/engine/payment/epay/usaepay.php";

						$tran = new umTransaction();
						$tran->transport = 'curl';
						$tran->ignoresslcerterrors = true;

						$tran->key = $this->settings_vars[$this->id."_Key"]["value"];
						if ($this->settings_vars[$this->id."_pin"]["value"]!="")
						{
							$tran->pin = $this->settings_vars[$this->id."_pin"]["value"];
						}

						$tran->gatewayurl = $this->url_to_gateway;
						$tran->testmode = $this->testMode;

						$tran->command = "capture";

						$tran->refnum = $refnum;

						$requestData = get_object_vars($tran);
						$this->log("process Request:", $requestData);

						$isValid = $tran->Process();

						$responseData = explode("\n", $tran->rawresult);
						$resultData = $responseData[count($responseData)-1];
						$responseData = array();
						parse_str($resultData, $responseData);

						$this->log("process Response:", $responseData);

						if ($isValid)
						{
							$order->setPaymentStatus(ORDER::PAYMENT_STATUS_RECEIVED);

							$db->reset();
							$db->assignStr("payment_status", $order->getPaymentStatus());
							$db->update(DB_PREFIX."orders", "WHERE oid='".$order_id."'");

							$this->createTransaction($db, $user, $order,
								$responseData,
								"",
								 "Sale", $captured_total_amount, $tran->refnum
							);
						}
						else
						{
							$this->error_message=$tran->error;
							$this->is_error = true;

							$this->storeTransaction($db, $user, $order, $responseData, '', false);
						}
					}
					break;
				}
				case 2 : 
				{
					$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order_id."'");
					if ($db->moveNext())
					{
						$order_data = $db->col;

						//check is transaction completed
						if ($order_data["custom1"] != "Sale")
						{
							$this->is_error = true;
							$this->error_message = "Transaction already completed";
							return false;
						}

						//get captured total amount & x_trans_id
						$captured_total_amount = $order_data["custom2"];
						$refnum = $order_data["custom3"];

						if ($order_data["total_amount"] > $captured_total_amount)
						{
							$this->is_error = true;
							$this->error_message = "New total amount can't be bigger as captured total amount";
							return false;
						}

						// Custom Call Transaction Process
						require "content/engine/payment/epay/usaepay.php";

						$tran = new umTransaction();
						$tran->transport = 'curl';
						$tran->ignoresslcerterrors = true;

						$tran->key=$this->settings_vars[$this->id."_Key"]["value"];
						if ($this->settings_vars[$this->id."_pin"]["value"]!="")
						{
							$tran->pin=$this->settings_vars[$this->id."_pin"]["value"];
						}

						$tran->gatewayurl = $this->url_to_gateway;
						$tran->testmode = $this->testMode;

						$tran->command = "creditvoid";

						$tran->refnum = $refnum;

						$requestData = get_object_vars($tran);
						$this->log("process Request:", $requestData);

						$isValid = $tran->Process();

						$responseData = explode("\n", $tran->rawresult);
						$resultData = $responseData[count($responseData)-1];
						$responseData = array();
						parse_str($resultData, $responseData);

						$this->log("process Response:", $responseData);

						if ($isValid)
						{
							$order->setPaymentStatus(ORDER::PAYMENT_STATUS_REFUNDED);
							$db->reset();
							$db->assignStr("payment_status", $order->getPaymentStatus());
							$db->update(DB_PREFIX."orders", "WHERE oid='".$order_id."'");

							$this->createTransaction($db, $user, $order,
								$responseData,
								"",
								 "REFUNDED", $captured_total_amount, $tran->refnum
							);
						}
						else
						{
							$this->error_message=$tran->error;
							$this->is_error = true;

							$this->storeTransaction($db, $user, $order, $responseData, '', false);
						}
					}
					break;
				}
			}

			$this->fireOrderEvent($order, $order->getStatus(), $oldPaymentStatus);

			return !$this->is_error;
		}
	}
