<?php 
	$payment_processor_id = "googlecheckout";
	$payment_processor_name = "Google Checkout";
	$payment_processor_class = "PAYMENT_GOOGLECHECKOUT";
	$payment_processor_type = "ipn";
	
	class PAYMENT_GOOGLECHECKOUT extends PAYMENT_PROCESSOR
	{
		/**
		 * Class constructor
		 */
		function PAYMENT_GOOGLECHECKOUT()
		{
			parent::PAYMENT_PROCESSOR();
			$this->id = "googlecheckout";
			$this->name = "Google Checkout";
			$this->class_name = "PAYMENT_GOOGLECHECKOUT";
			$this->type = "ipn";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			$this->post_url = "";
			$this->show_cvv2 = false;
			$this->support_accepted_cc = false;
			$this->allow_checkout = true;
			return $this;
		}
		
		/**
		 * Payment form
		 */
		function getPaymentForm($db)
		{
			global $settings, $url_http, $url_https, $url_dynamic;
			$_pf = parent::getPaymentForm($db);
			$cc_options = $this->cc_options;
			global $msg, $settings,$order;
			$order->setOrderNum();				
				
			//store session id
			$db->query("UPDATE ".DB_PREFIX."orders SET custom2='".session_id()."' WHERE oid='".$order->oid."'");
			
			//get order data
			$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order->oid."'");
			$db->moveNext();
			$order_data = $db->col;
			
			//get default currency code
			$db->query("SELECT code FROM ".DB_PREFIX."currencies WHERE is_default='Yes'");
			$currency_code = $db->moveNext() ? $db->col["code"] : "USD";
			
			//get countries and states codes
			$db->query("SELECT coid, iso_a2 FROM ".DB_PREFIX."countries");
			$country_codes = array();
			
			while ($db->moveNext())
			{ 
				$country_codes[$db->col["coid"]] = $db->col["iso_a2"];
			}
			
			$db->query("SELECT stid, short_name FROM ".DB_PREFIX."states");
			$state_codes = array();
			
			while ($db->moveNext())
			{ 
				$state_codes[$db->col["stid"]] = $db->col["short_name"];
			}
			
			//Check if product level shipping rate is added
			$add_product_level_shipping = 0;
			$no_product_level_shipping = 0;			
			$nofree_shipping_order = 0;
			$db->query("SELECT 
					".DB_PREFIX."orders_content.pid, 
					".DB_PREFIX."products_shipping_price.price AS product_level_shipping,
					free_shipping							
				FROM ".DB_PREFIX."orders_content 
				LEFT JOIN ".DB_PREFIX."products_shipping_price ON ".DB_PREFIX."products_shipping_price.pid = ".DB_PREFIX."orders_content.pid					
				WHERE oid='".$order->oid."'
			");
			
			while ($db->moveNext())
			{
				if ($db->col["product_level_shipping"] > 0)
				{
					$add_product_level_shipping = $add_product_level_shipping + 1;
					$product_level_method[0] =1;
					$product_level_method["ssid"] =1;
					$product_level_method[1] = "custom";
					$product_level_method["carrier_id"] = "custom";
					$_SESSION["product_level_method"] = $product_level_method;					
				}
				else
				{
					$no_product_level_shipping = $no_product_level_shipping + 1;
				}
				if ($db->col["free_shipping"] == "No") $nofree_shipping_order = $nofree_shipping_order + 1;
			}
			$shipping_methods = array();
			
			if ($nofree_shipping_order == 0)
			{
				$shipping_method = 
					'<merchant-calculated-shipping name="'.htmlspecialchars('Free').'">'.
						'<price currency="'.htmlspecialchars($currency_code).'">'.htmlspecialchars(0.00).'</price>';
				$shipping_method .= '</merchant-calculated-shipping>';
			}
			else
			{
			//get shipping methods			
				$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected ORDER BY priority");
				while ($db->moveNext())
				{
					if (($no_product_level_shipping == 0 && $db->col["method_id"] == "product_level") || ($no_product_level_shipping > 0 && $db->col["method_id"] != "product_level"))
					{
						$shipping_method_name = $db->col["carrier_name"].($db->col["carrier_id"] != "custom" ? " ".$db->col["method_name"] : "");
						$shipping_method = 
							'<merchant-calculated-shipping name="'.htmlspecialchars($shipping_method_name).'">'.
								'<price currency="'.htmlspecialchars($currency_code).'">'.htmlspecialchars(number_format($settings["googlecheckout_Shipping_Price_On_Error"], 2, ".", "")).'</price>';
						
						//add allowed / exluded countries and states		
						$allowed_countries = explode(",", $db->col["country"]);
						$exclude_countries = explode(",", $db->col["country_exclude"]);
						$allowed_states = explode(",", $db->col["state"]);
							
						$filters_restictions = "";
						
						if ($db->col["carrier_id"] == "ups" || $db->col["carrier_id"] == "fedex_express" || $db->col["carrier_id"] == "fedex_ground")
						{
							$filters_restictions .= '<allow-us-po-box>false</allow-us-po-box>';
						}
						
						if ((trim($db->col["country"]) != "" && trim($db->col["country"]) != "0"))
						{
							$filters_restictions .= '<allowed-areas>';
							foreach ($allowed_countries as $coid)
							{
								//check USA
								if ($coid == 1)
								{
									//all states?
									if (in_array("0", $allowed_states))
									{
										$filters_restictions .= '<us-country-area country-area="ALL"/>';
									}
									else
									{
										foreach ($allowed_states as $stid)
										{
											if (array_key_exists($stid, $state_codes))
											{
												$filters_restictions .= '<us-state-area>';
												$filters_restictions .= '<state>'.htmlspecialchars($state_codes[$stid]).'</state>';
												$filters_restictions .= '</us-state-area>';
											}
										}
									}
								}
								//other countries
								else
								{
									if (array_key_exists($coid, $country_codes))
									{
										$filters_restictions .= '<postal-area><country-code>'.htmlspecialchars($country_codes[$coid]).'</country-code></postal-area>';
									}
								}
							}
							$filters_restictions .= '</allowed-areas>';
						}
						else
						{
							$filters_restictions .= '<allowed-areas><world-area/></allowed-areas>';
						}
					
						//check excluded areas
						if ((trim($db->col["country_exclude"]) != ""))
						{
							$filters_restictions .= '<excluded-areas>';
							foreach ($exclude_countries as $coid)
							{
								//check USA
								if ($coid == 1)
								{
									//all states?
									$filters_restictions .= '<us-country-area country-area="ALL"/>';
								}
								//other countries
								elseif (array_key_exists($coid, $country_codes))
								{
									$filters_restictions .= '<postal-area><country-code>'.htmlspecialchars($country_codes[$coid]).'</country-code></postal-area>';
								}
								elseif ($coid == 0)
								{
									//$filters_restictions .= '<world-area/>';
								}
							}
							$filters_restictions .= '</excluded-areas>';
						}
						
						$shipping_method .= '<address-filters>'.$filters_restictions.'</address-filters>';
						$shipping_method .= '<shipping-restrictions>'.$filters_restictions.'</shipping-restrictions>';
								
						$shipping_method .= '</merchant-calculated-shipping>';
						$shipping_methods[] = $shipping_method;
					}
				}	
			}	
			//create tax tables array
			$alternate_tax_tables = array();
			
			//non-taxable products
			$alternate_tax_tables[] = '<alternate-tax-table standalone="true" name="tax_exempt"><alternate-tax-rules/></alternate-tax-table>';
			
			//select all tax classes used in current order
			$db->query("
				SELECT
					".DB_PREFIX."tax_classes.class_id AS tax_class_id,
					".DB_PREFIX."tax_classes.class_name AS tax_class_name
				FROM ".DB_PREFIX."orders_content
				INNER JOIN ".DB_PREFIX."products ON ".DB_PREFIX."products.pid = ".DB_PREFIX."orders_content.pid
				LEFT JOIN ".DB_PREFIX."tax_classes ON ".DB_PREFIX."tax_classes.class_id = ".DB_PREFIX."products.tax_class_id
				WHERE oid='".$order->oid."'
				GROUP BY tax_class_id
			");
		
			$_tax_classes = $db->getRecords();
			foreach ($_tax_classes as $_tax_class)
			{
				//add alternate state table for each tax classs
				$alternate_tax_table =
					'<alternate-tax-table standalone="true" name="'.htmlspecialchars($_tax_class["tax_class_name"]).'"><alternate-tax-rules>';
						
				//add rates and zones
				$db->query("
					SELECT 
						".DB_PREFIX."tax_rates.tax_rate,
						".DB_PREFIX."tax_zones_regions.coid as country_id,						
						".DB_PREFIX."tax_zones_regions.stid as state_id,
						if(".DB_PREFIX."tax_zones_regions.coid = 0, 2, 1) AS country_priority,
						if(".DB_PREFIX."tax_zones_regions.stid = 0, 2, 1) AS state_priority,
						".DB_PREFIX."countries.iso_a2 AS country_code,
						".DB_PREFIX."states.short_name AS state_code
					FROM ".DB_PREFIX."tax_rates 
					INNER JOIN ".DB_PREFIX."tax_zones_regions ON (".DB_PREFIX."tax_zones_regions.zone_id = ".DB_PREFIX."tax_rates.zone_id)
					LEFT JOIN ".DB_PREFIX."countries ON (".DB_PREFIX."countries.coid =".DB_PREFIX."tax_zones_regions.coid)
				   	LEFT JOIN ".DB_PREFIX."states ON (".DB_PREFIX."states.stid = ".DB_PREFIX."tax_zones_regions.stid)
					WHERE ".DB_PREFIX."tax_rates.class_id='".$_tax_class["tax_class_id"]."' 
					ORDER BY ".DB_PREFIX."tax_rates.rate_priority ASC, country_priority ASC, state_priority ASC
				");
				if ($db->numRows() > 0)
				{
					//add new tax rule for each itteration (tax rate)
					while ($db->moveNext())
					{
						$_tax_rate = $db->col;
						$alternate_tax_table .= '<alternate-tax-rule><rate>'.($_tax_rate["tax_rate"]/100).'</rate>';
						
						//world-wide tax
						if ($_tax_rate["country_id"] == "0")
						{
							$alternate_tax_table.= '<tax-area><world-area/></tax-area>';
						}
						//country-specific tax
						else
						{
							//united states tax
							if ($_tax_rate["country_code"] == "US")
							{
								if ($_tax_rate["state_id"] == "0")
								{
									$alternate_tax_table.= '<tax-area><us-country-area country-area="ALL"/></tax-area>';
								}
								else
								{
									$alternate_tax_table.= '<tax-area><us-state-area><state>'.$_tax_rate["state_code"].'</state></us-state-area></tax-area>';
								}
							}
							//other countries
							else
							{
								$alternate_tax_table.= '<tax-area><postal-area><country-code>'.$_tax_rate["country_code"].'</country-code></postal-area></tax-area>';
							}
						}
						$alternate_tax_table.= '</alternate-tax-rule>';
					}
				}
				
				$alternate_tax_table.= '</alternate-tax-rules></alternate-tax-table>';
				$alternate_tax_tables[] = $alternate_tax_table;
			}
			//by default google checkout is allowed
			$this->allow_checkout = true;
			
			//build cart xml
			$xml_cart = '<?xml version="1.0" encoding="UTF-8"?><checkout-shopping-cart xmlns="http://checkout.google.com/schema/2"><shopping-cart><items>';
			
			//get order items
			$db->query("
				SELECT 
					".DB_PREFIX."orders_content.*, 
					".DB_PREFIX."products.description AS description,
					".DB_PREFIX."products.is_taxable AS product_taxable,
					".DB_PREFIX."products.tax_rate AS product_tax_rate,
					".DB_PREFIX."products.is_google_co AS product_is_google_co,
					".DB_PREFIX."tax_classes.class_name
				FROM ".DB_PREFIX."orders_content 
				INNER JOIN ".DB_PREFIX."products ON ".DB_PREFIX."products.pid = ".DB_PREFIX."orders_content.pid
				LEFT JOIN ".DB_PREFIX."tax_classes ON (".DB_PREFIX."tax_classes.class_id = ".DB_PREFIX."products.tax_class_id)	
				WHERE oid='".$order->oid."'
			");
			
			//buid orders content XML
			while ($db->moveNext())
			{
				//check if cart has any product which is not allowed purhase using google checkout
				if ($db->col["product_is_google_co"] == "No") $this->allow_checkout = false;
				$options = trim($db->col["options"]) != "" ? ("\nOptions: ".$db->col["options"]."\n ") : "";
				$xml_cart .= 
					'<item>'.
						'<item-name>'.htmlspecialchars($db->col["title"]).'</item-name>'.
						'<item-description>'.htmlspecialchars(trim($db->col["options"])!=""?("[ Options: ".$db->col["options"])." ] ":"").htmlspecialchars($db->col["description"]).'</item-description>'.
						'<unit-price currency="'.$currency_code.'">'.htmlspecialchars(number_format($db->col["price"], 2, '.', '')).'</unit-price>'.
						'<quantity>'.htmlspecialchars(round($db->col["quantity"])).'</quantity>'.
						'<merchant-item-id>'.htmlspecialchars($db->col["product_id"]).'</merchant-item-id>';
				if ($db->col["digital_product"] == "Yes")
				{
					$download_url = $settings["GlobalHttpUrl"]."/download.php?a=".$order->oid."&b=".$db->col["digital_product_key"];
					$xml_cart .=
						'<digital-content><url>'.htmlspecialchars($download_url).'</url></digital-content>';
				}
				if ($db->col["product_taxable"] == "Yes")
				{
					if ($db->col["product_tax_rate"] > 0)
					{
						//global world-area tax on product level
						$xml_cart .= 
							'<tax-table-selector>'.htmlspecialchars($db->col["product_id"]." exclusive tax").'</tax-table-selector>';
						
						$alternate_tax_table = 
							'<alternate-tax-table standalone="true" name="'.htmlspecialchars($db->col["product_id"]." exclusive tax").'">'.
								'<alternate-tax-rules>'.
									'<alternate-tax-rule>'.
										'<rate>'.($db->col["tax_rate"]/100).'</rate>'.
											'<tax-area>'.
												'<world-area/>'.
											'</tax-area>'.
									'</alternate-tax-rule>'.
								'</alternate-tax-rules>'.
							'</alternate-tax-table>';
						$alternate_tax_tables[] = $alternate_tax_table;	
					}
					else
					{
						//tax based on tax class settings in admin area
						$xml_cart .= 
							'<tax-table-selector>'.htmlspecialchars($db->col["class_name"]).'</tax-table-selector>';
					}
				}
				else
				{
					//not taxable products
					$xml_cart .= 
						'<tax-table-selector>tax_exempt</tax-table-selector>';
				}
				
				//additional information
				$xml_cart .= 
						'<merchant-private-item-data><item-note>'.
							htmlspecialchars("Product ID: ".$db->col["product_id"].(trim($db->col["options"])!=""?("\nOptions: ".$db->col["options"]):"")).
						'</item-note></merchant-private-item-data>'.						
					'</item>';
			}
			
			//add additional items
			if ($order_data["discount_amount"] > 0)
			{
				$xml_cart .= 
					'<item>'.
						'<item-name>'.htmlspecialchars("Discount").'</item-name>'.
						'<item-description>'.htmlspecialchars("Shopping Cart Discount").'</item-description>'.
						'<unit-price currency="'.$currency_code.'">-'.htmlspecialchars(number_format($order_data["discount_amount"], 2, '.', '')).'</unit-price>'.
						'<quantity>1</quantity>'.
						'<merchant-private-item-data><item-note>'.htmlspecialchars("Discount").'</item-note></merchant-private-item-data>'.
					'</item>';
			}
			
			if ($order_data["promo_discount_amount"] > 0)
			{
				$xml_cart .= 
					'<item>'.
						'<item-name>'.htmlspecialchars("Promo Discount").'</item-name>'.
						'<item-description>'.htmlspecialchars("Shopping Cart Promo Discount").'</item-description>'.
						'<unit-price currency="'.$currency_code.'">-'.htmlspecialchars(number_format($order_data["promo_discount_amount"], 2, '.', '')).'</unit-price>'.
						'<quantity>1</quantity>'.
						'<merchant-private-item-data><item-note>'.htmlspecialchars("Promo Discount").'</item-note></merchant-private-item-data>'.
					'</item>';
			}
			
			if ($order_data["buysafe_wants_bond"] == "true" && $order_data["buysafe_bond_amount"] > 0)
			{
				$xml_cart .= 
					'<item>'.
						'<item-name>buySafe</item-name>'.
						'<item-description>'.("buySafe").'</item-description>'.
						'<unit-price currency="'.$currency_code.'">-'.htmlspecialchars(number_format($order_data["buysafe_bond_amount"], 2, '.', '')).'</unit-price>'.
						'<quantity>1</quantity>'.
						'<tax-table-selector>tax_exempt</tax-table-selector>';
						'<merchant-private-item-data><item-note>'.htmlspecialchars("buySafe").'</item-note></merchant-private-item-data>'.
					'</item>';
			}
			
			$xml_cart .= '</items>'.
				'<merchant-private-data><merchant-note>'.htmlspecialchars($order_data["oid"].":".$order_data["order_num"]).'</merchant-note></merchant-private-data>'.
				'</shopping-cart>';
			
			$continue_shopping = $settings["googlecheckout_continue_shopping_link"]!=""?$settings["googlecheckout_continue_shopping_link"]:$url_http.'p=home';
			$request_buyer_phone = $settings["googlecheckout_request_buyer_phone_number"]=="Yes"?"true":"false";					

			$xml_cart.=
				'<checkout-flow-support>'.
					'<merchant-checkout-flow-support>'.
						'<merchant-calculations><merchant-calculations-url>'.htmlspecialchars($settings["GlobalHttpsUrl"]."/content/engine/payment/google/callback.php?pcsid=".session_id().'&_pcod='.$order->getSecurityId()).'</merchant-calculations-url></merchant-calculations>'.
						'<shipping-methods>'.implode($shipping_methods).'</shipping-methods>'.
						'<tax-tables merchant-calculated="true"><alternate-tax-tables>'.implode($alternate_tax_tables).'</alternate-tax-tables></tax-tables>'.
						'<edit-cart-url>'.htmlspecialchars($url_dynamic.'p=cart').'</edit-cart-url>'.
						'<platform-id>755747362435048</platform-id>'.
						'<continue-shopping-url>'.htmlspecialchars($continue_shopping).'</continue-shopping-url>'.
						'<request-buyer-phone-number>'.htmlspecialchars($request_buyer_phone).'</request-buyer-phone-number>'.
					'</merchant-checkout-flow-support>'.
  				'</checkout-flow-support>'.
			'</checkout-shopping-cart>';
			

			//echo $xml_cart;

			//die();
			$merchant_key = $settings[$this->id."_Merchant_Key"];
			$signature = $this->CalcHmacSha1($xml_cart, $merchant_key);			
			$pf[0]=base64_encode($signature);
			$pf[1]=base64_encode($xml_cart);							
			return $pf;
		}
		
		function getPostUrl()
		{
			return $this->post_url;
		}
		
		function isTestMode()
		{
			global $settings;
			if ($settings[$this->id."_mode"] != "Live")
			{
				$this->testMode = true;
				$this->post_url = "https://sandbox.google.com/checkout/api/checkout/v2/checkout/Merchant/".$settings[$this->id."_Merchant_ID"];				
			}
			else
			{
				$this->testMode = false;								  
				$this->post_url = "https://checkout.google.com/api/checkout/v2/checkout/Merchant/".$settings[$this->id."_Merchant_ID"];
			}
			
			return $this->testMode;
		}
		
		function getValidatorJS()
		{
			return "";
		}

		//For processing refund and cancellation in admin panel
		function getVarStatus($custom1="", $custom2="", $custom3="", $order_status="", $payment_status="")
		{
			global $setting;
			$var_status = array("1"=>false, "2"=>false, "3"=>false);
			$financial_state = explode("-", $custom3);
			$message = "";
			switch ($financial_state[1])
			{
				case "CHARGED":
				{
					if($payment_status == "Received")
						$message .= "<div style='padding-top:7px;' OnClick=\"window.open('content/engine/payment/google/googlerefund.php?oid=".$_GET['oid']."','PopupWind','titlebar=no, toolbar=no, menubar=no, status=no, directories=no, resizable=no, scrollbars=no, top=200, left=400, width=320, height=240')\"><a href=\"#\">Refund Transaction</a></div>";
					if($payment_status == "Refunded")
						$message .= "<div style='padding-top:7px;' OnClick=\"window.open('content/engine/payment/google/googlecancel.php?oid=".$_GET['oid']."','PopupWind','titlebar=no, toolbar=no, menubar=no, status=no, directories=no, resizable=no, scrollbars=no, top=200, left=400, width=320, height=240')\"><a href=\"#\">Cancel Transaction</a></div>";
					break;
				}
				case "CHARGEABLE":
				{
					if($payment_status == "Pending")
						$message .= "<div style='padding-top:7px;' OnClick=\"window.open('content/engine/payment/google/googlecharge.php?oid=".$_GET['oid']."','PopupWind','titlebar=no, toolbar=no, menubar=no, status=no, directories=no, resizable=no, scrollbars=no, top=200, left=400, width=320, height=240')\"><a href=\"#\">Charge Order</a></div>";
						$message .= "<div style='padding-top:7px;' OnClick=\"window.open('content/engine/payment/google/googlecancel.php?oid=".$_GET['oid']."','PopupWind','titlebar=no, toolbar=no, menubar=no, status=no, directories=no, resizable=no, scrollbars=no, top=200, left=400, width=320, height=240')\"><a href=\"#\">Cancel Transaction</a></div>";
					break;
				}
				case "PAYMENT_DECLINED":
				{
					if($payment_status == "Pending")
						$message .= "<div style='padding-top:7px;' OnClick=\"window.open('content/engine/payment/google/googlecancel.php?oid=".$_GET['oid']."','PopupWind','titlebar=no, toolbar=no, menubar=no, status=no, directories=no, resizable=no, scrollbars=no, top=200, left=400, width=320, height=240')\"><a href=\"#\">Cancel Transaction</a></div>";
					break;
				}
			}

			$var_status[1] = array(
				"message"=>$message,
				"executable"=>false,
				"link_caption"=>""
			);

			return $var_status;
		}
		
		function process($db, $user, $order, $post_form)
		{
			extract($_POST);
			
			$fulfillment_state = isset($fulfillment_state)?$fulfillment_state:"ERROR";
			$financial_state = isset($financial_state)?$financial_state:"ERROR";
			$google_order_number = isset($google_order_number)?$google_order_number:"ERROR";
			$total_charge_amount = isset($total_charge_amount)?$total_charge_amount:"0.00";
			$currency = isset($currency)?$currency:"ERROR";
			
			if ($fulfillment_state == "NEW" && $financial_state == "CHARGED")
			{
				$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE custom1='".$db->escape($google_order_number)."'");
				if ($db->moveNext())
				{
					$custom1 = $db->col["custom1"];
					$custom2 = $db->col["custom2"]; 
					$custom3 = $db->col["custom3"]; 
					$security_id = $db->col["security_id"];
					$data = "Total charged amount ('".$currency."'): ".$total_charge_amount."\n Google staus for the order: ".$fulfillment_state."-".$financial_state;
					$this->createTransaction($db, $user, $order, $data, "", $custom1, $custom2, $custom3, $security_id);
					$this->is_error = false;
					$this->error_message = "";
				}
				else
				{
					$this->error_message = "Incorrect Google Order Number";
					$this->is_error = true;
				}
			}
			else
			{
				$this->error_message = "Wrong Parameters";
				$this->is_error = true;
			}

			if ($this->is_error)
			{
				$this->storeTransaction($db, $user, $order, $_POST, '', false);
			}

			echo $this->error_message;
			return !$this->is_error;
		}
		
		function processCustomAdvance($db, $custom_id, $order_id, $post_data)
		{
			global $settings;
			$this->is_error = false;
			//get default currency code
			$db->query("SELECT code FROM ".DB_PREFIX."currencies WHERE is_default='Yes'");
			$currency_code = $db->moveNext() ? $db->col["code"] : "USD";
			
			switch ($custom_id)
			{
				// Refund Order
				case "1" : 	
				{
					$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order_id."'");
					if ($db->moveNext())
					{
						$order_data = $db->col;
						//build cart xml
						$xml_post = '<?xml version="1.0" encoding="UTF-8"?><refund-order xmlns="http://checkout.google.com/schema/2" google-order-number="'.$order_data["custom1"].'">';
						$xml_post .= 
								'<amount currency="'.htmlspecialchars($currency_code).'">'.htmlspecialchars(number_format($post_data["refund_amount"], 2, ".", "")).'</amount>'.
								'<comment> Merchant wants to refund the order. </comment>'.
    							'<reason> '.htmlspecialchars($post_data["refund_reason"]).'</reason>'.
								'</refund-order>';
						$google_xml = $this->processRequest($xml_post);

						$xmlParser = new XMLParser();
						$parsed_result = $xmlParser->parse($google_xml);
						$a = array_keys($parsed_result);
						$recognized_request = $a[0];
						
						if ($recognized_request == "request-received")
						{
							$this->is_error = false;
							$this->error_message = "";
						}
						elseif ($recognized_request == "error")
						{
							$this->error_message = $parsed_result["error"][0]["error-message"][0];
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
						else
						{ 
							$this->error_message = "Invalid request for Google order!";	
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
					}
					break;
				}
				// Cancel Order
				case "2" :
				{
					$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order_id."'");
					if ($db->moveNext())
					{
						$order_data = $db->col;
						//build cart xml
						$xml_post = '<?xml version="1.0" encoding="UTF-8"?><cancel-order xmlns="http://checkout.google.com/schema/2" google-order-number="'.$order_data["custom1"].'">';
						$xml_post .= 
								'<comment> Merchant wants to cancel the order. </comment>'.
    							'<reason> Merchant wants to cancel the order. </reason>'.
								'</cancel-order>';
						$google_xml = $this->processRequest($xml_post);

						$xmlParser = new XMLParser();
						$parsed_result = $xmlParser->parse($google_xml);
						$a = array_keys($parsed_result);
						$recognized_request = $a[0];
						
						if ($recognized_request == "request-received")
						{
							$this->is_error = false;
							$this->error_message = "";
						}
						elseif ($recognized_request == "error")
						{
							$this->error_message = $parsed_result["error"][0]["error-message"][0];
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
						else
						{ 
							$this->error_message = "Invalid request for Google order!";	
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
					}
					break;
				}
				
				// Charge Order
				case "3" :
				{
					$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order_id."'");
					if ($db->moveNext())
					{
						$order_data = $db->col;
						//build cart xml
						$xml_post = '<?xml version="1.0" encoding="UTF-8"?>'.
						'<charge-order xmlns="http://checkout.google.com/schema/2" google-order-number="'.$order_data["custom1"].'"></charge-order>';
						
						$google_xml = $this->processRequest($xml_post);

						$xmlParser = new XMLParser();
						$parsed_result = $xmlParser->parse($google_xml);
						$a = array_keys($parsed_result);
						$recognized_request = $a[0];
						
						if ($recognized_request == "request-received")
						{
							$this->is_error = false;
							$this->error_message = "";
						}
						elseif ($recognized_request == "error")
						{
							$this->error_message = $parsed_result["error"][0]["error-message"][0];
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
						else
						{ 
							$this->error_message = "Invalid request for Google order!";	
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
					}
					break;
				}
				// Deliver Order status change
				case "4" : 
				{
					$db->query("SELECT * FROM ".DB_PREFIX."orders WHERE oid='".$order_id."'");
					if ($db->moveNext())
					{
						$order_data = $db->col;
						//build cart xml
						$xml_post = '<?xml version="1.0" encoding="UTF-8"?>'.
						'<deliver-order xmlns="http://checkout.google.com/schema/2" google-order-number="'.$order_data["custom1"].'">';
						$xml_post .= 
								'<tracking-data> 
									<carrier>'.$post_data["carrier"].'</carrier>
        							<tracking-number>'.$post_data["tracking_id"].'</tracking-number> 
        						</tracking-data>'.
    							'<send-email> true </send-email>'.
							'</deliver-order>';
						
						$google_xml = $this->processRequest($xml_post);

						$xmlParser = new XMLParser();
						$parsed_result = $xmlParser->parse($google_xml);
						$a = array_keys($parsed_result);
						$recognized_request = $a[0];
						
						if ($recognized_request == "request-received")
						{
							$this->is_error = false;
							$this->error_message = "";
						}
						elseif ($recognized_request == "error")
						{
							$this->error_message = $parsed_result["error"][0]["error-message"][0];
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
						else
						{ 
							$this->error_message = "Invalid request for Google order!";	
							$this->is_error = true; 
							$this->log($this->error_message."\n".$google_xml);
						}
					}
					break;
				}
				default : 
				{
					$this->is_error = true;
					$this->error_message = "Incorrect action ";
					
					break;
				}
			}
			return !$this->is_error;
		}

		function processRequest($xml_post)
		{
			global $settings;

			//send request
			if($settings["googlecheckout_mode"] == "Test")
			{
				$c = curl_init("https://sandbox.google.com/checkout/api/checkout/v2/request/Merchant/".$settings["googlecheckout_Merchant_ID"]);
			}
			else
			{
				$c = curl_init("https://checkout.google.com/api/checkout/v2/request/Merchant/".$settings["googlecheckout_Merchant_ID"]);
			}
			if ($settings["ProxyAvailable"] == "YES")
			{
				//curl_setopt($c, CURLOPT_VERBOSE, 1);
				if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
				{
					curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
				}
				curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
				if ($settings["ProxyRequiresAuthorization"] == "YES")
				{
					curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
				}

				curl_setopt($c, CURLOPT_TIMEOUT, 120);
			}

			//prepare header with auth info
			$header = array(
				"Authorization: Basic ".base64_encode($settings["googlecheckout_Merchant_ID"].":".$settings["googlecheckout_Merchant_Key"]),
				"Content-Type: application/xml",
				"Accept: application/xml"
			);
			curl_setopt($c, CURLOPT_HTTPHEADER, $header);
			curl_setopt($c, CURLOPT_POSTFIELDS, $xml_post);
			curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
				
			curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
			curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
			$charge_result = curl_exec($c);
			return $charge_result;
		
		}
		
		function CalcHmacSha1($data, $merchant_key) 
		{
			$key = $merchant_key;
			$blocksize = 64;
			$hashfunc = 'sha1';
			if (strlen($key) > $blocksize)
			{
				$key = pack('H*', $hashfunc($key));
			}
			$key = str_pad($key, $blocksize, chr(0x00));
			$ipad = str_repeat(chr(0x36), $blocksize);
			$opad = str_repeat(chr(0x5c), $blocksize);
			$hmac = pack('H*', $hashfunc(($key^$opad).pack('H*', $hashfunc(($key^$ipad).$data))));
		    return $hmac;
		}
	}
