<?php
/**
 * User order (archived)
 */

if (!defined("ENV")) exit();

if ($user->auth_ok)
{
	$order_id = isset($_REQUEST["order_id"]) ? intval($_REQUEST["order_id"]) : 0;
	$order_history = ORDER::getById($db, $settings, $user, $order_id);

	if ($order_history)
	{
		$order_history->getOrderData();
		$order_history->getOrderItems();

		$history_order_items = array(); //$user->getOrderItems($order_id);
		$history_user_data = $user->getUserData();

		if ($order_history->getShippingTrackingNumber() != '')
		{
			if ($order_history->getShippingTrackingNumberType() == 'UPS')
			{
				require_once("content/engine/engine_ups.php");
				$ups = new UPS();
				$ups->setUserName($settings["ShippingUPSUserID"]);
				$ups->setPass($settings["ShippingUPSUserPassword"]);
				$ups->setAccessKey($settings["ShippingUPSAccessKey"]);
				$ups->setTrackingServer($settings["ShippingUPSTrackingUrl"]);
				$info=$ups->getTrackingInfo($order_history->getShippingTrackingNumber());
				view()->assign("tracking_info", $info);
			}
			else if ($order_history->getShippingTrackingNumberType() == 'USPS')
			{
				require_once("content/engine/engine_usps.php");
				$usps = new USPS();
				$usps->setUserName($settings["ShippingUSPSUserID"]);
				$usps->setPass($settings["ShippingUSPSUserPassword"]);
				$usps->setServer($settings["ShippingUSPSTrackingUrl"]);
				$result = $usps->track($order_history->getShippingTrackingNumber());
				if ($result)
				{
					view()->assign("tracking_info", $result);
				}
			}
		}

		$viewModel = new View_OrderViewModel($settings, $msg);
		$viewModel->build($order_history);

		// Check for Bongo order
		$orderData = $db->selectOne('SELECT * FROM '.DB_PREFIX.'orders WHERE oid='.intval($order_history->getId()), MYSQL_ASSOC);

		if ($orderData['payment_gateway_id'] == 'bongocheckout')
		{
			$viewModel->setBongoOrder(true);
			$viewModel->setBongoData(false);

			if (trim($orderData['custom2']) != '' && trim($orderData['custom3']) != '')
			{
				$bongoOrderData = @unserialize($orderData['custom2']);

				if ($bongoOrderData && is_array($bongoOrderData))
				{
					$viewModel->setBongoData($bongoOrderData);
				}
			}
		}
		else
		{
			$viewModel->setBongoOrder(false);
		}

		view()->assign("history_order_data", $viewModel);
		view()->assign("history_user_data", $history_user_data);
		view()->assign("history_order_items", $history_order_items);
		view()->assign("body", "templates/pages/account/order.html");
	}
	else
	{
		header("Location: ".$settings["GlobalHttpUrl"]."/index.php?p=404");
		_session_write_close();
		die();
	}
}
else
{
	view()->assign("body", "templates/account/auth-error.html");
}
