<?php
/**
 * Handle user signup
 */

	if (!defined("ENV")) exit();
	
	//no reasons to show register page when there are no accounts
	if ($settings["AllowCreateAccount"] == "No")
	{
		header("Location: ".$url_http."p=cart");
		die();
	}
	
	//assign actions IDs
	view()->assign("USER_SIGNUP", USER_SIGNUP);
	
	//country / state data
	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	view()->assign("countries_states", json_encode($regions->getCountriesStatesForSite()));

	//check shipping
	$sc = getShippingCountries($db);
	if (is_array($sc))
	{
		view()->assign("ship2countries", in_array(0, $sc) ? "all" : $sc);
	}
	else
	{
		view()->assign("ship2countries", "all");
	}
	
	//check is there registration error on wrong attempt
	view()->assign("is_user_errors", ($ua=USER_SIGNUP) && ($user->is_error)?"yes":"no");
	
	//check captcha
	
	if (($ua=USER_SIGNUP) && ($user->is_error))
	{
		view()->assign("userErrors", $user->errors);
	}
	
	//check / create form data array 
	$form = isset($_POST["form"]) ? $_POST["form"] : array("email_newsletters"=>"No", "email_updates"=>"Yes");
	$form = is_array($form) ? $form : array("email_newsletters"=>"No", "email_updates"=>"Yes");
	view()->assign("form", $form);
	
	//assign custom fields
	$customFieldsData = isset($_POST["custom_field"]) ? $_POST["custom_field"] : array();
	view()->assign("cf_billing", $cf_billing = $customFields->getCustomFields("billing", $customFieldsData));
	view()->assign("cf_signup", $cf_signup = $customFields->getCustomFields("signup", $customFieldsData));
	view()->assign("cf_account", $cf_account = $customFields->getCustomFields("account", $customFieldsData));
	
	//add captcha
	if ($settings['captchaMethod'] != 'None')
	{
		require_once('content/vendors/recaptcha/recaptchalib.php');
		view()->assign('captcha', recaptcha_get_html($settings['captchaReCaptchaPublicKey'], null, isSslMode()));
	}

	//finally, join template
	view()->assign("body", "templates/pages/account/signup.html");

	$meta_keywords = trim($settings['register_meta_keywords']) != '' ? $settings['register_meta_keywords'] : $meta_keywords;
	$meta_title = trim($settings['register_page_title']) != '' ? $settings['register_page_title'] : $meta_title;
	$meta_description = trim($settings['register_meta_description']) != '' ? $settings['register_meta_description'] : $meta_description;