<?php

class core_Form_InterCasePackField extends core_Form_Field
{
	protected $interPackValue;
	protected $casePackValue;

	protected $interPackEnabled = false;
	protected $casePackEnabled = false;

	public function getInterPackValue()
	{
		return $this->interPackValue;
	}
	public function setInterPackValue($interPackValue)
	{
		$this->interPackValue = $interPackValue;
	}

	public function getCasePackValue()
	{
		return $this->casePackValue;
	}
	public function setCasePackValue($casePackValue)
	{
		$this->casePackValue = $casePackValue;
	}

	public function isInterPackEnabled()
	{
		return $this->interPackEnabled;
	}
	public function setInterPackEnabled($interPackEnabled)
	{
		$this->interPackEnabled = $interPackEnabled;
	}

	public function isCasePackEnabled()
	{
		return $this->casePackEnabled;
	}
	public function setCasePackEnabled($casePackEnabled)
	{
		$this->casePackEnabled = $casePackEnabled;
	}

	public function toArray()
	{
		$arr = parent::toArray();

		$arr['interPackValue'] = $this->getInterPackValue();
		$arr['interPackEnabled'] = $this->isInterPackEnabled();
		
		$arr['casePackValue'] = $this->getCasePackValue();
		$arr['casePackEnabled'] = $this->isCasePackEnabled();

		return $arr;
	}

	public function getType()
	{
		return 'inter-case-pack';
	}

	public static function createFromFormBuilder($name, $options = array())
	{
		core_Form_Field::setDefaults($options);

		$defaults = array(
				'interPackEnabled' => false,
				'casePackEnabled' => false,
				'interPackValue' => null,
				'casePackValue' => null,
		);

		$options = array_merge($defaults, $options);

		$field = new core_Form_InterCasePackField(
			$name, $options['label'], $options['value'], $options['required'], 
			$options['lockable'], $options['lockName'], $options['tooltip'], $options['note'], 
			$options['attr'], $options['wrapperClass'], $options['readonly']
		);

		$field->setCasePackValue($options['casePackValue']);
		$field->setCasePackEnabled($options['casePackEnabled']);

		$field->setInterPackValue($options['interPackValue']);
		$field->setInterPackEnabled($options['interPackEnabled']);
	
		return $field;
	}
}