<?php

class core_Form_MoneyTextField extends core_Form_TextField
{
	protected $emptyValue;

	public function getType()
	{
		return 'money';
	}

	public function __construct($name, $label, $value = null, $required = false, $lockable = false, $lockName = null, $tooltip = null, $note = null, $attr = array(), $wrapperClass = '', $emptyValue = null, $readonly = false)
	{
		parent::__construct($name, $label, $value, $required, $lockable, $lockName, $tooltip, $note, $attr, $wrapperClass, $readonly);

		$this->emptyValue = $emptyValue;
	}

	public function toArray()
	{
		$ret = parent::toArray();

		$ret['emptyValue'] = $this->emptyValue;

		return $ret;
	}

	public static function createFromFormBuilder($name, &$options = array())
	{
		core_Form_Field::setDefaults($options);

		if (!isset($options['emptyValue'])) $options['emptyValue'] = null;

		return new core_Form_MoneyTextField(
			$name, $options['label'], $options['value'], $options['required'], 
			$options['lockable'], $options['lockName'], $options['tooltip'], $options['note'],
			$options['attr'], $options['wrapperClass'], $options['emptyValue'], $options['readonly']
		);
	}
}