function showHideProxy()
{
	if ($('#div_proxy1').is(':visible'))
	{
		$('#div_proxy1').slideUp();
		$('#div_proxy2').slideDown();
		$('#proxy_used').val(1);
	}
	else
	{
		$('#div_proxy2').slideUp();
		$('#div_proxy1').slideDown();
		$('#proxy_used').val(0);
	}
}

function isEmail(entry)
{
	var rex= /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,5})(\]?)$/;
	return rex.test(entry);
}

/**
 * Check license form
 * @param frm
 * @return bool
 */
function checkLicenseForm(frm)
{
	if (frm.elements["license_number"].value=="")
	{
		alert("Please enter license number!");
		frm.elements["license_number"].focus();
		return false;
	}
	return true;
}

/**
 * Check database form
 * @param frm
 * @return bool
 */
function checkDatabaseForm(frm)
{
	if (frm.elements["db_username"].value=="")
	{
		alert("Please enter database username");
		frm.elements["db_username"].focus();
		return false;
	}
	
	if (frm.elements["db_database"].value=="")
	{
		alert("Please enter database name, which will be used for your store");
		frm.elements["db_database"].focus();
		return false;
	}
	
	if (frm.elements["db_hostname"].value=="")
	{
		alert("Please enter database hostname");
		frm.elements["db_hostname"].focus();
		return false;
	}
	document.getElementById('div_button').style.display = 'none';
	document.getElementById('div_db_form').style.display = 'none';
	document.getElementById('div_message').style.display = 'block';
	return true;
}

/**
 * Check settings form
 * @param frm
 * @return bool
 */
function checkSettingsForm(frm)
{
	if (frm.elements["admin_name"].value=="")
	{
		alert("Please enter Adminmistrator Name");
		frm.elements["admin_name"].focus();
		return false;
	}
	
	if (frm.elements["admin_username"].value=="")
	{
		alert("Please enter Administrator Username (Login)");
		frm.elements["admin_username"].focus();
		return false;
	}
	
	if (frm.elements["admin_password"].value=="")
	{
		alert("Please enter Password");
		frm.elements["admin_password"].focus();
		return false;
	}
	
	if (frm.elements["admin_password"].value!=frm.elements["admin_password_confirmation"].value)
	{
		alert("Password and confirmation are not equal!");
		frm.elements["admin_password_confirmation"].focus();
		return false;
	}
	else
	{
		var pwd = frm.elements["admin_password"].value;
		if (pwd.length < 8)
		{
			alert("Password is too short. Minimal length is 8 characters.");
			frm.elements["admin_password"].focus();
			return false;
		}
	}
	
	if (!isEmail(frm.elements["admin_email"].value))
	{
		alert("Please enter valid email address");
		frm.elements["admin_email"].focus();
		return false;
	}	
	
	if (frm.elements["site_url_http"].value=="")
	{
		alert("Please enter HTTP URL");
		frm.elements["site_url_http"].focus();
		return false;
	}
	
	if (frm.elements["site_url_https"].value=="")
	{
		alert("Please enter HTTPS URL");
		frm.elements["site_url_https"].focus();
		return false;
	}
	
	if (frm.elements["site_url_https"].value=="")
	{
		alert("Please enter server path");
		frm.elements["site_url_https"].focus();
		return false;
	}
	return true;
}

/**
 * Password strength
 * @param password
 * @return int
 */
function pwdStrengthPoints(password)
{
	var points   = 0;
	if (password.length >= 8) points++; // 1 point for length over 6
	if ((password.match(/[a-z]/)) && (password.match(/[A-Z]/))) points++; // 1 lower & uppercase characters
	if (password.match(/\d+/)) points++; // 1 point for a number
	if (password.match(/.[!,@,#,$,%,^,&,*,?,_,~,-,(,)]/)) points++; // 1 point for special character
	if (password.length > 12) points++; // 1 point for length over 12
	if (points > 4) points = 4;
	return points;
}

/**
 * Check/show password strength
 * @param password
 * @return
 */
function pwdStrength(password)
{
	var txt = "Password has to be atleast 8 characters long, do not include common words or names, and combine uppercase letters, lowercase letters, numbers.";

	var state = new Array();
	state[0] = 'Weakest';
	state[1] = 'Weak';
	state[2] = 'Improving';
	state[3] = 'Strong';
	state[4] = 'Strongest';
	
	var color = new Array();
	color[0] = '#ff5100';
	color[1] = '#ffa600';
	color[2] = '#fede00';
	color[3] = '#ecea00';
	color[4] = '#bdf800';
	
	var points = pwdStrengthPoints(password);

    document.getElementById("pwdDescription").innerHTML = 
    	'<div style="padding-top:5px;">' + 
    		'<div style="float:left;height:18px;border:0px solid #dddddd;"><div style="width:218px;">' +
    			'<div style="width:125px;padding:0px;float:left;">' +
    				'<div style="width:' + points * 30 + 'px;float:left;height:14px;background-color:' + color[points] + ';"></div>' + 
    				'<div style="width:' + (120 - points * 30) + 'px;float:left;height:14px;background-color:#f0f0f0;"></div>' + 
    			'</div>' + 
    			'<div style="width:50px;float:left;height:14px;padding-left:2px"><b>' + state[points] + '</b></div>' + 
    		'</div></div>' +
    		'<div style="clear:both;padding-top:2px;">' + 
    		txt + 
    		'</div>' +
    	'</div>'
    ;
}